ASMB,A,L,B,T ** BCS PREPARE CONTROL SYSTEM ** 
* 
      ORG 1774B 
* 
**************************************************
* 
* PREPARE CONTROL SYSTEM  -  P C S
* 
**************************************************
* 
* THE PREPARE CONTROL SYSTEM PROGRAM IS 
*  DESIGNED TO: 
* 
*  1. LOAD THE RELOCATABLE OBJECT PRO-
*      GRAMS COMPRISING THE MODULES OF
*      BCS - AND USER OR APPLICATIONS 
*      ROUTINES.
* 
*  2. CREATE AN OPERATING UNIT OF IOC,
*      EQUIPMENT DRIVERS, THE RELOCA- 
*      TABLE LOADER AND THE INTERRUPT 
*      LOCATIONS. 
* 
*  3. PRODUCE AN ABSOLUTE VERSION OF
*      BCS WHICH CAN BE LOADED BY THE 
*      ABSOLUTE BINARY LOADER.
* 
* 
* 
INPT  DEF TTY.I       ADDRESS OF INPUT SECTION
LIST  DEF TTY.O    ADDRESS OF LIST DEVICE DRIVER
PUNCH DEF TTY.O    ADDRESS OF PUNCH DEVICE DRIVER 
KBRD  DEF TTY.K    ADDRESS OF KEYBOARD DRIVER 
* 
PCS   JMP *+1,I   -STARTING POINT FOR PCS-
      DEF PCS1      INITIALIZE FOR I/O. 
* 
* 
* 
* CONTROL IS RETURNED TO THIS SECTION FROM THE
* LOADER AFTER EACH PROGRAM IS LOADED.
* 
LSEQ  LDA XIOC     IF PROGRAM 
      CPA NAM       JUST
      RSS           LOADED
      JMP LS1       IS
      LDA XIOC+1    NAMED 
      CPA NAM+1    -IOC-, 
      RSS           THEN
      JMP LS1       GO
      LDA NAM+2     TO
      AND UPCM
      CPA XIOC+2    GET 
      JMP *+2,I     EQT, SQT PARAMETERS.
      RSS          NOT IOC, FORCE A SKIP. 
* 
      DEF STEQT    ADDRESS OF SET-EQT SECTION 
* 
LS1   LDA XLDR     IF PROGRAM 
      CPA NAM       JUST
      RSS           LOADED
      JMP LS2       IS
      LDA XLDR+1    NAMED 
      CPA NAM+1     -LOADR-,
      RSS           THEN
      JMP LS2       GO
      LDA NAM+2     TO
      AND UPCM
      CPA XLDR+2    COMPLETE
      JMP INTR      PCS PROCESSING
* 
LS2   JSB SPACE 
      LDA ML5      OUTPUT MESSAGE 
      LDB ML5+1    - * LOAD - 
      JSB LIST,I
* 
      HLT 0        HALT TO READY NEXT PROGRAM LOAD. 
* 
      JMP LDRIN    GO TO LOAD NEXT PROGRAM
* 
* 
* 
*                  RETURN FROM INTERRUPT AND
*                   FINAL LINKAGE SET-UP. 
LS3   JSB LSTI     INITIALIZE LST PROCESSOR.
      JSB LSTP     SET LST ENTRY ADDRESSES
      JMP LS4      END OF LST - 
      LDA LST4,I   GET WORD 4 
      SZA          IF WORD 4 = 0, THEN ENTRY
      JMP LS3+1     IS UNDEFINED EXT. 
      JSB SPACE 
      LDA ML17     PRINT MESSAGE - UNDEFINED
      LDB ML17+1    SYMBOL- 
      JSB LIST,I
      CLA          PRINT ALL
      JSB EPL       UNDEFINED SYMBOLS 
      HLT 0 
* 
* APPEND ALL UNDEFINED EXTERNALS SYMBOLS TO THE 
*  BCS LOADER  LST.  THE ENTRY POINT ADDRESS
*  WORD OF EACH UNDEFINED EXT ENTRY IS SET = 77777
*  AFTER PROCESSING.
* 
LS5   JSB LSTI     INITIALIZE LST PROCESSOR 
      JSB LSTP     SET LST ENTRY ADDRESSES
      JMP LS4      -END OF LST IN PCS LOADER SECTION
      LDA LST4,I   GET ENTRY POINT ADDR. WORD.
      SZA          IF WORD = 0, THEN ENTRY IS UN EXT
      JMP LS5+1     - DEFINED, LOOK AT NEXT ENTRY.
      LDA M32K     SET WORD 4 = 
      STA LST4,I     77777. 
      LDA LST1,I   MOVE WORDS CONTAINING SYMBOL 
      STA IRL       NAME
      LDA LST2,I     TO 
      STA IRL+1      -IRL- BLOCK. 
      LDA LST3,I
      STA IRL+2 
      LDA IRLA     (A) = ADDR. OF SYMBOL. 
      LDB LST5,I   (B) = LINK WORD ADDRESS. 
      JSB ADLST    ADD TO BCS LOADER LST. 
      JMP LS5      RESTART THRU PCS LST.
* 
M32K  OCT 77777 
* 
* 
**
LS4   CLA,INA      PRODUCE MEMORY 
      JSB EPL       MAP 
* 
      JSB SPACE    FORCE 4 BLANK
      JSB SPACE     LINES 
* 
      JMP PNCH     GO TO PUNCH BCS
* 
ML5   DEC 6 
      DEF *+1 
      ASC 3,* LOAD
* 
XIOC  ASC 2,IOC    NAME OF BCS -IOC-
      OCT 20000 
* 
XLDR  ASC 2,LOAD   NAME OF BCS -LOADR-
      OCT 51000 
* 
* 
* SUBROUTINE:  KBIN - KEYBOARD INPUT
* 
* CALLING SEQUENCE: (P)    JSB  KBIN
*                   (P+1)  -RETURN
* 
* ON RETURN, SUBROUTINE -BINIT- HAS BEEN CALLED 
*  TO INITIALIZE  FOR BUFFER SCANNING.
* 
* KBIN CALLS FOR MAXIMUM OF 72 CHARACTER INPUT
*  INTO PBUF.  THE NUMBER OF CHARACTERS INPUT 
*  IS SAVED IN WORD LABELLED -PCNT-.  (BINIT
*  USES BCNT IN INITIALIZING BUFFER SCAN.). 
* 
* SIMULATED END-OF-TAPE (ZERO CHARACTER COUNT)
*  IS CHECKED AFTER EACH INPUT TO TAKE CARE OF
*  POSSIBLE INPUT THROUGH TELETYPEWRITER READER.
*  IF END-OF-TAPE IS DETECTED (A= 0 ON RETURN), 
*  THE MESSAGE  -END OF TAPE- IS PRINTED FOLLOWED 
*  BY A MACHINE HALT.  ON RESTART, THE NEXT RECORD
*  IS INPUT BEFORE RETURNING TO THE CALLER. 
* 
* 
KBIN  NOP 
      LDA C72      INPUT STATEMENT
      LDB PBUF      FROM TTY
      JSB KBRD,I     KEYBOARD.
* 
      SZA          CHECK FOR POSSIBLE END-OF-TAPE 
      JMP KB1      -NO- 
      LDA EOTA     YES, OUTPUT MESSAGE
      LDB EOTA+1    -END OF TAPE- 
      JSB LIST,I
* 
      HLT 0         HALT - TO READY NEXT INPUT TAPE.
      JMP KBIN+1   - RE-INPUT - 
* 
KB1   CMA          SET CHARS + 1 NEGATIVE 
      STA PCNT      FOR -BINIT- ROUTINE 
* 
      JSB BINIT    INITIALIZE BUFFER SCAN 
      JMP KBIN,I   -EXIT TO CALLER- 
* 
C72   DEC 72
* 
* 
*SUBROUTINE: BINIT  - BUFFER SCAN INITIALIZATION
* 
* CALL:  (P)  JSB BINIT 
*        (P+1) -RETURN- (A) DESTROYED 
* 
* BINIT INITIALIZES BUFFER SCAN BY -GETC-.
* 
BINIT NOP          -ENTRY / EXIT POINT- 
      LDA PCNT     SET CHAR COUNT INPUT FOR 
      STA CHCT      USE AS AN INDEX IN -GETC- 
      LDA PBUF     INITIALIZE BUFFER ADDRESS
      STA CSAD
      LDA C525     INITIALIZE UPPER/LOWER CHAR. 
      STA F525      POSITION INDICATOR. 
      JMP BINIT,I  - EXIT-
* 
* SUBROUTINE: GETC  - GET CHARACTER FROM BUFFER 
* 
* CALL:   (P)      JSB GETC 
*         (P+1)    -END OF STATEMENT RETURN-
*         (P+2)    -RETURN, (A) = CHARACTER.
* 
* 
GETC  NOP 
      ISZ CHCT     INDEX CHAR. COUNTER. IF END-OF-
      RSS 
      JMP GETC,I    BUFFER, EXIT TO P+1.
* 
      LDB F525     (B) = UPPER/LOWER POSITION FLAG. 
      LDA CSAD,I   GET WORD CONTAINING CURRENT CHAR.
      SSB,RSS      IF FLAG SAYS UPPER (SIGN = 0), 
      ALF,ALF       ROTATE TO LOW A.
      AND M377     ISOLATE CHAR.
      SSB          IF LOWER CHAR., ADD 1 TO BUFFER
      ISZ CSAD      ADDRESS FOR NEXT CHAR.
      RBL          UPDATE CHAR. POSITION
      STB F525       FLAG.
      CPA M.40     IF CHAR. IS A BLANK (SPACE), 
      JMP GETC+1    IGNORE IT, GET NEXT CHAR. 
      ISZ GETC     ADJUST RETURN TO P+2 AND 
      JMP GETC,I    -EXIT-
* 
PCNT  OCT 0 
CHCT  OCT 0 
CSAD  OCT 0 
C525  OCT 52525 
F525  OCT 0 
*****************************************
* SUBROUTINE: CONVX - NUMERIC FIELD CONVERSION
* 
* CALLING SEQUENCE:  (B) = MAXIMUM FIELD LENGTH 
*       (P)      JSB  CONVX 
*       (P+1)   -ERROR RETURN- -*ERR PRINTED
*       (P+2)   -RETURN- (A) = RESULT, (B) = 0 IF 
*               END OF STATEMENT REACHED. 
* 
* CONVERSION IS FROM ASCII (OCTAL NUMBERS) TO BINARY. 
*  - NON NUMERIC CHARACTERS, INCLUDING 8 AND 9 ARE
*    ILLEGAL.  FIELDS ARE TERMINATED BY A COMMA OR
*     MAXIMUM FIELD LENGTH IN CALL. IF MAX. LENGTH
*     IS NOT FOLLOWED BY A COMMA OR END-OF-STATEMENT, 
*      THE ERROR RETURN IS MADE.
* 
CONVX NOP 
      CMB,INB      SET MAX. FIELD LENGTH NEGATIVE 
      STB MXN.      FOR INDEX.
      CLA          INITIALIZE RESULT =
      STA RSLT      ZERO. 
* 
* FOLLOWING SECTION CONVERTS THE CHARACTERS 
* AFTER CHECKING FOR LEGALITY.
* 
CON1  JSB GETC     GET NEXT CHARACTER 
      JMP CON2     -END OF STATEMENT -
      CPA COMMA     IF CHAR. = A -,-
      JMP CONX      THEN EXIT.
* 
      ADA CM60B    SUBTRACT 60(8) FROM
      SSA           CHAR. IF RESULT NEGATIVE, 
      JMP CON3       CHAR. NOT NUMERIC, ERROR---
      STA CNBR     SAVE CURRENT CHAR. 
      ADA CM10     SUBTRACT 10(8) TO CHECK FOR
      SSA,RSS       RANGE 60-67(8). IF POSITIVE,
      JMP CON3      NO, ERROR.
* 
      LDA RSLT     MULTIPLY PARTIAL RESUT 
      ALF,RAR       BY 8, ADD 
      ADA CNBR       CURRENT NUMBER,
      STA RSLT        RESTORE RESULT. 
      ISZ MXN.     INDEX MAX. FIELD LENGTH COUNTER. 
      JMP CON1      MORE TO CONVERT.
* 
      JSB GETC     END OF FIELD. GET NEXT CHAR. 
      JMP CON2     -END OF STATEMENT- 
      CPA COMMA     IF NEXT CHAR. IS A COMMA, 
      JMP CONX      EXIT. 
      JMP CON3     ERROR, NOT FOLLOWED BY A COMMA.
* 
CON2  CLB          CLEAR B TO SAY END-OF-STATEMENT. 
* 
CONX  LDA RSLT     SET (A) = RESULT OF CONVERSION.
      ISZ CONVX    INDEX RETURN TO P+2, AND 
      JMP CONVX,I   EXIT. 
* -ERROR
*    SECTION
CON3  JSB ERRPT 
      JMP CONVX,I    TO P+1.
* 
* 
MXN.  OCT 0 
RSLT  OCT 0 
CNBR  OCT 0 
CM10  OCT -10 
CM60B OCT -60 
* 
* 
* SUBROUTINE: BASC  - BINARY TO ASCII (OCTAL) 
* 
* CALLING SEQUENCE: (A) = BINARY NUMBER < 77(8).
* 
*                   (P)    JSB BASC 
*                   (P+1)  -RETURN- 
* 
*    (A) ON RETURN CONTAINS THE 2 ASCII CHARACTERS
*      REPRESENTING THE BINARY NUMBER.
* 
BASC  NOP 
      STA BAST     SAVE NUMBER
      CLB          CLEAR COUNT REGISTER 
BAS1  LDA BAST     SUBTRACT  8
      ADA CM8      FROM NUMBER
      SSA          IF RESULT NEGATIVE,
      JMP BAS2      FINISHED. 
      STA BAST     STORE N,  N = NUMBER - 8.
      INB          COUNT SUBTRACTING. 
      ADA CM8      SUBTRACT 8 AGAIN.
      SZA          IF RESULT = ZERO 
      SSA,RSS       OR POSITIVE, CONTINUE 
      JMP BAS1      TO DIVIDE BY SUBTRACTING. 
* 
BAS2  LDA B        (B) = NUMBER OF SUBTRACT OPER- 
      IOR M.60      ATIONS. MAKE AN ASCII CHAR. 
      ALF,ALF        AND ROTATE TO UPPER POSITION.
      IOR M.60     MAKE REMAINDER AN
      IOR BAST      ASCII CHAR. IN LOWER POSITION 
      JMP BASC,I    AND EXIT. 
* 
BAST  OCT 0        HOLDS TEMPORARY RESULT 
CM8   DEC -8
* 
* 
* SECTION  * INTR * 
* 
* THIS SECTION CONSTRUCTS THE INSTRUCTIONS AND
*  ADDRESSES REQUIRED TO SET THE INTERRUPT SYSTEM 
*  PROCESSING FOR BCS AND ANY INDEPENDENT USER
*  OR APPLICATION SYSTEM MODULES. 
* 
* INPUT STATEMENTS OF THE FORM: A1,A2,ENTRY POINT NAME
*  ARE PROCESSED UNTIL THE STATEMENT  /E IS INPUT 
*  TO TERMINATE THE INTERRUPT SYSTEM SETUP. 
* 
*   A1 DESIGNATES THE INTERRUPT ADDRESS 
*   A2 DESIGNATES THE ADDRESS OF THE WORD USED TO 
*      HOLD THE 15-BIT ADDRESS OF:
*   ENTRY POINT NAME - DESIGNATES THE NAME OF THE 
*      INTERRUPT PROCESSOR. 
* 
* 
INTR  JSB SPACE 
      LDA ML10     OUTPUT MESSAGE 
      LDB ML10+1    * INTERRUPT LINKAGE? *
      JSB LIST,I
* 
      JSB SPACE 
      LDA HLT5     SET HLT 05 IN LOCATION 00005 
      STA 5         FOR POWER FAILURE INTERRUPT.
* 
      HLT 11B         TURN OFF READER.
* 
IR1   JSB KBIN     GET KEYBOARD INPUT 
      JSB GETC     GET FIRST CHAR.
      JMP IRE      ERROR - NULL STATEMENT.
      CPA SLASH    IF CHAR = /, 
      RSS           CHECK FOR * E * 
      JMP IR2      PROCESS STATEMENT
      JSB GETC     GET NEXT CHAR. 
      JMP IRE      ERROR - INCOMPLETE STATEMENT.
      CPA E        IF = E, GO TO
      JMP P.I       LINKING SECTION 
* 
IR2   JSB BINIT    RE-INITIALIZE BUFFER SCAN
      LDB C.02     MAX. 2 DIGITS FOR A1 
      JSB CONVX    CONVERT * A1 *.
      JMP IR1      ERROR RETURN 
      SZB          IF END-OF-STATEMENT
      SZA,RSS       OR A1 = 0, OUTPUT 
      JMP IRE       *ERR AND REPEAT 
* 
      STA IRL      SAVE  A1 
* 
      LDB C.06     REPEAT CONVERSION
      JSB CONVX     FOR  * A2 *.
      JMP IR1       - ERROR, NON-NUMERIC. 
      SZB,RSS      IF END-OF-STATEMENT AFTER A2,
      JMP IR6       GO TREAT AS ABSOLUTE INT. 
      SZA,RSS      IF A2 = 0 (AND NOT END-OF-INPUT) 
      JMP IRE       PRINT DIAGNOSTIC. 
* 
      STA IRL+1    SAVE  A2 
* 
      LDA M.40     SET 5-WORD AREA
      STA IRL+2     = 0 IN UPPER, BLANK IN LOWER
      STA IRL+3 
      STA IRL+4 
      STA IRL+5 
      STA IRL+6 
* 
      LDA CM.5     IRL+7= 
      STA IRL+7     -5
      LDA IRLA     IRL+8  = ADDRESS OF WORD 3 
      ADA C.02
      STA IRL+8     OF IRL AREA.
IR3   JSB GETC     GET CHAR OF ENTRY POINT NAME 
      JMP IR4      FINISHED WITH STATEMENT. 
      STA IRL+8,I  SET CHAR IN APPROPRIATE WORD 
      ISZ IRL+8    ADD 1 TO AREA ADDRESS
      ISZ IRL+7    INDEX FOR 5 CHARACTERS.
      JMP IR3      NOT 5 YET
* 
IR4   LDA IRL+2    PACK NAME
      ALF,ALF      LEFT-JUSTIFIED 
      IOR IRL+3     IN IRL+2 TO 
      STA IRL+2      IRL+4
      LDA IRL+4       WITH TRAILING 
      ALF,ALF          BLANKS.
      IOR IRL+5     LOWER CHAR
      STA IRL+3      OF  IRL+4
      LDA IRL+6       = 0.
      ALF,ALF 
      STA IRL+4 
* 
      LDB IRLA     (A) = ADDR. OF WORD 3 OF IRL.
      ADB C.02
      JSB SRLST    SEARCH FOR MATCH IN LST. 
      RSS          NO MATCH.
      JMP IR5       MATCH.
      LDA ML9      OUTPUT MESSAGE 
      LDB ML9+1      UNDEFINED NAME 
      JSB LIST,I    AND REPEAT
      JSB KBIN       INPUT. 
      JSB GETC     GET FIRST CHARACTER. 
      JMP IRE       ERROR - NULL STATEMENT. 
      CPA XMARK    IF CHAR. IS A !, THEN SYMBOL IS
      RSS           TO BE ADDED TO BCS LDR LST. 
      JMP IR1+3    MISTAKE IN PREVIOUS STATEMENT. 
* 
* THE SYMBOL IN THE STATEMENT IS AN ENTRY POINT IN
*  AN INTERRUPT ROUTINE WHICH IS TO BE LOADED AT
*  RUN TIME BY THE BCS LOADER. THEREFORE, THIS
*  SYMBOL IS ADDED TO THE LOADER LST AS AN UNDEFINED
*  EXTERNAL SYMBOL. 
* 
      LDA IRLA     (A) = ADDRESS OF SYMBOL
      ADA C.02
      CLB          (B) = 0 TO FORCE LINK ESTABLISHED
      JSB ADLST 
* 
      ADB MSIGN    (B) = LINK ADDR, SET INDIRECT BIT, 
      LDA B         STORE IN LST4 AND GO TO 
      JMP IR5+1      SET INTERRUPT LOCATIONS. 
* 
* 
IR5   LDA LST4,I   GET ENT.POINT ADDRESS
      STA IRL+1,I   STORE IN (A2).
      LDA JSBI     SET A2 AS OPERAND ADDRESS OF 
      IOR IRL+1     JSB X,I  AND STORE
IR6   STA IRL,I      IN  (A1).
      JMP IR1     PROCESS NEXT INPUT. 
* 
IRLA  DEF *+1 
IRL   BSS 9 
JSBI  OCT 114000     JSB  0,I 
ML9   DEC 8 
      DEF *+1 
      ASC 4,*UN NAME
IRE   JSB ERRPT    OUTPUT *ERROR
      JMP IR1       AND REPEAT INPUT. 
* 
ML10  DEC 20
      DEF *+1 
      ASC 10, INTERRUPT LINKAGE ? 
* 
HLT5  HLT 05       POWER FAIL CELL HALT.
* 
XMARK OCT 41       ASCII CODE FOR  !
* 
* FINAL LINKAGE SECTION TO COMPLETE BCS SYSTEM
* 
* PART I.  THE IOC EQUIPMENT TABLE IS SCANNED AND 
*          THE ABSOLUTE ADDRESS OF THE CORRESPONDING
*          DRIVER INITIATOR SECTION IS SET IN 
*          WORD 4 OF THE EQT ENTRIES.  THIS IS
*          ACCOMPLISHED BY: 
*            1. CONVERTING THE EQUIPMENT TYPE CODE, 
*               BITS 13-08 OF WORD 2, TO ASCII (OCTAL)
*            AND COMBINING IT WITH D. TO CONSTRUCT
*               THE DRIVER INITIATOR SECTION NAME.
* 
*            2. THE LST IS SEARCHED TO FIND THE 
*               CORRESPONDING NAME. 
* 
*            3. THE ABSOLUTE ADDRESS OF THE NAME
*               IS SET IN WORD 4 OF THE EQT ENTRY.
*           4. IF THE DRIVER NAME IS NOT FOUND
*              IN THE PCS SYMBOL TABLE, THE 
*              NAME IS TYPED AND  A  KEYBOARD 
*              INPUT IS REQUESTED. IF A - ! - IS
*              INPUT, THE MISSING DRIVER IS TO
*              BE LOADED AT RUN-TIME BY THE BCS 
*              LOADER. THEREFORE, THE NAME IS 
*              ADDED TO THE BCS LOADER SYMBOL 
*              TABLE AS AN UNDEFINED EXT, AND 
*              THE LINK ADDRESS (WITH THE INDIRECT
*              BIT SET = 1) IS STORED IN WORD 4 
*              OF THE EQT ENTRY.
* 
* 
* PART II. THE FIXED SEGMENT OF THE LST IN THE
*          RELOCATABLE LOADER IS PROCESSED TO 
*          SET THE ENTRY POINT ADDRESS AND LINKAGE
*          ADDRESS FOR EACH LST SYMBOL. 
* 
* 
* PART III. THE MEMORY TABLE IN THE BCS LOADER
*            IS SET TO REFLECT THE BOUNDS OF
*            AVAILABLE MEMORY - THE MEMORY
*            TABLE IS AT THE ENTRY POINT -MEMRY-. 
* 
*            LOCATIONS 0002 AND 0003 IN BASE PAGE 
*             ARE SET TO CONTAIN: 
* 
*              (00002)   JMP  3,I 
*              (00003)   DEF  .LDR. 
* 
*              TO PROVIDE FOR BEGINNING EXECUTION 
*              OF THE BCS LOADER. 
* 
* 
* 
P.I   LDB EQTA     (B) . ADDRESS OF EQT.
      LDA B,I      SET T1 = NEGATIVE NUMBER 
      CMA,INA       OF EQT ENTRIES FOR
      STA T1         INDEXING 
*                          SET T2 = ADDRESS OF WORD PRIOR 
      STB T2        TO FIRST ENTRY. 
* 
PX1   LDB T2       SET (A) =
      ADB C.02       WORD 2 OF
      LDA B,I         EQT ENTRY 
      ADB C.02     SET T2 = ADDRESS OF
      STB T2          WORD 4. 
* 
      ALF,ALF      ROTATE EQUIP CODE TO LOW A.
      JSB BASC     CONVERT TO OCTAL / ASCII.
      STA DNAM+2   STORE AS WORD 2 OF DRIVER NAME 
      LDB DNAM     (B) = ADDRESS OF DRIVER NAME 
* 
      JSB SRLST    FIND MATCHING NAME 
      JMP PX4      NOT FOUND - CHECK TO BE ADDED. 
* 
      LDA LST4,I   SET ADDRESS IN WORD 4
PX5   STA T2,I      OF EQT ENTRY
      ISZ T1       FINISHED WITH EQT? 
      JMP PX1       NO, PROCESS NEXT ENTRY. 
      JMP P.II     YES, GO TO PART II.
* 
PX4   LDA ML18     OUTPUT MESSAGE:
      LDB ML18+1   -I/O DRIVER?-, 
      JSB LIST,I
      LDB DNAM      AND DRIVER
      LDA C.05       ENTRY POINT
      JSB LIST,I      NAME. 
* 
      JSB KBIN     GET REPLY FROM KEYBOARD. 
      JSB GETC     GET FIRST CHARACTER. 
      JMP PX4       -ERROR, NULL STATEMENT. 
      CPA XMARK    IF CHAR. = !, THEN 
      RSS           ADD TO BCS LDR  LST.
      JMP IRREC     TERMINATE PCS OPERATION 
* 
      LDA DNAM     (A) = ADDR. OF SYMBOL
      CLB          (B) = 0 TO FORCE LINK ESTABLISHED
      JSB ADLST    ADD TO BCS LOADER SYMBOL TABLE.
* 
      ADB MSIGN    SET I-BIT OF LINK ADDR = 1,
      LDA B         GO TO 
      JMP PX5        SET IN EQT ENTRY.
* 
* 
DNAM  DEF *+1      DEFINE ADDRESS OF 3 WORD BLOCK 
      ASC 1,D.      D.  FOR DRIVER NAME 
      OCT 0 
      OCT 20000     BLANK / ZERO
* 
* 
P.II  LDB .LSTA    FIND  LST ENTRY
      JSB SRLST    - LST -
      JMP UNSYM    ERROR - NOT FOUND. 
* 
      LDA LST4,I   GET ADDRESS OF -LST-.
      LDB A,I      GET NO. OF FIXED ENTRIES 
      CMB,INB       SET NEGATIVE AND SAVE 
      STB T1         FOR INDEX IN T1
      STA T2       SET STARTING ADDRESS IN T2.
* 
PX2   LDB T2       SET B = ADDRESS OF WORD 4 OF 
      ADB CM.4       LST ENTRY. 
      LDA B,I      GET LINK LOCATION. 
      ADB CM.1     SET B = ADDRESS OF WORD 5 LST
      STB T2       AND RESTORE B IN T2. 
      SSA,RSS      IF THIS ENTRY IS ONLY AN ENTRY 
      JMP PX3       POINT TO LDR, GET NEXT ENTRY. 
      ALR,ARS      CLEAR SIGN OF LINK LOCATION. 
      STA B,I      SET LINK ADDRESS IN WORD 5.
      LDA A,I      GET ADDRESS AT LINK LOCATION 
      INB          SET B=ADDR OF WORD 4 LST ENTRY 
      STA B,I      SET ABS. ENTRY POINT ADDR IN W.4.
PX3   ISZ T1       INDEX FOR FIXED LST ENTRIES. 
      JMP PX2      -MORE TO PROCESS.
      JMP P.III    FINISHED, GO TO PART 3.
* 
.LSTA DEF *+1 
      ASC 1,LS
      ASC 1,T 
      OCT 20000 
* 
P.III LDB XMEM     FIND ENTRY POINT 
      JSB SRLST           .MEM. 
      JMP UNSYM 
      LDB LST4,I   GET ADDRESS OF MEMORY TABLE. 
      INB 
      LDA FWABP    SET FWA BASE PAGE IN WORD 1
      STA B,I 
      ADB C.03     SET (B) = ADDR. OF WORD 4. 
      LDA LWAM
      STA B,I      SET LWA MEMORY IN WORD 4.
      INB 
      LDA LWAM1 
      STA B,I 
* 
      LDB X.LDR    FIND ENTRY POINT:
      JSB SRLST      .LDR.
      JMP UNSYM    -ERROR - NOT FOUND.
      LDA LST4,I   SET ADDRESS OF .LDR. 
      STA 3          IN LOCATION 3. 
      LDA JMP3I    SET A  JMP  3,I
      STA 2          IN LOCATION 2. 
* 
      JMP LS3      RETURN TO CONTROL SECTION. 
* 
UNSYM STB T1       SAVE ADDRESS OF SYMBOL FOR PRINT.
      LDA ML17     PRINT MESSAGE
      LDB ML17+1    *UNDEFINED SYMBOL 
      JSB LIST,I
      LDB T1       PRINT SYMBOL 
      LDA C.05
      JSB LIST,I
      JMP IRREC    GO TO ERROR HALT.
* 
XMEM  DEF *+1 
      ASC 1,.M        - .MEM. - 
      ASC 1,EM
      OCT 27000 
* 
X.LDR DEF *+1 
      ASC 1,.L
      ASC 1,DR
      OCT 27000 
* 
JMP3I JMP 3,I 
* 
* 
ML17  DEC 19
      DEF *+1 
      ASC 10,* UNDEFINED SYMBOL:
* 
ML18  DEC 11
      DEF *+1 
      ASC 6,I/O DRIVER? 
* 
* 
* 
* SUBROUTINE:  ADLST (ADD TO BCS LOADER LST)
* 
* PURPOSE: THIS ROUTINE ADDS AN EXTERNAL
*          SYMBOL TO THE FIXED SEGMENT OF 
*          THE SYMBOL TABLE OF THE BCS
*          RELOCATABLE LOADER. A LINK WORD
*          FOR THE EXT IS ESTABLISHED IN
*          THE SYSTEM LINKAGE AREA IN 
*          BASE PAGE. THE LOCATION OF THE 
*          LINK WORD IS STORED IN WORD 5
*          OF THE NEW LST ENTRY AND WORD 4
*          IS SET = 0.
* 
*          THE EFFECT OF THIS OPERATION IS
*          TO ALLOW (OR FORCE) LOADING OF 
*          I/O DRIVERS AND/OR INTERRUPT 
*          SERVICE ROUTINES DURING A BCS
*          LOADING OPERATION. 
* 
* CALL:    (A) = STARTING ADDRESS OF 3-WORD 
*             GROUP CONTAINING ASCII
*             SYMBOL
*          (B),NOT = 0, CONTAINS LINK WORD ADDRESS. 
*        (P)  JSB ADLST 
*        (P+1) -RETURN- (B)= LINK LOCATION
* 
* ERROR CONDITIONS: IF AVAILABLE MEMORY IS
*        EXHAUSTED IN ATTEMPTING TO ADD 
*        A NEW LST ENTRY, CONTROL IS TRANS- 
*        FERRED TO THE LOADER SECTION TO
*        PRINT THE ERROR DIAGNOSTIC *L03. 
* 
* 
ADLST NOP 
      STB AD3      SAVE B (= 0 OR LINK ADDR). 
      STA AD1      SAVE SYMBOL ADDRESS. 
      LDB .LSTA    FIND  -LST- IN PCS 
      JSB SRLST     LOADER SYMBOL TABLE - 
      JMP UNSYM      ERROR - NOT FOUND. 
* 
      LDA LST4,I   GET ADDRESS OF -LST-.
      LDB A,I      GET NO. OF FIXED LST ENTRIES-
      BLS,BLS       MULTIPLY BY 5 TO GET
      ADB A,I        WORD LENGTH. 
      ISZ A,I     ADD 1 FOR NEW ENTRY.
      CMB          SUBTRACT  # WORDS + 1 FROM 
      ADA B         ADDR. OF LST, SAVE WORD 1 
      STA AD2       ADDR OF NEW LST ENTRY.
      ADA CM.5     SUBTRACT 5 FROM NEW
      STA B         ADDR TO GET NEW -LWAM-. 
      CMA,INA      SUBTRACT NEW LWAM FROM 
      ADA FWAM      FIXED FWAM. 
      SSA,RSS      A POSITIVE RESULT MEANS MEMORY 
      JMP LER3      OVERFLOW. 
      STB LWAM      SET NEW LWAM. 
* 
      LDB AD2      (B) = ADDR. (WORD 1) NEW ENTRY.
      LDA AD1,I    MOVE  3 WORDS CONTAINING 
      STA B,I       SYMBOL NAME 
      ISZ AD1       TO WORDS 1,2 AND 3
      ADB CM.1      OF NEW
      LDA AD1,I     LST ENTRY IN BCS LOADER.
      STA B,I 
      ISZ AD1 
      ADB CM.1
      LDA AD1,I 
      STA B,I 
      ADB CM.1
      CLA          SET WORD 4 (EPT ADDRESS) 
      STA B,I        = 0. 
      ADB CM.1     SET AD2 = ADDR.
      STB AD2       OF WORD 5 ( EXT LINK ADDR). 
      LDB AD3      IF LINK ALREADY ESTABLISHED
      SZB,RSS       FOR THIS SYMBOL, SKIP - 
* 
      JSB LINK      OTHERWISE, ALLOCATE LINK WORD.
* 
      STB AD2,I    SET LINK ADDR. IN WORD 5 AND 
* 
      JMP ADLST,I   EXIT. 
* 
AD1   NOP 
AD2   NOP 
AD3   NOP 
* 
* 
* 
* 
* PUNCH SECTION  *********************************
* 
* THIS SECTION IS THE FINAL STEP IN CONSTRUCTING
*  A BCS SYSTEM. THE PURPOSE OF THIS SECTION IS 
*  TO PRODUCE ABSOLUTE BINARY VERSIONS OF THE 
*  BCS SYSTEM. THE ABSOLUTE BINARY VERSIONS ARE 
*  OUTPUT TO THE PAPER TAPE PUNCH DEVICE IN THE 
*  ABSOLUTE RECORD FORMAT ACCEPTABLE BY THE 
*  BASIC BINARY LOADER ( ABSOLUTE BINARY LOADER). 
* 
* 
* THE AREA PUNCHED IS: FWA OF LOADR TO LWA MEMORY 
*          AS DESIGNATED BY THE OPERATOR IN THE 
*          INITIALIZATION SECTION. THIS VALUE IS
*          HELD AT  -LWAM1-.  THE SYSTEM LINKAGE
*          AREA AND INTERRUPT LOCATIONS ARE FROM
*          LOCATION 0002  TO (FWABP-1). 
* 
*  MULTIPLE COPIES OF BCS MAY BE PRODUCED BY
*   SETTING SWITCH 15 = 1 AND PRESSING RUN
*   AFTER THE HALT SIGNALLING THE COMPLETION
*   OF EACH COPY. 
* 
*  THE MAXIMUM BLOCK SIZE OF THE ABSOLUTE RECORDS 
*   IS  60(10) WORDS. 
* 
* 
* 
PNCH  LDA ML11     OUTPUT -*BCS ABSOLUTE OUTPUT-
      LDB ML11+1     TURN PUNCH ON. 
      JSB LIST,I   AND
      HLT 0         HALT -
      LDA LOUTP     SET TTY COMMAND FOR PUNCH UNIT
      STA LOUTC      FOR POSSIBLE ASR-35 USAGE. 
* 
PCH1  JSB LTG      GENERATE LEADER. 
      LDA LWAM     OUTPUT ALL 
      INA          BCS
      LDB LWAM1     MODULES 
      JSB PNCHA      LOADED 
      LDA C.02     OUTPUT AREA FOR INTERRUPT AND
      LDB FWABP     LINKAGE 
      ADB CM.1
      JSB PNCHA      AREA 
      JSB LTG      GENERATE TRAILER 
* 
      HLT 77B 
* 
      LIA 01       IF SWITCH 15 = 1,
      SSA           REPEAT
      JMP PCH1       PREVIOUS OUTPUT. 
* 
* 
      LDA LOUTP+1    RESET PRINTER
      STA LOUTC       COMMAND.
      LDA ML15     OUTPUT MESSAGE:
      LDB ML15+1    * PCS RUN COMPLETED 
      JSB LIST,I
IRREC HLT 0        FINAL HALT ------- 
      JMP *-1       -IRRECOVERABLE
* 
ML11  DEC 20
      DEF *+1 
      ASC 10,*BCS ABSOLUTE OUTPUT 
ML15  DEC 4 
      DEF *+1 
      ASC 2,*END
* 
* SUBROUTINE: PNCHA (PUNCH ABSOLUTE BLOCK)
* 
* CALLING SEQUENCE:   (A) = FWA OF BLOCK
*                     (B) = LWA OF BLOCK
*                   (P)  -  JSB  PNCHA
*                   (P+1)-  -RETURN-
* 
* 
PNCHA NOP ##
      STA T1       SAVE FIRST AND LAST WORD 
      STB T2        ADDRESSES OF BLOCK
* 
P1    LDA CM.57    SET T3 = -57 AS INDEX FOR
      STA T3        FILLING BUFFER. 
      LDA T1       SET LBUF+1 FOR LOAD ADDRESS
      STA PBUF1,I   OF CURRENT BLOCK. 
      STA CKS      INITIALIZE CHECKSUM WORD 
      CLA          INITIALIZE 
      STA PBUF,I    WORD COUNT
      LDA PBUF     SET T4 = ADDRESS OF
      ADA C.02      WORD 3 OF BUFFER FOR
      STA T4         STORING WORDS. 
* 
P2    LDA T1,I     STORE CURRENT WORD FROM MEMORY 
      STA T4,I      BLOCK IN BUFFER.
      ISZ T4       ADD 1 TO BUFFER ADDRESS. 
      ADA CKS      ADD WORD TO CUMULATED
      STA CKS       CHECKSUM. 
      ISZ PBUF,I   COUNT WORD STORED IN BUFFER. 
      LDA T1       CHECK FOR END-OF-BLOCK.
      ISZ T1        ADD 1 TO BLOCK ADDRESS. 
      CPA T2
      JMP P3       YES
      ISZ T3       INDEX BUFFER COUNTER.
      JMP P2       BUFFER NOT FILLED. 
* 
P3    LDA CKS      BUFFER FILLED. SET CHECKSUM IN 
      STA T4,I      LAST WORD IN BUFFER.
      LDA PBUF,I   POSITION RECORD
      ALF,ALF       WORD COUNT TO 
      STA PBUF,I     UPPER CHARACTER IN WORD 1. 
      ALF,ALF      REPOSITION , ADD 3 FOR 
      ADA C.03      TOTAL RECORD LENGTH, SET
      CMA,INA        NEGATIVE FOR OUTPUT. 
      LDB PBUF     (B) = ADDRESS OF BUFFER. 
      JSB PUNCH,I  PUNCH RECORD---
* 
      CCA           CHECK FOR 
      ADA T1         COMPLETION OF
      CPA T2        PUNCHING BLOCK -
      JMP PNCHA,I  YES, EXIT. 
      JMP P1       NO, SET NEXT RECORD. 
* 
CM.57 DEC -57 
PBUF  DEF LBUF     REDEFINE LBUF
PBUF1 DEF LBUF+1
T3    OCT 0 
T4    OCT 0 
CKS   OCT 0 
* 
* 
* SUBROUTINE: LTG  (LEADER/TRAILER GENERATOR) 
* 
* CALL:  (P)    JSB  LTG
*        (P+1)  -RETURN-
* 
*  LTG PRODUCES  APPROXIMATELY  10-INCHES OF
*    BLANK TAPE -FEED FRAMES. 
* 
LTG   NOP 
      LDB CM.57 
      LDA PBUF
      STA T1
* 
      CLA 
      STA T1,I
      ISZ T1
      INB,SZB 
      JMP *-3 
* 
      LDA CM.57 
      LDB PBUF
      JSB PUNCH,I 
      JMP LTG,I 
* 
* 
LOUTP OCT 110000      ASR PUNCH COMMAND WORD
      OCT 120000
* 
* 

* 
*****  EQUIPMENT DRIVERS FOR   P C S  ******
* 
* 
* CALLING SEQUENCE: 
* 
*  (A) = LENGTH OF DATA BUFFER (OR RECORD) :
*         > O, LENGTH IN CHARACTERS FOR ASCII RECORDS 
*         < 0, LENGTH IN WORDS (2-S COMPLEMENT) FOR 
*               BINARY RECORDS
* 
*  (B) = STARTING ADDRESS OF DATA BUFFER
* 
* 
*  (P)     JSB  10X,I  ( X DESIGNATES 1 TO 4 )
*  (P+1)  -RETURN-   (B) MEANINGLESS
* 
*     (A) ON RETURN FROM AN INPUT OPERATION CONTAINS
*       THE NUMBER OF CHARACTERS (ASCII) OR WORDS 
*       (BINARY) TRANSMITTED TO BUFFER. 
* 
*     NOTE: IF (A) = ZERO, THEN AN END-OF-TAPE
*           CONDITION RESULTED FROM THE INPUT.
*           THIS IS DEFINED AS A FIXED NUMBER OF
*           CONSECUTIVE FEED-FRAMES INPUT BEFORE
*           THE FIRST NON-ZERO DATA CHARACTER OF
*           A RECORD. THE FIXED NUMBER IS THE 
*           NEGATIVE CONSTANT AT LABEL  -FFCT- .
* 
*    (A) ON RETURN FROM AN OUTPUT OPERATION ARE 
*      MEANINGLESS. 
* 
* RECORD FORMATS: 
* 
*  A. INPUT - ASCII: A GROUP OF CHARACTERS
*           TERMINATED BY A RETURN/LINE FEED. 
*           THESE CODES INPUT BEFORE THE FIRST
*           DATA CHARACTER OF A RECORD ARE IGNORED. 
*           A RUB-OUT CODE CAUSES THE CURRENT RECORD
*           TO BE DELETED AND THE NEXT RECORD INPUT.
*           A LINE-FEED MUST TERMINATE THE CURRENT
*           RECORD
* 
*            BINARY: THE FIRST CHARACTER OF A 
*           BINARY RECORD CONTAINS THE WORD COUNT OF
*           THE ENTIRE RECORD. THIS VALUE DETERMINES
*           THE NUMBER OF WORDS TRANSMITTED UP TO 
*           THE BUFFER LENGTH IN THE CALLING SEQUENCE.
* 
*            KEYBOARD:  ASCII FORMAT WITH EACH
*           CHARACTER PRINTED AS IT IS TYPED. 
* 
*  B. OUTPUT - ASCII: A RETURN/LINE-FEED IS OUTPUT BY 
*           THE DRIVER TO  TERMINATE AN ASCII RECORD. 
* 
*            BINARY: THE DRIVER OUTPUTS FOUR (4)
*           FEED-FRAMES TO TERMINATE A BINARY RECORD. 
*           THE LENGTH OF A BINARY RECORD IS THE
*           LENGTH IN B UPON ENTRY TO THE DRIVER. 
* 
* 
* DRIVER FOR ASR 33/35 TELETYPEWRITER --- 
*         << PARALLEL INTERFACE >>
* 
* 
* 
TTY.K NOP         ** KEYBOARD INPUT ENTRY **
      STB BUFF     SET BUFFER 
      STB BUFS      ADDRESS 
      LDB TTY.K    TAKE ENTRY POINT ADDRESS AND 
      STB TTY.I    STORE IN EXIT POINT
      LDB DA       SET INSTRUCTION IN INPUT SECTION 
      STB TT.3. 
      JMP TT.1
* 
TTY.I NOP         **  INPUT  ENTRY  **
      STB BUFF     SET BUFFER 
      STB BUFS      ADDRESS 
      LDB DB       SET INSTRUCTION TO INPUT ONLY. 
      STB TT.3.    TO PROVIDE CHAR. PRINTING
TT.1  CCE,SSA      SET E=1 FOR ASCII MODE, SKIP IF
      ALS,CLE,SLA  ASCII. SET E=0, BINARY,CONVERT TO
      CMA,INA       CHARS. SET CHAR COUNT NEGATIVE. 
      CLB          SET B (DATA-IN FLAG) =0, NO DATA 
      STA LENG     SET REQUESTED LENGTH (CHARS) 
TT.2  STA CHC1      AS COUNTER. 
      LDA UL52     INITIALIZE UPPER/LOWER CHAR. POS.
      STA ULFL      INDICATOR TO UPPER. 
      LDA FFCT     INITIALIZE END-OF-TAPE 
      STA EOTC      COUNTER.
      CLA          SET CHAR. INPUT COUNTER
      STA CHC2      TO ZERO.
* 
* CHARACTER INPUT SECTION 
* 
TT.3  STB SAVB     SAVE (B) 
TT.3. NOP 
TT.31 OTB TTY      OUTPUT THE COMMAND 
TT.32 STC TTY,C    SET CONTROL AND CLEAR FLAG.
TT.33 SFS TTY      WAIT UNTIL READY 
      JMP *-1 
TT.34 LIA TTY      INPUT DATA FROM BUFFER 
      AND M377     REMOVE TRAILER BITS
      SEZ 
      AND M177     REMOVE TRAILER BITS IF ASCII.
      LDB SAVB     RESTORE B
* 
      SZB,RSS      IF NO DATA YET AND CHAR = 0, 
      SZA           CHECK FOR END-OF-TAPE.
      JMP TT.6     OTHERWISE PROCESS CHAR.
* 
      ISZ EOTC     INDEX END-OF-TAPE COUNTER
      JMP TT.3      NO -
      JMP TT.13    END-OF-TAPE - GO TO EXIT SECTION.
* 
* BINARY RECORD LENGTH SECTION
* 
TT.6  SEZ          IF ASCII MODE, GO TO 
      JMP TT.7      EXAMINE CHAR. 
      SZB          IF NOT FIRST CHAR. OF BINARY 
      JMP TT.8      RECORD, GO TO PACK CHARACTER. 
      STA 1         CONVERT RECORD WORD 
      BLS            LENGTH TO CHARS. 
      ADB LENG      SUBTRACT ORIG. BUFFER LENGTH. 
      CLE,SSB,RSS   IF RECORD LENGTH GREATER, 
      JMP TT.8       USE ORIG. BUFFER LENGTH. 
      STA 1         CONVERT TO CHARS AGAIN
      BLS            AND SET NEGATIVE 
      CMB,INB        FOR CHARACTER
      STB CHC1        INDEX.
      JMP TT.8      GO TO CHAR. PACKING SECTION.
* 
* CHARACTER EXAMINATION SECTION - ASCII 
* 
TT.7  CPA RETN     IF CHAR. IS RETURN CODE, IGNORE
      JMP TT.3      IT. GET NEXT CHAR.
      CPA RUBO     IF CHAR. IS RUB-OUT, GO
      JMP TT.11     TO RESET INPUT FOR NEXT RECORD. 
      CPA LINF     IF CHAR. IS LINE-FEED, GO TO 
      JMP TT.12     TERMINATION SECTION.
* 
      SSB          IF DATA-IN FLAG = -1 (LINE-FEED
      JMP TT.3      REQUIRED), INPUT NEXT CHAR. 
* 
TT.8  CLB,INB      SET DATA-IN FLAG = 1 TO SAY
      STB SAVB      RECORD BEING TRANSMITTED. 
* 
* DATA PACKING AND STORING SECTION
* 
      LDB ULFL    (B) = CHAR. POSITION INDICATOR. 
      SSB,RSS 
      JMP TT.9     UPPER. 
      IOR CHAR     LOWER- PACK PREVIOUS UPPER CHAR
      STA BUFF,I    AND STORE PACKED WORD 
      ISZ BUFF     ADD 1 TO BUFFER ADDRESS. 
      JMP TT.10 
TT.9  ALF,ALF      ROTATE TO UPPER AND
      STA CHAR      SAVE. 
TT.10 RBL          SET INDICATOR FOR NEXT POSITION
      STB ULFL      AND SAVE FLAG.
      LDB SAVB     RESTORE DATA-IN FLAG.
      ISZ CHC2     COUNT CHAR. INPUT
      ISZ CHC1     INDEX CHAR. LENGTH 
      JMP TT.3      BUFFER NOT FILLED.
      SEZ,RSS      BUFFER FILLED - IF BINARY
      JMP TT.13     MODE, GO TO EXIT SECTION. 
* 
      CCB          ASCII - SET DATA-IN FLAG = -1, 
      JMP TT.3      TO FORCE A LINE-FEED IN.
* 
* SECTION TO PROCESS RUBOUT CODE (ASCII  MODE)
* 
TT.11 LDA BUFS     RESET STARTING BUFFER
      STA BUFF      ADDRESS.
      LDA LENG     (A) = ORIGINAL BUFFER LENGTH.
      CCB          SET DATA-IN FLAG = -1, TO FORCE
      JMP TT.2     A LF TO TERMINATE RECORD.
* 
* SECTION TO PROCESS LINE-FEED CODE (ASCII MODE)
* 
TT.12 CLB       SET B=0 FOR RE-INPUT FROM RUB-OUT.
      LDA LENG     IF NO CHARS. INPUT OR RUB-OUT
      CPA CHC1      RECORD TERMINATED, READ 
      JMP TT.3       NEXT CHARACTER.
*               CHECK CURRENT POSITION INDICATOR. 
      LDB ULFL     IF LAST CHAR.
      LDA CHAR      INPUT WAS IN UPPER POSITION,
      IOR BLANK     MAKE LOWER CHAR. A
      SSB            BLANK AND STORE
      STA BUFF,I      LAST WORD.
* 
* EXIT (COMPLETION) SECTION 
* 
TT.13 LDA CHC2     SET A = CHARACTER COUNT. 
      SEZ,RSS      IF BINARY RECORD INPUT,
      ARS           CONVERT TO WORDS
TT.36 CLC TTY      CLEAR CONTROL. 
      JMP TTY.I,I  EXIT THROUGH INPUT ENTRY.
* 
* 
* LIST AND PUNCH OUTPUT SECTION 
* 
* 
TTY.O NOP          ** OUTPUT LIST ENTRY **
      STB BUFF      SAVE STARTING ADDRESS OF BUFFER.
* 
TOUT1 CCE,SSA 
      ALS,CLE,SLA   -BINARY, SET E=0, CONVERT TO
*                             CHARS., FORCE A SKIP
      CMA,INA       SET CHAR. COUNT NEGATIVE
      SZA,RSS       IF ZERO CHAR. LENGTH, 
      JMP TT.15      GO OUTPUT A LINE-FEED. 
      STA CHC1      SET CHAR. INDEX 
      LDB UL52     (B) = UPPER/LOWER INDICATOR
      LDA CM.4     SET EOTC = -4 FOR OUTPUT OF 4
      STA EOTC      FEED-FRAMES AFTER BINARY RECORD.
* 
* CHARACTER OUTPUT SECTION
* 
TT.14 LDA BUFF,I   GET WORD CONTAINING CHARACTER
      SSB,RSS      IF UPPER/LOWER FLAG SAYS UPPER,
      ALF,ALF       SIGN = 0, ROTATE TO LOWER.
      AND M377     ISOLATE CHARACTER. 
      JSB TOUT     OUTPUT CHARACTER.
      SSB          IF CHAR. OUTPUT WAS LOWER CHAR., 
      ISZ BUFF      ADD 1 TO BUFFER ADDRESS.
      RBL          SET UPPER/LOWER FLAG TO NEXT CHAR
      ISZ CHC1     INDEX CHARACTER COUNTER
      JMP TT.14     MORE TO PROCESS.
* 
* OUTPUT COMPLETION SECTION 
* 
      SEZ,RSS      IF BINARY MODE, GO TO OUTPUT 
      JMP TT.16     4 FEED-FRAMES.
      LDA RETN     OUTPUT 
      JSB TOUT      RETURN (ASCII MODE).
TT.15 LDA LINF     OUT
      JSB TOUT      LINE-FEED.
      JMP TOUT6    EXIT.
* 
TT.16 CLA          BINARY- A= 0 FOR FEED FRAME. 
      JSB TOUT      OUTPUT
      ISZ EOTC       4
      JMP TT.16       FEED-FRAMES.
TOUT6 CLC TTY      CLEAR CONTROL
      JMP TTY.O,I  CLEAR, EXIT LIST ENTRY 
* 
* SUBROUTINE (TOUT) TO OUTPUT ONE CHARACTER 
* CALLING SEQUENCE:  (A)= CHARACTER IN 07-00
*        (P)       JSB  TOUT
*        (P+1)    -RETURN-  (B) NOT DESTROYED 
* THE 8-LEVEL BIT (FOR ASCII MODE) AND TRAILER
*  BITS ARE ADDED TO THE CHARACTER. 
* 
TOUT  NOP          ENTRY / EXIT 
      STB SAVB     SAVE (B).
TOUT. LDB LOUTC 
TOUT0 OTB TTY      OUTPUT COMMAND 
      AND M377     MASK DATA. 
      SEZ          IF ASCII MODE, 
      IOR M1400     SET 8-LEVEL BIT 
TOUT3 OTA TTY      SET CHARACTER IN BUFFER
TOUT4 STC TTY,C    AND OUTPUT IT. 
TOUT5 SFS TTY      WAIT 
      JMP *-1 
      LDB SAVB     RESTORE (B). 
      JMP TOUT,I     AND EXIT.
* 
* CONSTANT, STORAGE AND FLAG SECTION
* 
BUFF  OCT 0        HOLDS CURRENT BUFFER ADDRESS 
BUFS  OCT 0        HOLDS STARTING BUFFER ADDRESS
LENG  OCT 0        HOLDS ORIGINAL BUFFER LENGTH 
CHC1  OCT 0        INDEX VALUE FOR CHARACTERS 
CHC2  OCT 0        HOLDS COUNT OF CHARACTERS INPUT
M377  OCT 377      MASK FOR 8-BIT CHARACTER 
M177  OCT 177      MASK FOR 7-BIT CHARACTER 
M1400 OCT 1400     MASK FOR ADDING TRAILER BITS 
LOUTC OCT 120000
DA    LDB DA. 
DB    LDB DB. 
DA.   OCT 160000   INSTRUCTION TO PRINT 
DB.   OCT 140000   INSTRUCTION TO INPUT ONLY. 
CM.4  DEC -4       FEED-FRAME OUTPUT COUNTER
*                             UPPER/LOWER CHARACTER 
UL52  OCT 52525    POSITION INDICATOR:0=UPPER,1=LOWR
ULFL  OCT 0        POSITION INDICATOR FLAG
SAVB  OCT 0        TEMPORARY STORAGE FOR B
EOTC  OCT 0        INDEX WORD FOR END-OF-TAPE 
CHAR  EQU EOTC     HOLDS UPPER CHAR. FOR PACKING
BLANK OCT 40       ASCII  SPACE  (BLANK)
RETN  OCT 15       ASCII  RETURN CODE 
LINF  OCT 12       ASCII  LINE FEED CODE
RUBO  EQU M177     ASCII  RUB-OUT CODE
* 
* FOLLOWING IS NEGATIVE CONSTANT FOR FEED-FRAME COUNT 
* 
FFCT  DEC -10      * END OF TAPE COUNTER *
* 
TTY   EQU 0 
* 
* 
INPUT EQU 0 
* 
* 
* 
* 
* DRIVER FOR HIGH-SPEED PAPER TAPE READER 
* 
* 
PT.R  NOP           * ENTRY / EXIT POINT *
      STB BUFF     SET BUFFER 
      STB BUFS      ADDRESS 
      CLB           SET DATA-IN FLAG TO SAY NO DATA 
      CCE,SSA      SET E=1 FOR ASCII INPUT
      ALS,CLE,SLA  SET E=0 FOR BINARY-CONVERT TO
      CMA,INA       CHARS, SET CHAR CNT NEGATIVE
      STA LENG       FOR INDEX. 
PT.1  STA CHC1     SET CHARACTER INDEX
      LDA UL52     INITIALIZE UPPER/LOWER CHARACTER 
      STA ULFL      POSITION INDICATOR TO UPPER 
      LDA FFCT     INITIALIZE FEED-FRAME COUNTER
      STA EOTC      FOR  -END OF TAPE-
      CLA          SET CHARACTER INPUT
      STA CHC2      COUNTER = 0.
* 
* CHARACTER INPUT SECTION 
* 
PT.2  STC INPUT,C  SET DEVICE TO READ ONE CHARACTER 
      SFS INPUT    WAIT FOR CHARACTER TO
      JMP *-1        BE INPUT  (FLAG = 1) 
      LIA INPUT    GET CHARACTER FROM BUFFER
      SEZ          IF ASCII MODE, 
      AND M177      REMOVE 8-LEVEL BIT
      SZB,RSS      IF NO DATA YET AND CHAR. = 0,
      SZA           CHECK FOR END-OF-TAPE.
      JMP PT.3     OTHERWISE, PROCESS CHARACTER 
* 
      ISZ EOTC     INDEX END-OF-TAPE COUNTER
      JMP PT.2      NO -
      JMP PT.10    END-OF-TAPE, GO TO EXIT SECTION. 
* 
* BINARY RECORD LENGTH SECTION
* 
PT.3  SEZ          IF ASCII MODE, GO TO EXAMINE 
      JMP PT.4      CHARACTER 
      SZB          IF NOT FIRST CHAR. OF BINARY 
      JMP PT.5      RECORD, GO TO PACKING SECTION.
* 
      STA 1        CONVERT RECORD WORD LENGTH TO
      BLS           CHARACTERS
      ADB LENG     SUBTRACT ORIGINAL BUFFER LENGTH. 
      CLE,SSB,RSS  IF RECORD LENGTH GT BUFFER 
      JMP PT.5      LENGTH, USE BUFFER LENGTH.
      STA 1        CONVERT LENGTH TO
      BLS           CHARACTERS, SET NEGATIVE
      CMB,INB       AND STORE AS
      STB CHC1       CHARACTER INDEX. 
      JMP PT.5     GO TO PACK CHARACTER.
* 
* ASCII CHARACTER EXAMINATION SECTION 
* 
PT.4  CPA RETN     IF CHAR. IS A RETURN,
      JMP PT.2      IGNORE IT.
      CPA RUBO     IF CHAR. IS A RUBOUT,
      JMP PT.8      GO TO INPUT NEXT RECORD 
      CPA LINF     IF CHAR. IS A LINE-FEED, GO TO 
      JMP PT.9      TERMINATION SECTION.
* 
      SSB          IF A LINE-FEED IS NEEDED, DATA-IN
      JMP PT.2      FLAG = -1, GO INPUT NEXT CHAR.
* 
PT.5  CLB,INB      SET DATA-IN FLAG TO SAY RECORD 
      STB SAVB      BEING INPUT  (=1) 
* 
* DATA PACKING AND STORING SECTION
* 
      LDB ULFL     (B) = CHAR. POSITION INDICATOR 
      SSB,RSS 
      JMP PT.6     -UPPER CHAR. 
      IOR CHAR     LOWER- PACK IN PREVIOUS UPPER
      STA BUFF,I    CHAR. AND STORE IN BUFFER 
      ISZ BUFF     ADD 1 TO BUFFER ADDRESS. 
      JMP PT.7
PT.6  ALF,ALF     ROTATE CHAR. TO UPPER POSITION
      STA CHAR      AND SAVE IT.
PT.7  RBL          SET INDICATOR FOR NEXT 
      STB ULFL      POSITION
      LDB SAVB     RESTORE DATA-IN FLAG.
      ISZ CHC2     ADD 1 TO CHAR. INPUT COUNTER 
      ISZ CHC1     INDEX CHARACTER INPUT COUNTER. 
      JMP PT.2     BUFFER NOT FILLED. 
      SEZ,RSS      BUFFER FILLED, IF BINARY MODE, 
      JMP PT.10     GO TO EXIT SECTION. 
* 
      CCB          SET DATA-IN FLAG =-1 TO FORCE A
      JMP PT.2      LINE-FEED TO BE INPUT 
* 
* SECTION TO PROCESS RUBOUT CODE (ASCII MODE) 
* 
PT.8  LDA BUFS     RESTORE STARTING BUFFER
      STA BUFF      ADDRESS 
      LDA LENG     (A) = ORIGINAL BUFFER LENGTH 
      CCB          SET DATA-IN FLAG = -1 TO FORCE A 
      JMP PT.1      LINE-FEED TO BE INPUT.
* 
* SECTION TO PROCESS LINE-FEED CODE (ASCII MODE)
* 
PT.9  CLB         SET B=0 FOR POSSIBLE RE-INPUT FROM
      LDA LENG     RUBOUT. IF NO CHARS INPUT OR 
      CPA CHC1      RUBOUT RECORD TERMINATED ,
      JMP PT.2       READ NEXT CHARACTER. 
* 
      LDB ULFL     IF LAST CHARACTER
      LDA CHAR      INPUT WAS IN
      IOR BLANK      UPPER POSITION, MAKE 
      SSB             LOWER CHAR A BLANK
      STA BUFF,I       AND STORE LAST WORD. 
* 
* EXIT (COMPLETION) SECTION 
* 
PT.10 LDA CHC2     (A) = NUMBER OF CHARS INPUT. 
      SEZ,RSS      IF BINARY RECORD,
      ARS           CONVERT TO WORDS
      JMP PT.R,I   EXIT.
* 
* 
* 
* DRIVER FOR HIGH-SPEED PAPER TAPE PUNCH
* 
* 
PT.P NOP           ENTRY/EXIT 
     STB BUFF      SAVE STARTING ADDRESS OF BUFFER
     CCE,SSA       IF ASCII MODE, SET E=1, AND SKIP 
     ALS,CLE,SLA   IF BINARY, SET E=0, CONVERT WORDS
*                   TO CHARS AND FORCE A SKIP 
PP01 CMA,INA       SET NEGATIVE ASCII COUNT AND SAVE
      SZA,RSS      IF BUFFER LENGTH ZERO, GO TO 
      JMP PP05      OUTPUT A LINE-FEED. 
     STA CHC1      AS COUNTER FOR OUTPUT SECTION. 
     LDB UL52      SET UPPER/LOWER CHARACTER INDICA-
*                   TOR TO UPPER (SIGN - 0).
* 
* CHARACTER OUTPUT SECTION
* 
PP02 LDA BUFF,I    GET WORD CONTAINING CHARACTER
     SSB,RSS       IF UPPER/LOWER FLAG SAYS UPPER 
     ALF,ALF        (SIGN = 0) ROTATE TO LOWER
     AND M377      REMOVE UPPER CHARACTER 
     SEZ            SET 8-LEVEL BIT (BIT 07) = 1
     IOR M200        IF ASCII MODE
     JSB POUT      OUTPUT CHAR. IN A(07-00).
     SSB           IF CHAR. OUTPUT WAS LOWER CHAR., 
     ISZ BUFF       ADD 1 TO BUFFER ADDRESS.
     RBL           SET UPPER/LOWER FLAG FOR NEXT CHAR 
     ISZ CHC1      INDEX CHARACTER COUNTER. 
     JMP PP02       NOT ZERO, MORE TO OUTPUT. 
* 
*  COMPLETION SECTION 
* 
     SEZ,RSS      IF BINARY MODE (E=0), JMMP. 
     JMP PP03       *ASCII MODE SECTION*
     LDA RETX      SET A = RETURN CODE
     JSB POUT        AND OUTPUT RETURN
PP05 LDA LINX      SET A = LINE-FEED CODE 
     JSB POUT        AND OUTPUT LINE-FEED 
     JMP PP04      GO TO EXIT SECTION 
* 
PP03 LDA CM.4      BINARY SECTION.  SET BUFF = -4 
     STA BUFF       FOR COUNTER FOR FEED-FRAMES 
     CLA           SET A = ZERO( FEED-FRAME). 
     JSB POUT      OUTPUT FEED-FRAME
     ISZ BUFF      INDEX COUNTER
     JMP *-3        CONTINUE OUTPUT 
* 
*  EXIT SECTION.  RECORD OUTPUT COMPLETED.
* 
PP04  LIA IOAX     GET DEVICE STATU. 
      SZA,RSS      IF NOT TAPE SUPPLY LOW,
      JMP PP08      GO TO EXIT. 
* 
      LDB CM100   *TAPE SUPPLY LOW* 
PP06  CLA          OUTPUT 
      JSB  POUT      10 INCHES
      INB,SZB        OF 
      JMP PP06        TRAILER 
* 
      HLT 66B      TAPE SUPPLY LOW HALT 
* 
      LDB CM100    ON RESTART, OUTPUT 
PP07  CLA           10 INCHES 
      JSB POUT       FOR
      INB,SZB         LEADER
      JMP PP07
* 
PP08  CLC IOAX     CLEAR DEVICE CONTROL 
     JMP PT.P,I     AND EXIT TO CALLER
* 
*  SUBROUTINE  (POUT) TO OUTPUT ONE CHARACTER TO
*   PUNCH DEVICE. 
*  CALLING SEQUENCE:
*             (A) = CHARCTER IN BITS 07-00 
*  (P)        JSB  POUT 
*  (P+1)      (RETURN)    ( (B) NOT ALTERED ) 
* 
POUT NOP      ENTRY/EXIT POINT
     OTA IOAX      OUTPUT CHAR. TO  I/O REGISTER
     STC IOAX,C    TELL DEVICE TO PUNCH - CLEAR FLAG
     SFS IOAX      DELAY UNTIL CHARACTER
     JMP *-1        IS PUNCHED. 
     JMP POUT,I     EXIT TO CALLING POINT.
* 
M200 OCT 200       CONSTANT FOR SETTING 8-LEVEL BIT 
RETX OCT 215       RETURN CODE (WITH 8-LEVEL SET) 
LINX OCT 212       LINE FEED CODE (WITH 8-LEVEL SET)
CM100 DEC -100     COUNTER FOR LEADER/TRAILER 
* 
* 
IOAX EQU  0 
* 
* 
ST.12 EQU * 
* 
TT.X  NOP 
      STA 1        SET IN B 
* 
      LDA TT.32    STC TTY,C
      IOR 1 
      STA TT.32 
      STA TOUT4 
* 
      LDA TT.33    SFS TTY
      IOR 1        OUTPUT 
      STA TT.33 
      STA TOUT5 
* 
      LDA TOUT3 
      IOR 1 
      STA TOUT3 
* 
      LDA TOUT0    OTB TTY
      IOR 1 
      STA TOUT0 
      STA TT.31 
* 
      LDA TT.36    CLC TTY
      IOR 1 
      STA TT.36 
      STA TOUT6 
* 
      LDA TT.34    LIA TTY
      IOR 1 
      STA TT.34 
* 
      JMP TT.X,I
* 
* 
* 
* 
PR.X  NOP 
      STA B 
      LDA PT.2     SET DEVICE 
      IOR B         I/O 
      STA PT.2      ADDRESS 
      LDA PT.2+1    IN
      IOR B         ALL 
      STA PT.2+1    I/O 
      LDA PT.2+3    INSTRUCTIONS
      IOR B         FOR 
      STA PT.2+3    THIS
      LDA PR.AD 
      STA 1774B 
      JMP PR.X,I    DRIVER
* 
* 
PR.AD DEF PT.R
* 
PP.X  NOP 
      STA B 
      LDA PP08     SET
      IOR B         DEVICE
      STA PP08      I/O 
      LDA POUT+1    ADDRESS 
      IOR B         IN
      STA POUT+1    ALL 
      LDA POUT+2    I/O 
      IOR B         INSTRUCTIONS
      STA POUT+2    FOR 
      LDA POUT+3    THIS
      IOR B         DRIVER
      STA POUT+3
      LDA PP04
      IOR B 
      STA PP04
      LDA PP.AD 
      STA 1776B 
      JMP PP.X,I
* 
PP.AD DEF PT.P
* 
* 

* 
* SECTION  * STEQT *
* 
* THIS SECTION CONSTRUCTS THE IOC  SYSTEM EQUIPMENT 
*  TABLE AND EQUIPMENT TABLE FROM PARAMETERS
*  SUPPLIED BY THE CONFIGURATOR (OPERATOR). 
* 
* THIS SECTION IS ENTERED AFTER THE PROGRAM *IOC* 
*  IS LOADED. AFTER THE INPUT STATEMENT  * /E * IS
*  READ, CONTROL IS RETURNED TO THE LOADING SECTION.
* 
* THE ORDER OF PARAMETER INPUT IS:
* 
*   OUTPUT:  * TABLE ENTRY
* 
*A.             EQUIPMENT TABLE (EQT) ? 
* 
*   INPUT FORMAT: NN,D.XX(,D)(,UX) - PARAMETERS IN
*                 PARENTHESES ARE OPTIONAL
* 
*              NN - HARDWARE I/O ADDRESS - OCTAL
*              D.XX - DRIVER NAME FOR DEVICE
*              D    - DMA CHANNEL REQUIRED FOR DEVICE 
*              UX   - DESIGNATES UNIT NUMBER FOR
*                     ADDRESSING DEVICE.
* 
*               : /E - TERMINATES  EQU  INPUT.
* 
*B. OUTPUT:    SYSTEM EQUIPMENT TABLE ? 
* 
*              KEYBOARD INPUT?
* 
*   INPUT:     N1  (-EQT ORDINAL OF APPROPRIATE DEVICE) 
* 
*   OUTPUT:    TELETYPE OUTPUT? 
* 
*   INPUT      N2 
* 
*   OUTPUT:    PROGRAM LIBRARY? 
* 
*   INPUT:     N3 
* 
*   OUTPUT:    PUNCH OUTPUT?
* 
*   INPUT:     N4 
* 
*   OUTPUT:    STANDARD INPUT?
* 
*   INPUT:     N5 
* 
*   OUTPUT:    LIST OUTPUT
* 
*   INPUT:     N6 
* 
*C. OUTPUT:   DMA CHANNELS? 
* 
*   INPUT:   1) 0 (ZERO)  MEANS NO DMA IN CONFIGURATION 
* 
*            2) 6[,7]    6 IF ONE DMA CHANNEL AVAILABLE 
*                        7 IF SECOND DMA AVAILABLE
* 
* 
* ERRORS ENCOUNTERED IN INPUT STATEMENTS RESULT IN
*  THE DIAGNOSTIC:    * ERROR    IS PRINTED AND THE 
*  SYSTEM WAITS FOR THE INPUT TO BE REPEATED. 
* 
* 
* AFTER PROCESSING OF THIS SECTION IS COMPLETED,
*  THE MEMORY OCCUPIED BY THE SECTION IS
*  RELEASED TO ALLOW FOR MORE AREA TO LOAD
*  BCS MODULES. MEMORY IS RELEASED TO BEGIN AT
*  THE WORD FOLLOWING THE LAST DRIVER ROUTINE.
* 
      ORG 4 
      HLT 4,C       SET POWER FAIL HALT IN 4
      HLT 5          AND 5. 
* 
* 
* 
* 
      ORG 4000B 
* 
* 
STEQT JSB SPACE 
      LDA ML6      OUTPUT MESSAGE 
      LDB ML6+1    - * TABLE ENTRY
      JSB LIST,I     EQUIPMENT TABLE ? -
* 
       HLT 11B       TURN OFF READER. 
* 
* 
      CLA          INITIALIZE 
      STA DMAF      DMA USAGE AND 
      STA UNIT      UNIT WORD 
      STA EQTA,I   SET EQT COUNT WORD = 0.
* 
ST.1  JSB KBINX,I   INPUT STATEMENT FROM KEYBOARD.
      JSB GETCX,I  GET FIRST CHAR.
      JMP ST.EQ     ERROR - NULL STATEMENT
      CPA SLASH    CHECK FOR  /E STATEMENT. 
      RSS           / 
      JMP ST.2     NO, PROCESS AS EQT ENTRY 
      JSB GETCX,I  GET NEXT CHAR. 
      JMP ST.EQ     ERROR - 
      CPA E        IF CHAR = E, THEN GO TO
      JMP ST.5      PROCESS SQT PARAMETERS. 
* 
ST.2  JSB BINT,I   RE-INITIALIZE BUFFER SCAN. 
      LDB C.02     CONVERT 2-DIGIT
      JSB CNVX,I   I/O ADDRESS. 
      JMP ST.1     -ERROR, NON-NUMERIC. 
      SZB          IF NUMBER = 0 OR IF STATEMENT
      SZA,RSS       TERMINATED, 
      JMP ST.EQ      ERROR. 
* 
      STA IOADR    SAVE I/O ADDRESS.
      JSB GETCX,I  GET FIRST CHAR. NEXT FIELD 
      JMP ST.EQ    - ERROR - END OF STATEMENT 
      CPA D        IF CHAR. IS NOT A
      RSS            D, 
      JMP ST.EQ     THEN ERROR
      JSB GETCX,I  GET NEXT CHAR. 
      JMP ST.EQ    - ERROR - END OF STATEMENT 
      CPA PER.     IF CHAR. IS NOT A
      RSS           .,
      JMP ST.EQ     THEN ERROR. 
      LDB C.02     CONVERT XX PART OF DRIVER
      JSB CNVX,I   NAME.
      JMP ST.1     -ERROR - NOT NUMERIC 
      STA ETYPE    SAVE XX - EQUIPMENT TYPE 
      SZB,RSS      IF END-OF-STATEMENT, 
      JMP ST.4       GO TO COMPLETE EQT ENTRY.
      JSB GETCX,I  GET CHAR. OF OPTIONAL FIELD
      JMP ST.EQ    -ERROR, END OF STATEMENT.
      CPA D        IF CHAR. IS NOT A -D-, 
      RSS           FOR DMA REQUIRED, 
      JMP ST.3       CHECK FOR A -U-. 
      STA DMAF     SET DMAF NON-ZERO. 
      JSB GETCX,I  GET NEXT CHAR. 
      JMP ST.4     -END OF STATEMENT, COMPLETE ENTRY
      CPA COMMA    IF CHAR. IS NOT
      RSS           A COMMA, THEN 
      JMP ST.EQ      ERROR. 
      JSB GETCX,I  GET NEXT FIELD,  UX .
      JMP ST.4     -END OF STATEMENT. 
ST.3  CPA U        IF CHAR. IS NOT A
      RSS            -U-, 
      JMP ST.EQ      THEN ERROR.
      CLB,INB      CONVERT 1-DIGIT UNIT NUMBER. 
      JSB CNVX,I
      JMP ST.1     -ERROR, NOT NUMERIC, REPEAT. 
      ALF          SHIFT UNIT NUMBER
      ALS,ALS       TO BITS 08-06 AND 
      STA UNIT      SAVE IT.
* 
* CONSTRUCT EQT ENTRY 
* 
ST.4  CLA          CONSTRUCT
      CLB            WORD 1 OF EQT ENTRY
      CPB DMAF     IF DMA REQUIRED FOR DEVICE,
      RSS 
      IOR MSIGN     SET BIT 15 = 1. 
      IOR UNIT     SET UNIT NUMBER IN BITS 08-06. 
      IOR IOADR    SET I/O ADDRESS IN BITS 05-00, 
      STA EQTX,I    AND STORE WORD 1. 
      ISZ EQTX     SET ADDRESS FOR WORD 2.
      LDA ETYPE    POSITION EQUIPMENT TYPE, XX PART 
      ALF,ALF       OF D.XX (DRIVER NAME) AN
      STA EQTX,I     SET WORD 2, O FIELD = 0. 
      ISZ EQTX     SET WORDS
      STB EQTX,I     3
      ISZ EQTX        AND 
      STB EQTX,I       4 = ZERO.
* 
      ISZ EQTA,I   COUNT ENTRY
      ISZ EQTX     SET EQTX FOR NEXT ENTRY
      CLA          CLEAR DMAF 
      STA DMAF      AND UNIT FOR NEXT 
      STA UNIT       STATEMENT
      JMP ST.1        PROCESSING. 
* 
* SYSTEM EQUIPMENT TABLE PROCESSING 
* 
ST.5  LDA CM.6     SET T1 = -6 FOR INDEX
      STA T1        OF 6 PARAMETERS 
      LDA SQTMS    SET T2 = ADDRESS OF SQT
      STA T2        MESSAGE BLOCK.
      LDA EQTX     SET STARTING ADDRESS 
      STA SQTA      OF SQT. 
* 
ST.6  JSB SPACE 
      LDA ML7      OUTPUT - SYSTEM EQUIPTMENT 
      LDB ML7+1      TABLE?.
      JSB LIST,I
ST.7  LDA T2,I     OUTPUT CURRENT 
      ISZ T2        SYSTEM DEVICE NAME
      LDB T2,I
      ISZ T2
      JSB LIST,I
ST.71 JSB KBINX,I  GET PARAMETER INPUT. 
      LDB C.02     CONVERT 2
      JSB CNVX,I   DIGIT EQT ORDINAL. 
      JMP ST.SQ    NULL STATEMENT - ERROR.
      STA EQTX,I   SET EQT ORDINAL IN SQT ENTRY 
      ADA CM.7     IF EQT ORDINAL 
      SSA            NOT GT OR = 7, THEN
      JMP ST.SQ       ERROR.
      ISZ EQTX   ADD 1 TO SQT TABLE ADDRESS.
      ISZ T1       INDEX FOR 6 ENTRIES
      JMP ST.7      IN SQT. 
* 
      LDA EQTA,I   GET NUMBER OF EQT ENTRIES. 
      ALS,ALS       DETERMINE NO. OF WORDS
      CMA           AND SET NEGATIVE FOR INDEXING 
      STA T1         MOVE OF EQT TO HIGH MEMORY.
      INA          DETERMINE STARTING ADDRESS OF
      ADA LWAM      EQT - SUBTRACT NO. WORDS-1 FROM 
      STA T2         LWA AVAIL. MEM. - SET IN T2. 
      LDB EQTA     (B) = CURRENT EQT STARTING ADDR. 
      STA EQTA     SET NEW EQT ADDRESS. 
      ADA CM.1     SET NEW LWA AVAIL. 
      STA LWAM      MEMORY. 
ST.8  LDA B,I      MOVE EQT TO HIGH MEMORY
      STA T2,I      JUST BELOW PROGRAM
      INB            IOC. 
      ISZ T2
      ISZ T1
      JMP ST.8
* 
      LDA CM.6     SET T1 = -6 FOR MOVING SQT TO
      STA T1        JUST BELOW EQT. 
      ADA LWAM     SET NEW LWA AVAIL. 
      STA LWAM      MEMORY  ( SQT - 1). 
      INA          SET ADDRESS OF SQT IN SQTA 
      LDB SQTA      AND SET B = CURRENT ADDRESS 
      STA SQTA       OF SQT.
      STA T2
ST.9  LDA B,I      MOVE SQT TO
      STA T2,I      HIGH MEMORY 
      INB            JUST BELOW 
      ISZ T2          EQT.
      ISZ T1
      JMP ST.9
      LDB .SQT     FIND ENTRY POINT  SQT
      JSB SRLST     IN PCS LST. 
      JMP UNSYX,I    ERROR - NOT FOUND
      LDA SQTA     SET ABSOLUTE ADDRESS OF SQT
      STA LST4,I    AS ENTRY POINT ADDRESS-WORD 4 
* 
      LDB .EQT     FIND ENTRY POINT EQT 
      JSB SRLST     IN PCS LST. 
      JMP UNSYX,I    ERROR- NOT FOUND.
      LDA EQTA     SET ABSOLUTE ADDRESS OF EQT
      STA LST4,I    AS ENTRY POINT ADDRESS-WORD 4.
* 
* GET DMA CHANNEL PARAMETERS
* 
      CLA          SET DMA1 AND DMA2 = 0 FOR
      STA DMA1     NO DMA 
      STA DMA2       USAGE
      JSB SPACE 
      LDA ML8      OUTPUT - DMA CHANNELS? - 
      LDB ML8+1 
      JSB LIST,I
ST.10 JSB KBINX,I  GET REPLY
      CLB,INB      CONVERT FIRST
      JSB CNVX,I   PARAMETER. 
      JMP ST.10     ERROR - NOT NUMERIC.
      SZA,RSS      IF REPLY = 0, THEN NO
      JMP ST.11     DMA USAGE.
* 
      STA DMA1     SET ADDRESS OF CHANNEL 1.
      CPA C.06     SHOULD = 6.
      RSS          YES
      JMP ST.DM    NO,ERROR 
      SZB,RSS      IF NO CHANNEL 2, 
      JMP ST.11     GO TO COMPLETE DMA SET-UP.
      CLB,INB      CONVERT PARAMETER
      JSB CNVX,I    FOR CHANNEL 2.
      JMP ST.10    ERROR - NOT NUMERIC
      STA DMA2     SET ADDRESS OF CHANNEL 2.
      CPA C.07     SHOULD = 7.
      RSS          YES. 
      JMP ST.DM    NO, ERROR. 
* 
ST.11 LDB XDMA1    FIND ENTRY POINT DMAC1 IN
      JSB SRLST     PCS LST.
      JMP UNSYX,I    NOT FOUND, ERROR.
      LDA LST4,I   A = ADDRESS OF DMAC1.
      LDB DMA1     SET  (DMAC1) = 
      STB A,I        000006.
* 
      LDB XDMA2    REPEAT FOR  DMAC2. 
      JSB SRLST 
      JMP UNSYX,I    NOT FOUND, ERROR 
      LDA LST4,I
      LDB DMA2     SET  (DMAC2) = 
      STB A,I        000007.
* 
* 
* SET ADDRESSES OF EQT AND SQT INTO PROGRAM  IOC
*  AT ENTRY POINTS  XEQT AND  XSQT, RESPECTIVELY. 
* 
      LDB XEQT     FIND ENTRY POINT  -XEQT-.
      JSB SRLST 
      JMP UNSYX,I    NOT FOUND, ERROR.
      LDA LST4,I   GET ADDRESS OF  XEQT,
      LDB EQTA      AND STORE ADDRESS OF
      STB A,I       EQT AT THAT LOCATION. 
* 
      LDB XSQT     FIND ENTRY POINT  -XSQT-.
      JSB SRLST 
      JMP UNSYX,I    NOT FOUND, ERROR.
      LDA LST4,I   GET ADDRESS OF XSQT, 
      LDB SQTA      AND STORE ADDRESS OF
      STB A,I       SQT AT THAT LOCATION. 
* 
      LDA ST.13    SET FWA AVAIL. MEM IN PCS LDR
      STA FWAM      TO RELEASE  -STEQT-  SECTION. 
* 
      JMP *+1,I    RETURN TO
      DEF LS2       CONTROL SECTION.
* 
.SQT  DEF *+1 
      ASC 1,.S
      ASC 1,QT
      OCT 27000 
* 
.EQT  DEF *+1 
      ASC 1,.E
      ASC 1,QT
      OCT 27000 
* 
* 
* 
ML6   DEC 22
      DEF *+1 
      ASC  7,* TABLE ENTRY
      OCT 6412   (RETURN-LINE FEED) 
      OCT 12      (NULL - LINE FEED)
      ASC 2,EQT?
ML7   DEC 4 
      DEF *+1 
      ASC 2,SQT?
* 
SQTMS DEF *+1 
      DEC 6 
      DEF SQ1 
      DEC 5 
      DEF SQ2 
      DEC 5 
      DEF SQ3 
      DEC 7 
      DEF SQ4 
      DEC 7 
      DEF SQ5 
      DEC 6 
      DEF SQ6 
* 
SQ1   ASC 3,-KYBD?
SQ2   ASC 3,-TTY? 
SQ3   ASC 3,-LIB? 
SQ4   ASC 4,-PUNCH? 
SQ5   ASC 4,-INPUT? 
SQ6   ASC 3,-LIST?
* 
* 
C.07  DEC 7 
CM.7  DEC -7
ML8   DEC 4 
      DEF *+1 
      ASC 2,DMA?
* 
IOADR OCT 0 
ETYPE OCT 0 
DMAF  OCT 0 
UNIT  OCT 0 
U     OCT 125 
ST.EQ JSB ERRPT 
      JMP ST.1
* 
ST.SQ JSB ERRPT 
      JMP ST.71 
* 
ST.DM JSB ERRPT 
      JMP ST.10 
* 
* 
XEQT  DEF *+1 
      ASC 2,XEQT
      OCT 20000 
* 
XSQT  DEF *+1 
      ASC 2,XSQT
      OCT 20000 
* 
XDMA1 DEF *+1 
      ASC 1,DM
      ASC 1,AC
      OCT 30400 
* 
XDMA2 DEF *+1 
      ASC 1,DM
      ASC 1,AC
      OCT 31000 
* 
* 
DMA1  OCT 0 
DMA2  OCT 0 
* 
KBINX DEF KBIN
CNVX  DEF CONVX 
GETCX DEF GETC
UNSYX DEF UNSYM 
BINT  DEF BINIT 
ST.13 DEF ST.12 
* 
* 
* 
* 
PCS1  LIA 01       GET SWITCH REGISTER
      AND M77       FOR TELETYPE PUNCH I/O ADDRESS. 
      JSB TT.XX,I SET I/O INSTRUCTIONS IN DRIVER. 
* 
      JSB SPACE 
      LDA ML1      OUTPUT MESSAGE 
      LDB ML1+1     -HIGH SPEED INPUT?
      JSB LIST,I
* 
PCS2  JSB KBINX,I  GET REPLY FROM KEYBOARD
      LDB C.02     CONVERT FOR ZERO OR 2-DIGIT
      JSB CNVX,I   I/O ADDRESS
      JMP PCS2     -ERROR, REPEAT INPUT.
* 
      SZA,RSS      IF TTY READER IS TO BE USED, = 0,
      JMP PCS3      GO CHECK FOR HIGH-SPEED PUNCH.
      JSB PR.XX,I  SET ADDRESS FOR HS INPUT.
* 
PCS3  LDA ML2      OUTPUT MESSAGE-
      LDB ML2+1    -HIGH SPEED OUTPUT?- 
      JSB LIST,I
* 
PCS4  JSB KBINX,I  GET REPLY FROM KEYBOARD
      LDB C.02     CONVERT FOR ZERO OR 2-DIGIT
      JSB CNVX,I   I/O ADDRESS. 
      JMP PCS4     -ERROR, REPEAT INPUT 
* 
      SZA,RSS      IF TTY PUNCH IS TO BE USED, = 0, 
      JMP PCS5      GO TO NEXT SECTION. 
      JSB PP.XX,I  SET ADDRESS FOR HS PUNCH.
* 
PCS5  JSB SPACE 
      LDA ML3      OUTPUT MESSAGE 
      LDB ML3+1     -FWA MEMORY?- 
      JSB LIST,I
PCS6  JSB KBINX,I  GET REPLY FROM KEYBOARD. 
      LDB C.03     CONVERT
      JSB CNVX,I   BASE PAGE ADDRESS. 
      JMP PCS6     -ERROR, REPEAT INPUT.
* 
      STA FWABP    SET FOR FWA BASE PAGE, AND FOR 
      STA LINKA     START OF BASE PAGE LINKAGE AREA.
      ADA M1000    INSURE THAT ADDRESS
      SSA           IS LESS THAN 1000(8). 
      JMP PCS7     -YES-
      JSB ERRPT    -NO, PRINT ERROR 
      JMP PCS5       AND REPEAT INPUT 
* 
PCS7  LDA ML4      OUTPUT MESSAGE.
      LDB ML4+1    -LWA MEMORY?-
      JSB LIST,I
* 
PCS8  JSB KBINX,I  GET REPLY FROM KEYBOARD. 
      LDB C.05     CONVERT 5-DIGIT
      JSB CNVX,I   LWA OF AVAILABLE MEMORY. 
      JMP PCS8     -ERROR, REPEAT INPUT.
* 
      STA LWAM     SET LWA IN LWAM
      STA LWAM1     AND LWAM1.
      SZA          IF LWA 
      JMP PCS9      = 0,
      JSB ERRPT     THEN TREAT
      JMP PCS7       AS ERROR 
* 
PCS9  LDA PCS10    RELEASE THIS 
      STA FWAM      SECTION TO THE PCS LOADER.
      JMP *+1,I    EXIT TO
      DEF LS2      MAIN CONTROL.
* 
PCS10 DEF PCS1     DEFINE STARTING ADDR. OF SECTION 
* 
* 
TT.XX DEF TT.X
* 
PR.XX DEF PR.X
* 
PP.XX DEF PP.X
* 
* 
ML1   DEC 7 
      DEF *+1 
      ASC 4,HS INP? 
ML2   DEC 7 
      DEF *+1 
      ASC 4,HS PUN? 
ML3   DEC 8 
      DEF *+1 
      ASC 4,FWA MEM?
ML4   DEC 8 
      DEF *+1 
      ASC 4,LWA MEM?
* 
M1000 OCT -1000 
* 
* 
* THE FOLLOWING DEFINES THE INITIAL LWA 
*  OF PCS TO SET FWA AVAIL. MEMORY IN 
*  PCS LOADER.
* 
XPCS  EQU * 
* 

********* FORCE LOADER SECTION INTO BASE PAGE ********* 
* 
      ORG 600B
* 
******************************************************* 
* 
****************************************
* 
* RELOCATABLE LOADER SECTION FOR THE
*  -PREPARE CONTROL SYSTEM-  PROGRAM. 
* 
* THIS SECTION IS A MODIFIED VERSION OF 
*  THE FULL BCS RELOCATABLE LOADER. 
* 
* THIS SECTION IS CONTAINED ENTIRELY
*  WITHIN BASE PAGE.
* 
* 
* 
* FOLLOWING WORD DEFINES THE STARTING POINT 
*  OF THE LOADER SYMBOL TABLE FOR THE PCS 
*  LOADER.  THE TABLE EXTENDS TOWARD LOW MEMORY 
*  AS IT IS BUILT.  THE WORD AT  -LST- CONTAINS 
*  THE NUMBER OF 5-WORD ENTRIES IN THE TABLE. 
* 
LWA   EQU *-1      TO SET LWA BASE PAGE FOR LOADER. 
* 
      OCT 0 
      OCT 0        DEFINE 
      OCT 27000        LST ENTRY
      ASC 1,QT          FOR 
      ASC 1,.E          - .EQT. - 
* 
      OCT 0 
      OCT 0        DEFINE 
      OCT 27000        LST ENTRY
      ASC 1,QT           FOR
      ASC 1,.S         - .SQT. -
* 
LST   DEC 2        2 FIXED LST ENTRIES
* 
* 
* 
* INPUT RECORD, LEGALITY CHECK AND CHECKSUM SECTION 
* 
* 
LDRIN LDA CM60     CALL FOR BINARY RECORD 
      LDB LBUFA     INPUT  (MAX. - 60 WORDS ) 
      JSB INPT,I    INTO LBUF.
* 
      SZA          IF A NOT = 0, GO 
      JMP LDR1      TO PROCESS RECORD.
* 
      CPA RIC      END OF TAPE - IGNORE IF FIRST
      JMP LDRIN     RECORD NOT READ.
      STA RIC      CLEAR RIC FOR NEXT TAPE
* 
      LDB EOTA     PRINT MESSAGE
      LDA EOTA+1    * END OF TAPE 
      JSB LOUT      AND 
      HLT 0        HALT.
      JMP LDRIN    ON RESTART, GET NEXT RECORD. 
* 
* 
* 
* CHECK RECORD LEGALITY 
* 
LDR1  LDA LBUF+1   GET WORD 2 OF RECORD,
      ALF,RAR       ROTATE RIC FIELD TO 
      AND M.07      LOW A AND ISOLATE CODE. 
      STA RIC      SAVE CODE FOR PROCESSING.
      SZA          IF RIC = 0, SKIP 
      ADA CM.6     SUBTRACT 6 TO TEST FOR  1 TO 5.
      SSA,RSS      IF RESULT IS POSITIVE OR 
      JMP LER2        ZERO, ERROR. ILLEGAL RECORD.
* 
* LEGAL RECORD -  COMPUTE AND CHECK CHECKSUM
* 
      LDB LBUF     GET RECORD 
      BLF,BLF       WORD COUNT
      CMB,INB        AND SUBTRACT 
      ADB C.03        3 FOR USE AS COUNTER
      SSB,RSS      (PROTECTION AGAINST
      JMP LDR2       LT 4-WORD RECORD)
      LDA LBUF+1       IN COMPUTING 
      STB LBUF          CHEKSUM 
      LDB LBUFA    SET B = ADDRESS
      ADB C.03      OF WORD 4.
      ADA B,I      ADD
      INB           REMAINING 
      ISZ LBUF       WORDS IN 
      JMP *-3         RECRD - SUM INA 
      CPA LBUF+2   COMPARE SUM TO CHECKSUM IN RECORD
      JMP LDRC      EQUAL, ASSUME RECORD GOOD.
* 
* CHECKSUM ERROR
* 
LDR2  LDA ERR01    SET ERROR CODE 01
      JSB DIAG     PRINT DIAGNOSTIC  *L01 
      HLT 03       ERROR HALT-
      JMP LDRIN     RESTART TO RE-READ. 
* 
LER2  LDA ERR02    ILLEGAL RECORD ERROR 
     JSB DIAG      -PRINT   *L02
     JMP LDR2+2   GO TO HALT AND RE-READ. 
* 
LDRC  LDA RIC      (A) = RECORD TYPE
      LDB PLFLG    (B) = PROGRAM LOADING FLAG 
      CPA C.01     IF RIC = 1, THEN GO TO PROCESS 
      JMP LDRC3     NAM RECORD. 
      SSB,RSS      IF FLAG = 0 (NOT LOADING), THEN
      JMP LDRC8     RECORD-OUT-OF-SEQUENCE OR LIB-
      CPA C.02       RARY SKIP. IF RIC = 2, THEN
      JMP ENTR      GO PROCESS ENT RECORD.
LDRC2 CPA C.03     IF RIC = 3, GO TO
      JMP DBLR       DBL RECORD PROCESSOR.
      CPA C.04     IF RIC = 4, GO TO
      JMP EXTR       EXT RECORD PROCESSOR.
* 
* END  RECORD  PROCESSOR
* 
ENDR1 JSB LSTI     INITIALIZE LST PROCESSOR 
ENDR2 JSB LSTP     SET LST ENTRY ADDRESSES. 
      JMP ENDR3    -END OF LST. 
      LDA LST3,I   GET WORD 3 OF EACH 
      AND UPCM      LST ENTRY - CLEAR BITS 07-00
      STA LST3,I    (EXT ORD FIELD) AND RESET.
      JMP ENDR2     REPEAT THRU LST.
* 
ENDR3 CLA          SET PLFLG AND RIC
      STA PLFLG     = 0 FOR NEXT
      STA RIC       PROGRAM LOAD. 
      JMP *+1,I       RETURN TO 
      DEF LSEQ         PCS CONTROL ******** 
* 
* PROCESSING NAM RECORD SECTION.
* 
LDRC3 SZB         IF PLFLG NOT = 0, THEN NAM RECORD 
      JMP LDRC8     OUT OF ORDER -  ERROR.
* 
      LDA CM.9      SET TO
      STA LBUF+57    MOVE  9 WORD 
      LDA NBUFA       NAM RECORD
      STA LBUF+58      TO 
      LDB LBUFA         NBUF. 
* 
      LDA B,I        MOVE NAM 
      STA LBUF+58,I    RECORD 
      ISZ LBUF+58      TO 
      INB              NAM
      ISZ LBUF+57       BUFFER
      JMP *-5            AREA 
* 
      CCA           SET PLFLG AND 
      STA PLFLG      EXMFL = -1 TO SAY
      STA EXMFL       LOAD. 
* 
      JSB NAMR     ALLOCATE MEMORY FOR PROGRAM
      JMP LDRIN    GO TO PROCESS NEXT RECORD. 
* 
LDRC8 LDA ERR09    RECORD OUT OF SEQUENCE 
      JMP ERROR 
* 
* CONSTANT/STORAGE SECTION FOR MAIN CONTROL SECTION.
* 
RIC   OCT 0        HOLDS RECORD IDENTIFICATION CODE 
C.01  OCT 1 
C.02  OCT 2 
C.03  OCT 3 
C.04  OCT 4 
CM.6  DEC -6
M.07  OCT 7 
CM.9  DEC -9
PLFLG OCT 0   LOADING FLAG:=0,NO,=-1,YES
EXMFL OCT 0   ENT/EXT MATCH:=-1 DURING INPUT LOADING
* 
UPCM  OCT 177400    MASK FOR UPPER 8-BITS.
M.37  OCT 37
* 
A     EQU 0 
B     EQU 1 
* 
CM60  DEC -60 
* 
EOTA  DEC 5 
      DEF *+1 
      ASC 3,* EOT 
* 
* 
*              - NAMR - 
*  NAME  ( NAM - RIC = 1 ) RECORD PROCESSOR 
* 
* PURPOSE:  1) LIST PROGRAM NAME
* 
*           2) ALLOCATE  MEMORY NEEDED FOR
*               LOADING THE MAIN SECTION OF A 
*               PROGRAM 
* 
*           3) UPDATE MEMORY TABLE TO REFLECT 
*               NEW BOUNDS OF AVAILABLE 
*               MEMORY
* 
*           4) ESTABLISH THE RELOCATION BASES 
*               FOR THE SECTIONS OF A PROGRAM 
* 
*           5) LIST THE ABSOLUTE LOWER AND
*               UPPER BOUNDS OF THE PROGRAM.
* 
* OPERATION:
* 
*  THIS PROCESSOR OPERATES AS A CLOSED  SUB-
*   ROUTINE CALLED BY THE MAIN CONTROL
*   SECTION OF THE LOADER. THE NAM RECORD 
*   IS MOVED FROM LBUF TO NBUF BEFORE THE 
*   PROCESSOR IS ENTERED. CONTROL IS RETURNED 
*   TO P+1 IN THE CALL.  THERE ARE NO ERROR 
*   RETURNS.
* 
* 
NAMR  NOP           ENTRY/EXIT
      JSB SPACE    DOUBLE-SPACE PRINT OUTPUT. 
* 
      LDA NBUFA     WRITE 
      ADA C.03        PROGRAM NAME
      LDB C.05          ON LIST 
      JSB LOUT           DEVICE.
      LDA NBUFA    SET A = ADDRESS OF WORD
      ADA C.03      4 AGAIN - 
      LDB A,I       AND MOVE
      STB NAM        WORDS
      INA             4,5 AND 6,
      LDB A,I         CONTAINING
      STB NAM+1       PROGRAM NAME, 
      INA             TO 3 WORD 
      LDB A,I         AREA AT 
      STB NAM+2      -NAM-. 
* 
* SECTON TO ALLOCATE MEMORY FOR LOADING 
*  PRGRAM - ONLY PROGRAM LENGTH IS USED 
*  TO LOAD (IN WORD 7).  BASE PAGE LENGTH,
*  ORD 8, AND COMMON LENGTH, WORD 9, ARE
*  GNORED AS THESE PROPRTIES ARE MEANINGLESS
* FOR PROGRAM MODULES LOADED BY  -PCS- .
* 
      LDA NBUF+6    GET PROGRAM LENGTH. 
      SZA,RSS       IF LENGTH = 0, THEN 
      JMP LER6      ERROR-
* 
* 
      CMA,INA      SUBTRACT LENGTH FROM LWA AVAIL.
      ADA LWAM      MEMORY TO GET ORIGIN-1 - NEW
      STA B         LWA AVAIL. MEMORY.
      INA          ADD 1 TO GET PROGRAM ORIGIN -
      STA NBUF      SAVE ORIGIN IN NBUF.
      STA PREL     SET ORIGIN IN RBL. 
      CMA,INA      SUBTRACT FROM LWA OF 
      ADA FWAM      PCS PROGRAM - A POSITIVE
      SSA,RSS       RESULT MEANS AVAILABLE MEMORY 
      JMP LER3      EXHAUSTED - GO DIAGNOSE AND HALT
* 
      LDA LWAM     SET CURRENT LWA AS LWA OF
      STA NBUF+1    BLOCK - 
* 
      STB LWAM     SET NEW LWA OF AVAILABLE MEMORY. 
* 
      LDA BOUND    (A) = ADDRESS OF 6-WORD BUFFER.
      LDB NBUF     B) = PROGRAM BLOCK ORIGIN. 
      JSB CONV     CONVERT TO ASCII 
      LDB NBUF+1   (B) = LWA OF PROGRAM BLOCK.
      JSB CONV     CONVERT TO ASCII.
      LDA BOUND    (A) = ADDRESS OF BUFFER
      LDB C.12     (B) = 12 CHARS. IN LENGTH. 
      JSB LOUT     PRINT BOUNDS OF PROGRAM BLOCK. 
* 
      JMP NAMR,I   EXIT PROCESSOR.
* 
LER6  LDA ERR06    PRINT   *L06 
      JMP ERROR     AND HALT. 
* 
* 
* CONSTANT AND STORAGE SECTION FOR -NAMR-.
* 
BOUND DEF LSTPX    DEFINE ADDRESS OF 6-WORD AREA. 
CM.1  DEC -1
* 
NAM   OCT 0,0,0 
* 
* 
* 
*              - DBLR - 
* DATA BLOCK RECORD PROCESSOR (RIC = 3) 
* 
* 
* PURPOSE OF THIS SECTION IS TO ADJUST
*  (RELOCATE) THE LOAD ADDRESS OF  A  DATA
*  BLOCK AND  RELOCATE AND STORE EACH WORD
*  IN THE DATA BLOCK.  THIS SECTION CHECKS
*  THE OPERAND ADDRESS OF EACH MEMORY-REFER-
*  ENCE INSTRUCTION AND, IF THE OPERAND IS
*  NOT IN THE SAME PAGE AS THE INSTRUCTION, 
*  A REQUEST TO SUBROUTINE  *LINK* IS MADE
*  TO ALLOCATE A WORD IN BASE PAGE TO HOLD
*  THE OPERAND ADDRESS. THE INSTRUCTION IS
*  THEN ALTERED TO INDIRECTLY REFERENCE THE 
*  LINKAGE WORD IN BASE PAGE. 
* 
* A RELOCATION BYTE IS ASSOCIATED WITH EACH 
*  INSTRUCTION OR DATA WORD IN A DBL RECORD.
*  THIS 3-BIT BYTE CONTAINS ONE OF THE
*  FOLLOWING RELOCATION INDICATORS: 
* 
*         000   ABSOLUTE
*         001 -  PROGRAM RELOCATABLE
*         010 -  BASE PAGE RELOCATABLE
*         011 -  COMMON RELOCATABLE 
*         100 -  EXTERNAL SYMBOL REFERENCE
*         101 -  2-WORD MEMORY REFERENCE
*                 GROUP- WORD 1 CONTAINS
*                 OP-CODE AND A RELOCATION
*                 BYTE IN THE OPERAND FIELD,
*                 WORD 2 CONTAINS THE FULL
*                 15-BIT ADDRESS OF THE 
*                 REFERENCED OPERAND. 
*                  THE RELOCATION BYTE IN 
*                 WORD 1 IS ONE OF THE
*                 FOLLOWING VALUES: 
*                    00 - PROGRAM 
*                    01 - BASE PAGE 
*                    10 - COMMON
* 
* THE SECTION USES THE RELOCATION BASE
*   TABLE  (RBT) TO RELOCATE THE LOAD 
*   ADDRESS AND DATA WORDS. THE RELOCATION
*   BASES IN THE RBT ARE SET BY THE NAM 
*   RECORD PROCESSOR. THE TABLE IS STRUCTURED 
*   AS: 
*      RBTA  DEF *+1
*      RBT   OCT 0  (ABSOLUTE)
*      PREL  (PROGRAM ORIGIN - FWA) 
*      BPREL (BASE PAGE ORIGIN (FROM ORB) 
*      COMOR (COMMON AREA ORIGIN) 
* 
* 
DBLR  LDB PREL     SET (B) = PROGRAM RELOCATION BASE
      ADB LBUF+3   ADD LOAD ADDR. TO RELOCATION BASE
      STB LBUF      AND SAVE. 
      LDA LBUF+1   GET WORD 2 AGAIN, ISOLATE
      AND M77        COUNT FIELD, SET NEGATIVE
      CMA,INA        FOR COUNTER AND
      STA LBUF+1     SAVE.
      LDA LBUFA    SET ADDRESS OF WORD 5 OF DBL 
      ADA C.04      RECORD (FIRST RELOC. BYTE WORD) 
      STA LBUF+2    IN LBUF+2.
* 
DBL1  LDB LBUF+2,I  SET RELOCATION BYTE WORD
      STB LBUF+3     IN LBUF+3. 
      LDA CM.5      SET BYTE COUNTER
      STA NBUF        = -5
      ISZ LBUF+2    SET ADDRESS FOR FIRST DATA WORD.
* 
DBL2  LDA LBUF+3    GET RELOC. BYTE WORD - ROTATE 
      ALF,RAR        3-BIT BYTE FOR NEXT INSTR. TO
      STA LBUF+3     LOW A AND RESTORE WORD.
      AND M.07      ISOLATE BYTE. 
      CPA C.04      IF BYTE = 4, THEN GO TO EXTERNAL
      JMP DBL4       REFERENCE SECTION. 
      CPA C.05      IF BYTE = 5, THEN GO TO 2-WORD
      JMP DBL6       MEMORY REFERENCE GROUP SECTION.
      ADA RBTA      BYTE = 0-3. ADD ADDR. OF RBT
      LDA A,I        TO BYTE AND GET BASE VALUE.
      ADA LBUF+2,I  ADD DATA WORD TO RELOCATION BASE. 
DBL3  STA LBUF,I    STORE WORD IN MEMORY AT LOAD ADDR 
      ISZ LBUF+1    INDEX DATA WORD COUNT.
      RSS            MORE IN RECORD.
      JMP LDRIN     END OF RECORD.  EXIT TO CONTROL.
      ISZ LBUF     ADD 1 TO LOAD ADDRESS
      ISZ LBUF+2   ADD 1 TO RECORD ADDRESS
      ISZ NBUF     INDEX REL-BYTE COUNTER 
      JMP DBL2      MORE BYTES IN WORD
      JMP DBL1     GET NEXT BYTE WORD.
* 
* RELOCATION BASE TABLE  ( RBT )
* 
RBTA  DEF *+1   DEFINES ADDRESS OF RBT
RBT   OCT 0      ABSOLUTE 
PREL  OCT 0      PROGRAM RELOCATION 
BPREL OCT 0      BASE PAGE RELOCATION 
COMOR OCT 0      COMMON RELOCATION
* 
* CONTROL SECTION FOR PROCESSING
*  INSTRUCTIONS  ( OR A DEF ) REFERENCING 
*  AN EXTERNAL SYMBOL.
* 
DBL4  LDA LBUF+2,I   GET INSTR. WORD
      AND K377      ISOLATE  EXT ORDINAL
      STA NBUF+1     AND SAVE 
      JSB LSTI     INITIALIZE  LST PROCESSOR
DBL5  JSB LSTP     SET LST ENTRY ADDRESSES. 
* 
* FOLLOWING WORD IS A 2000(8) WHICH IS USED AS A
*  NOP CODE TO IGNORE END OF LST RETURN FROM -LSTP- 
*   AND IS USED AS A MASK TO SET THE Z BIT OF 
*    AN INSTRUCTION = 1 (CURRENT PAGE). 
* 
M2000 OCT 2000
* 
      LDA LST3,I   GET WORD 3 OF LST ENTRY, ISOLATE 
      AND K377      BITS 07-00, AND COMPARE VALUE TO
      CPA NBUF+1    SAVED EXT ORDINAL 
      RSS          EQUAL - LST ENTRY FOR EXT FOUND
      JMP DBL5     NOT FOUND, KEEP SEARCHING LST
      LDB LST5,I   GET EXT LINK ADDR. IN BASE PAGE
      LDA LBUF+2,I  GET INSTRUCTION, REMOVE  EXT
      AND M174       ORDINAL,  SET  I = 1 FOR AN
      IOR MSIGN      INDIRECT REFERENCE, PUT LINK 
      ADA B          ADDRESS IN BITS 09-00 AND GO 
      JMP DBL3       TO STORE INSTRUCTION WORD. 
* 
* 2-WORD MEMORY REFERENCE GROUP PROCESSOR 
* 
DBL6  LDA LBUF+2,I   GET WORD 1 (OP-CODE,REL. BYTE) 
      ISZ LBUF+2     SET ADDR. TO WORD 2
      LDB PREL      SET B = PROGRAM RELOCATION
      ADB LBUF+2,I  ADD BASE TO WORD 2- OPERAND ADDR. 
      AND M174     REMOVE REL. BYTE FROM INSTR. 
      SSA           IF INSTR. IS INDIRECT THEN SET
      ADB MSIGN      I-BIT OF OPERAND ADDRESS.
      STA NBUF+2    SAVE INSTRUCTION
      LDA LBUF      GET LOAD ADDRESS, ISOLATE AND 
      AND M076       SAVE MODULE/PAGE ADDRESS.
      STA NBUF+1
      LDA B         GET OPERAND ADDR. AND ISOLATE 
      AND M076       MODULE/PAGE ADDR.
      CPA NBUF+1    IF MODULE/PAGE ADDRESSES EQUAL, 
      JMP DBL7       THEN OPERAND IS IN SAME PAGE.
      LDA B         NOT IN SAME PAGE- SET (A) = OPER- 
      JSB LINK       AND ADDRESS AND ESTABLISH LINK.
      LDA NBUF+2    (B) =LOCATION OF LINK,(A) = INSTR.
      IOR MSIGN      SET  I = 1 (INDIRECT) AND
      IOR B          -OR- LINK ADDRESS TO  09-00. 
      JMP DBL3      GO TO STORE WORD. 
* 
* OPERAND IN SAME PAGE AS INSTRUCTION.
* 
DBL7  LDA B        SET (A) = OPERAND ADDRESS
      AND M1777     ISOLATE PAGE AREA ADDRESS.
      IOR M2000    SET Z BIT = 1 (CURRENT PAGE) 
      IOR NBUF+2   -OR- IN I AND OP-CODE
      JMP DBL3     GO TO STORE WORD.
* 
* CONSTANT AND STORAGE SECTION FOR -DBLR-.
* 
CM.5  DEC -5
C.05  DEC 5 
M77   OCT 77
M100  OCT 100 
K377  OCT 377 
M1777 OCT 1777
M076  OCT 76000 
M174  OCT 174000
MSIGN OCT 100000
* 
* 
* SUBROUTINE:   LINK  (ALLOCATE LINK WORD)
* 
* PURPOSE: TO SEARCH LINKAGE AREA IN BASE PAGE
*          FOR AN EXISTING OPERAND ADDRESS MATCHING 
*          THE PARAMETER OPERAND AND TO ALLOCATE
*          A WORD TO CONTAIN THE OPERAND ADDRESS
*          IF A MATCH IS NOT FOUND. 
* 
*          THE OPERAND ADDRESS PARAMETER IS STORED
*          IN THE LINKAGE WORD IF A MATCH IS NOT
*          FOUND IN THE LINKAGE AREA. 
* 
*          THE OPERAND ADDRESS PARAMETER IS IN
*           THE  A-REGISTER ON ENTRY TO LINK. THE 
*           LOCATION OF THE WORD IN THE LINKAGE 
*           AREA CONTAINING THE OPERAND IS RETURNED 
*           TO THE CALLER IN THE B-REGISTER.
* 
*          THE LINKAGE AREA BEGINS AT THE ADDRESS 
*           CONTAINED IN THE WORD LABELED -LINKA- 
*           AND EXTENDS UP TO, BUT NOT INCLUDING, 
*           THE FIRST WORD ADDRESS OF AVAILABLE 
*           MEMORY IN BASE PAGE. IF, IN ATTEMPTING
*           TO ALLOCATE A NEW LINKAGE WORD, THE 
*           NEW FWA = LWA AVAILABLE MEMORY, THEN
*           NO MORE ROOM IS AVAILABLE IN BASE PAGE
*           AND THE LOADING OPERATION IS TERMINATED.
* 
* CALLING SEQUENCE:        (A) = OPERAND ADDRESS
*                  (P)      JSB LINK
*                  (P+1)   -RETURN- WITH: 
*                             (B)= ADDRESS OF LINK
*                             (A) MEANINGLESS 
* 
* 
LINK  NOP     ENTRY/EXIT POINT
      LDB FWABP   (B)= FWA AVAIL MEM IN BASE PAGE 
      SZA,RSS      IF OPERAND ADDRESS = 0, THEN GO
      JMP LINK2     ALLOCATE A WORD WITHOUT A SEARCH. 
* 
*  SEARCH  THRU LINKAGE ARE-
* 
      LDB LINKA   (B) = STARTING ADDRESS OF AREA. 
LINK1 CPB FWABP    IF CURRENT LINK AREA ADDR. = FWA 
      JMP LINK2     AVAIL. MEMORY IN BASE PAGE, GO
*                   ALLOCATE NEW LINKAGE WORD.
      CPA B,I      CHECK OPERAND ADDRESSES -
      JMP LINK,I    MATCH, EXIT,(B)= ADDRESS OF LINK. 
      INB          SET TO CHECK NEXT
      JMP LINK1     WORD IN LINKAGE AREA. 
* 
*  ESTABLISH NEW  LINK WORD 
* 
LINK2 CPB LWABP    IF FWA AVAIL.MEM = LWA AVAIL. MEM. 
      JMP LER4      THEN NO MORE ROOM IN BASE PAGE. 
      ISZ FWABP    ADD 1 TO FWA AVAIL.MEM ADDRESS.
      STA B,I      STORE OPERAND ADDRESS IN LINK
      JMP LINK,I    WORD (B)  AND  EXIT.
* 
* LINKA HOLDS ABSOLUTE STARTING ADDRESS OF SYSTEM 
*  LINKAGE AREA IN BASE PAGE. VALUE SET BY PCS -
LINKA OCT 0 
* 
* 
* 
* SUBROUTINE:  SRLST - SEARCH LOADER SYMBOL TABLE 
* 
* CALLING SEQUENCE: (B) = ADDRESS OF 3-WORD BLOCK 
*                         CONTAINING SYMBOL FOR 
*                         SEARCH. 
* 
*                   (P)    JSB  SRLST 
*                   (P+1)  -NO MATCH RETURN-
*                   (P+2)  -MATCH - ADDRESSES OF
*                           MATCHING SYMBOL SET IN
*                           LST1 - LST5.
* 
* 
SRLST NOP      ENTRY / EXIT POINT 
      STB SRL      SAVE SYMBOL ADDRESS
      JSB LSTI     INITIALIZE LST PROCESSOR 
* 
SR1   LDB SRL      (B) = ADDR. OF SYMBOL. 
      JSB LSTP      SET LST ENTRY ADDRESSES.
      JMP SRLST,I  END OF LST-EXIT TO P+1.
      LDA LST1,I   GET WORD 1 OF LST ENTRY
      CPA B,I      COMPARE TO WORD 1 OF SYMBOL
      INB,RSS      MATCH - SET ADDR. TO WORD 2, SKIP
      JMP SR1      NO MATCH, GET NEXT ENTRY 
      LDA LST2,I   CHECK NEXT WORD
      CPA B,I       FOR MATCHING
      INB,RSS      YES, SET FOR WORD 3, SKIP
      JMP SR1      NO, GET NEXT ENTRY 
      LDA LST3,I   CHECK WORDS 3 FOR
      CPA B,I       MATCH.
      RSS          YES, SYMBOL FOUND, SKIP
      JMP SR1      NO, GET NEXT ENTRY.
      ISZ SRLST    ADJUST RETURN TO P+2 AND 
      JMP SRLST,I   EXIT. 
* 
SRL   OCT 0 

 
* 
* 
* ENT / EXT RECORDS PROCESSOR 
* 
* PURPOSE OF THIS SECTION IS TO PROCESS ENTRY POINTS
*  AND EXTERNAL SYMBOLS, ADD SYMBOLS TO THE 
*  LST (LOADER SYMBOL TABLE), ESTABLISH A LIKE
*  WORD IN THE LINKAGE AREA TO HOLD THE ENTRY 
*  POINT ADDRESS OF A SYMBOL FOR AN EXT REFERENCE,
*  SET A FLAG IF AN ENTRY POINT FROM A LIBRARY
*  LOAD MATCHES AN UNDEFINED EXTERNAL SYMBOL. 
* 
* AN LST ENTRY CONSISTS OF FIVE WORDS EXTENDING 
*  TOWARDS LOW-NUMBERED MEMORY. FOR EXAMPLE:
* 
*    ADDRESS    WORD      CONTENTS
*    -------    ----    --------------------
*     5760       1      -   S        Y     -
*     5757       2      -   M        B     -
*     5756       3      -   L   EXT ORDINAL-
*     5755       4      - EPT ADDRESS      -
*     5754       5      - EXT LINK ADDRESS -
* 
* ERRORS DETECTED ARE:
*   1. DUPLICATE ENTRY POINTS 
*   2. MEMORY OVERFLOW IN ADDING NEW LST ENTRY
* 
* CONTROL RETURNED FROM THIS SECTION TO -LDRIN-.
* 
* WORDS USED FOR TEMPORARY STORAGE: 
* 
*  LBUF - RECORD TYPE FLAG: =0, ENT.,=1, EXT. 
*  LBUF+1 - NEGATIVE COUNT OF ENT/EXT ENTRIES IN RECORD.
*  LBUF+2 - FIRST WORD ADDRESS OF CURRENT ENTRY.
*  NBUF+2 - HOLDS UPPER CHAR./WORD 3 OF ENTRY.
* 
* SUBROUTINES CALLED: 
*   - LSTI -, - LSTP -, -RELEN-, -LINK- 
* 
ENTR  CLA,RSS   ENT--SET A = 0 FOR FLAG.
* 
EXTR  CLA,INA   EXT--SET A = 1 FOR FLAG.
      STA LBUF  STORE A FOR RECORD TYPE FLAG. 
      LDA LBUF+1   GET AND ISOLATE
      AND M.37     ENTRY COUNT OF RECORD- 
      CMA,INA      SET NEGATIVE FOR 
      STA LBUF+1   COUNTER IN PROCESSING
      LDA LBUFA    SET LBUF+2 = ADDRESS OF
      ADA C.03      FIRST ENTRY 
      STA LBUF+2    IN RECORD 
      JSB LSTI     INITIALIZE LST PROCESSOR 
* 
ENTX1 JSB LSTP     SET LST ENTRY ADDRESSES
      JMP ENTX6    END OF LST- MAKE NEW ENTRY 
* 
*  CHECK LST AND RECORD ENTRIES FOR MATCHING SYMBOLS
* 
      LDB LBUF+2   (B) = RECORD ENTRY ADDR. 
      LDA B,I      GET WORD 1 REC. ENTRY, 
      CPA LST1,I    COMPARE TO WORD 1 LST ENTRY 
      INB,RSS      EQUAL, SET FOR WORD 2. 
      JMP ENTX1    NOT =, CHECK NEXT ENTRY
      LDA B,I      CHECK WORD 2 OF
      CPA LST2,I     THE ENTRIES
      INB,RSS      =, SET FOR WORD 3. 
      JMP ENTX1    NOT =, CHECK NEXT ENTRY. 
      LDA B,I      CHECK UPPER
      AND UPCM      CHARACTER IN
      STA NBUF+2     WORD 3 
      LDA LST3,I      OF BOTH RECORD
      AND UPCM         ENTRY AND
      CPA NBUF+2        LST ENTRY.
      RSS          EQUAL, SYMBOLS MATCH.
      JMP ENTX1    NOT =, CHECK NEXT ENTRY. 
* 
      LDA LBUF     IF RECORD TYPE 
      SZA           IS EXT, 
      JMP ENTX4      GO PROCESS EXT.
*          ENT  RECORD. 
      CPA LST4,I    IF ENT ADDR. IN LST ENTRY = 0,
      JMP ENTX2      GO TO SET ADDR. FROM RECORD. 
* 
      JMP LER7     DUPLICATE ENTRY POINT ERROR -
* 
* ADD ENTRY POINT ADDRESS TO LST ENTRY. 
* 
ENTX2 LDA B,I      GET WORD 3 OF RECORD ENTRY.
      STA LST3,I    AND STORE IN LST WORD 3.
      INB          SET B=ADDR. WORD 4 RECORD ENTRY. 
* 
ENTX3 JSB RELEN   (B) ADDR OF WORD 4 - RELOCATE ADDR
      LDA LST5,I   GET EXT LINK ADDRESS. IF LINK
      SZA           ESTABLISHED, STORE ENT. ADDRESS 
      STB A,I       IN LINK WORD. 
      JMP ENTX5    GO TO COMPLETE ENTRY PROCESSING. 
* 
* EXT RECORD ENTRY MATCHES AN EXISTING LST ENTRY. 
* 
ENTX4 LDA B,I      SET WORD 3 (BITS 07-00 CONTAIN 
      STA LST3,I    EXT ORDINAL) IN LST ENTRY 
      LDA LST5,I   IF THE EXT LINK WORD (WORD 5)
      SZA           IF NON-ZERO THEN LINKAGE
      JMP ENTX5      ALREADY SET. OTHERWISE, ESTA-
      JSB LINK       BLISH EXT LINK (A=0 CALL). 
      LDA LST4,I   STORE ENTRY POINT ADDRESS
      STA B,I       INT O EXT LINK
      STB LST5,I     WORD-SET EXT LINK ADDR. IN LST.
* 
ENTX5 LDA LBUF     (A) = RECORD TYPE FLAG 
      LDB LBUF+2   (B) = RECORD ENTRY ADDR. 
      ADB C.03      ADD 3 FOR NEXT EXT ENTRY. 
      SZA,RSS      IF RECORD IS ENT,
      INB            ADD 2 MORE (4-WORD ENTRY). 
      STB LBUF+2   SET ADDRESS OF NEXT ENTRY. 
      ISZ LBUF+1   INDEX ENTRY COUNT -
      JMP ENTX1-1   MORE TO PROCESS.
      JMP LDRIN    FINISHED- GET NEXT RECORD. 
* 
* NO MATCH IN LST FOR RECORD ENTRY SYMBOL - ADD 
*  NEW ENTRY - CHECK FIRST FOR MEMORY CONFLICT. 
ENTX6 LDA FWABP    SUBTRACT FWA BASE PAGE 
      CMA,INA       FROM LWA OF NEW 
      ADA LST5       LST ENTRY. 
      SSA          A NEGATIVE RESULT MEANS NEW ENTRY
      JMP LER5      EXTENDS INTO PROGRAM AREA-ERROR.
      LDB LST5     OK.
      ADB CM.1     SET B= ADDR-1 OF NEW LST WORD 5. 
      STB LWABP      LST5 AS NEW LWA AVAIL. MEMORY. 
      LDB LBUF+2    (B) = RECORD ENTRY ADDR.
      LDA B,I       MOVE WORDS 1 AND 2 OF RECORD
      STA LST1,I     ENTRY TO WORDS 
      INB             1 AND 2 NEW LST ENTRY 
      LDA B,I       (WORD 3 WILL BE SET LATER)
      STA LST2,I
      CLA           SET WORDS 4 AND 5 = ZERO
      STA LST4,I
      STA LST5,I
      INB          (B) = ADDR. OF WORD 3, REC. ENTRY
      ISZ LSTA,I    ADD 1 TO LST ENTRY COUNT. 
      LDA LBUF     (A) = RECORD TYPE FLAG.
      SZA          GO TO COMPLETE ENTRY PROCESSING
      JMP ENTX4     EXTERNAL ENTRY
      JMP ENTX2     ENTRY POINT ENTRY 
* 
* 
* SUBROUTINE:  RELEN  (RELOCATE ENTRY POINT ADDRESS)
* 
* CALLING SEQUENCE:  (B)= ADDRESS OF WORD 
*                         CONTAINING ENT ADDRESS
* 
*             (P)   JSB  RELEN
*             (P+1)  -RETURN-  A-DESTROYED
*                        (B) = RELOCATED ENT ADDRESS
* 
*             BITS  07-00 OF (LST3) ARE SET = ZERO. 
* 
* 
RELEN NOP          ENTRY/EXIT POINT 
      LDA LST3,I   GET WORD 3 OF LST ENTRY
      AND UPCM     SET BITS 07-00 = ZERO
      STA LST3,I    AND RESTORE.
      LDB B,I      GET ENTRY POINT ADDRESS
      ADB PREL     ADD RELOCATION FACTOR. 
      STB LST4,I   STORE ENT ADDR. IN WORD 4 LST. 
      JMP RELEN,I  EXIT.
* 
* 
* 
* FOLLOWING STATEMENT DEFINES LOADER BUFFER 
* 
LBUFA DEF LBUF
* 
LBUF  OCT 0,0 
LBUF3 BSS 58
* 
* 
******************************
NBUFA DEF NBUF
NBUF  BSS 9 
* 
*********************************** 
* 
* SUBROUTINE:  LSTP  / LSTI  (LST PROCESSOR)
* 
* PURPOSE:  TO SET IN WORDS  LST1 - LST5 THE
*            ADDRESSES OF THE FIVE WORDS IN AN
*            ENTRY IN THE LST (LOADER SYMBOL TABLE) 
* 
*           INITIAL SETUP IS MADE BY THE ROUTINE
*            -LSTI-   THIS SECTION INITIALIZES
*             THE NEGATIVE COUNT OF THE NUMBER
*             OF ENTRIES IN THE LST AND SET THE 
*             VALUE OF THE ADDRESS+1 OF THE 
*             FIRST ENTRY. THIS ADDRESS IS STORED 
*             IN LST5.
* 
*           THE SECTION -LSTP- SETS THE FIVE
*             ADDRESSES OF THE NEXT LST ENTRY 
*             IN LST1-LST5.  IT ALSO INDEXES THE
*             ENTRY COUNTER.  WHEN THE COUNTER = ZERO 
*             EXIT FROM LSTP IS TO P+1 OF THE CALL
*             AND LST1-LST5 CONTAIN THE ADDRESSES 
*             FOR A NEW ENTRY.  IF THE COUNT AFTER
*             INDEXING IS NOT ZERO, EXIT IS TO
*             P+2 OF THE CALL.
* 
*           LSTP SEQUENTIALLY SETS THE ADDRESSES
*            OF LST ENTRIES  1 TO N.
* 
* CALLING SEQUENCE: (P-1)     JSB LSTI
*                   (P)       JSB LSTP
*                   (P+1)  (END OF LST RETURN)
*                   (P+2)  (NEXT ENTRY ADDRESSES
*                             SET RETURN) 
* 
* 
*             - INITIALIZER-
LSTI  NOP 
      LDA LSTA,I   GET NUMBER OF LST ENTRIES - SET
      CMA           NEGATIVE THE VALUE + 1. 
      STA LSTPX    STORE
      LDA LSTA     SET ADDRESS+1 OF WORD 1 OF FIRST 
      STA LST5      ENTRY IN LST5.
      JMP LSTI,I   EXIT 
* 
*             - PROCESSOR - 
* 
LSTP  NOP 
      LDA LST5     SUBTRACT 5 TO GET A ADDR. OF WORD5 
      ADA CM.5      OF THE NEXT ENTRY 
      STA LST5      AND SET IN  LST5. 
      INA 
      STA LST4      SET FOR WORD 4. 
      INA 
      STA LST3      SET FOR WORD 3. 
      INA 
      STA LST2      SET FOR WORD 2. 
      INA 
      STA LST1      SET FOR WORD 1. 
      ISZ LSTPX     INDEX ENTRY COUNTER.
      ISZ LSTP     NOT END OF LST - SET P+2 EXIT
      JMP LSTP,I   -EXIT-  TO P+1 IF END OF LST.
* 
LSTA  DEF LST     DEFINE STARTING ADDRESS OF LST
* 
LSTPX OCT 0        HOLDS ENTRY COUNTER(NEG. #+1). 
LST1  OCT 0 
LST2  OCT 0 
LST3  OCT 0 
LST4  OCT 0 
LST5  OCT 0 
* 
* 
* 
* SUBROUTINE:  DIAG  (DIAGNOSTIC OUTPUT)
* 
* CALLING SEQUENCE: (A) 2-DIGIT (ASCII) ERROR CODE
* 
*                (P)    JSB DIAG
*                (P+1)  (RETURN)
* 
* DIAG STORES THE 2-DIGIT DIAGNOSTIC IDENTIFIER IN
*    THE SECOND WORD OF THE DIAGNOSTIC BUFFER - 
*    THE FIRST WORD CONTAINS   *L  .  THE DIAGNOSTIC
*    IS OUTPUT  AS   *LXX - XX IS THE NUMERIC CODE. 
*  AFTER THE DIAGNOSTIC IS OUTPUT, CONTROL
*   IS RETURNED TO THE CALLER.
* 
DIAG  NOP 
      STA DBUF+2   SET 2-DIGIT NUMBER IN BUFFER.
* 
      JSB SPACE    DOUBLE-SPACE PRINT OUTPUT. 
* 
      LDA DBUF     (A) = ADDR. OF BUFFER. 
      LDB C.04     (B) = 4 CHARS. OUTPUT. 
      JSB LOUT     OUTPUT DIAGNOSTIC. 
      JMP DIAG,I   RETURN.
* 
DBUF  DEF *+1 
      ASC 1,*L
      NOP 
* 
* 
* DIAGNOSTIC OUTPUT SECTION 
* 
LER7  LDA ERR07     DUPLICATE ENTRY POINTS
      JMP ERROR 
LER5  LDA ERR05     SYMBOL TABLE OVERFLOW 
      JMP ERROR 
LER4  LDA ERR04     LINKAGE AREA OVERFLOW 
      JMP ERROR 
LER3  LDA ERR03     MEMORY OVERFLOW 
* 
ERROR JSB DIAG      PRINT DIAGNOSTIC
* 
      HLT 0     * ERROR HALT *
* 
      JMP *-1    *** FORCE IRRECOVERABLE ***
* 
ERR01 ASC 1,01
ERR02 ASC 1,02
ERR03 ASC 1,03
ERR04 ASC 1,04
ERR05 ASC 1,05
ERR06 ASC 1,06
ERR07 ASC 1,07
ERR08 ASC 1,08
ERR09 ASC 1,09
* 
* SUBROUTINE: LOUT  (LOADER OUTPUT) 
* 
* CALLING SEQUENCE:  (A)= ADDRESS OF BUFFER 
*                    (B)= NUMBER OF CHARACTERS
*                          IN BUFFER
*                (P)     JSB  LOUT
*                (P+1)   (RETURN)-OUTPUT COMPLETED, 
*                           (A),(B) MEANINGLESS.
* 
LOUT  NOP 
      STA NBUF+8   SAVE (A).
      LDA B        SET (A) = BUFFER LENGTH
      LDB NBUF+8   SET (B) = BUFFER ADDRESS 
* 
      JSB LIST,I   PRINT BUFFER 
* 
      JMP LOUT,I   RETURN  -
* 
* 
* SUBROUTINE  -SPACE- 
* 
* CALLING SEQUENCE:  (P)      JSB SPACE 
*                    (P+1)    -RETURN-  REGISTERS 
*                                       DESTROYED.
* 
* PURPOSE:  THIS ROUTINE CAUSES A DOUBLE-SPACE TO 
*           BE PRODUCED ON THE LIST OUTPUT DEVICE.
*           IT CALLS -LOUT- TO OUTPUT THE UPPER 
*           CHARACTER OF THE WORD  -MAPF- WHICH IS
*           A LINE-FEED.  THE OUTPUT DRIVER PROVIDES
*           A RETURN AND AN ADDITIONAL LINE-FEED
*           TO GENERATE THE DESIRED DOUBLE-SPACE. 
* 
SPACE NOP      ENTRY/EXIT 
      LDA LINFX    ADDR. OF MAPF. 
      CLB,INB      SET FOR 1 CHARACTER OUTPUT.
      JSB LOUT     OUTPUT LINE-FEED.
      JMP SPACE,I  RETURN 
* 
LINFX DEF MAPF     DEFINE ADDRESS OF MAPF 
* 
* 
* 
* 
* 
* SUBROUTINE -  (ENTRY POINT LIST)
* 
* CALLING SEQUENCE: 
*          (A): =0, LIST UNDEFINED EXTERNAL SYMBOLS.
*               =1, LIST  ENTRY POINT SYMBOLS AND 
*                    ABSOLUTE ADDRESSES FROM LST. 
* 
*        (P)     JSB  EPL 
*        (P+1)   (RETURN) A AND B DESTROYED 
* 
* LIST UNDEFINED EXTERNAL SYMBOLS:  EACH LST ENTRY
*     IS EXAMINED FOR A ZERO ENTRY POINT ADDRESS. 
*     EACH ENTRY WITH A ZERO ENT ADDRESS (WORD 4) 
*     IS LISTED ON THE COMMENT OUT DEVICE.  THE 
*     LIST FORMAT IS: 
*         SYMB1 
*         SYMB2 
*         ----- 
*         ETC.
* 
* LIST ALL ENTRY POINT SYMBOLS AND ADDRESSES: 
*     EACH ENTRY IN THE  LST IS OUTPUT TO THE 
*     COMMENT OUT DEVICE IN THE FORMAT: 
*        SYMB1  NNNNN    (NNNNN= ABSOLUTE ADDRESS)
*        SYMB2  NNNNN 
*        -----
*        SYMBN  NNNNN 
* 
*    THE LISTING OF THE BOUNDS OF THE LINKAGE 
*     AREA IN BASE PAGE COMPLETES THE OUTPUT. 
*     THE FORMAT IS:
* 
*       LINK
*        LLLLL UUUUU
*        (LLLLL= STARTING ADDRESS OF LINK AREA, 
*         UUUUU= ENDING ADDRESS OF LINK AREA) 
* 
*  EPL  USES THE SUBROUTINE -CONV- TO CONVERT THE 
*    ABSOLUTE ADDRESSES TO ASCII FORMAT.
* 
* 
EPL   NOP          ENTRY/EXIT POINT 
      STA NBUF     SAVE ENTRY PARAMETER.
* 
      JSB SPACE    DOUBLE-SPACE PRINT OUTPUT. 
* 
      JSB LSTI    -INITIALIZE LST PROCESSOR-
* 
EPL1  JSB LSTP     SET LST ENTRY ADDRESSES
      JMP EPL4      END OF LST -- 
*                     PROCESS LST ENTRY 
      LDA LST1,I   MOVE FIRST 3 WORDS OF
      STA LBUF      LST ENTRY ( SYMBL ) 
      LDA LST2,I    TO
      STA LBUF+1     LBUF.
      LDA LST3,I   MAKE 6TH CHARACTER 
      IOR M.40      A BLANK 
      STA LBUF+2
      LDB LST4,I   (B) = ENT. ADDRESS 
      LDA NBUF     (A) = ENTRY PARAMETER
      SZA          IF ENT LIST REQUESTED
      JMP EPL2      GO TO CONVERT ADDRESS IN B. 
      SZB          IF ENT ADDR NOT = ZERO, THEN 
      JMP EPL1      EXT DEFINED, GO CHECK NEXT ENTRY
      LDB C.06     SET TO OUTPUT UNDEFINED
      JMP EPL3      EXT  ( 6 CHARACTER  OUTPUT ). 
* 
* ENTRY POINT LIST
* 
EPL2  LDA LBUFA    SET -CONV- TO CONVERT ENT. 
      ADA C.03      ADDRESS TO ASCII AND
      JSB CONV      STORE IN LBUF+3-LBUF+5. 
      LDB C.12     OUTPUT OF 12 CHARACTERS. 
* 
EPL3  LDA LBUFA    OUTPUT BUFFER
      JSB LOUT      STARTING AT LBUF. 
      JMP EPL1     PROCESS NEXT ENTRY IN LST. 
* 
* COMMON ALLOCATION BOUNDS LIST 
* 
EPL4  LDA NBUF     IF LIST OF UNDEFINED EXTS
      SZA,RSS       REQUESTED, THEN EXIT. 
      JMP EPL,I 
* 
      JSB SPACE    DOUBLE-SPACE PRINT OUTPUT. 
* 
* 
* BASE PAGE LINKAGE BOUNDS LIST 
* 
EPL5  LDB LINKA    CONVERT
      LDA LBUFA     FWA 
      JSB CONV       LINK AREA. 
      LDB FWABP    CONVERT
      ADB CM.1       LWA
      JSB CONV       LINK AREA. 
      LDA LINKM    OUTPUT 
      LDB C.12       MESSAGE
      JSB LOUT       -LINK-.
      LDA LBUFA    OUTPUT 
      LDB C.12      LINK AREA 
      JSB LOUT       BOUNDS.
      JMP EPL,I    EXIT --. 
* 
* CONSTANT AND STORAGE SECTION FOR -EPL- .
* 
* 
MAPF  OCT 5000    -UPPER CHARACTER IS A 12(8) WHICH 
*                   IS A LINE-FEED CODE - USED TO 
*                   GENERATE A DOUBLE-SPACE ON PRINT
*                   OUTPUT BY ROUTINE -SPACE-.
* 
* 
M.40  OCT 40      ASCII SPACE  (BLANK)
C.06  OCT 6 
C.12  DEC 12
CM.3  DEC -3
M.60  OCT 60
* 
LINKM DEF *+1 
      ASC 6,*SYSTEM LINK
* 
* 
* SUBROUTINE: CONV  (CONVERT 15-BIT BINARY NUMBER 
*                    TO 6-CHARACTER (LEADING BLANK) 
*                    ASCII FORM OF THE OCTAL
*                    REPESENTATION.)
* CALLING SEQUENCE: 
*             (A)-ADDRESS OF 3-WORD AREA FOR
*                   STORING ASCII/OCTAL CHARACTERS
*             (B)-BINARY VALUE FOR CONVERSION 
*       (P)    JSB  CONV
*       (P+1)  (RETURN)-(A)=NEXT ADDRESS OF STORAGE 
*                            AREA,(B)-DESTROYED.
* 
CONV  NOP          ENTRY/EXIT POINT 
      STA NBUF+3   SAVE STORAGE AREA ADDRESS
      RBL          POSITION FIRST DIGIT TO B(15-13).
      LDA CM.3     SET CONVERT COUNTER
      STA NBUF+4     = -3.
      LDA M.40     MAKE FIRST CHARACTER A SPACE.
CONV1 ALF,ALF      ROTATE CHAR. TO UPPER POSITION 
      STA NBUF+5    AND SAVE. 
      BLF,RBR      POSITION NEXT DIGIT TO B(02-00), 
      LDA B         PUT IN B AND
      AND M.07       ISOLATE DIGIT. 
      IOR M.60     MAKE AN ASCII CHAR. (60 - 67). 
      IOR NBUF+5   PACK IN UPPER CHARACTER
      STA NBUF+3,I  AND STORE IN STORAGE AREA.
      ISZ NBUF+3   ADD 1 TO STORAGE AREA ADDRESS. 
      BLF,RBR      ROTATE NEXT DIGIT TO LOW B,
      LDA B         ISOLATE CHAR
      AND M.07       IN LOW A,
      IOR M.60      MAKE AN ASCII CHAR. 
      ISZ NBUF+4   INDEX CONVERT COUNTER
      JMP CONV1     NOT FINISHED. 
      LDA NBUF+3   FINISHED, SET (A)= NEXT STORAGE
      JMP CONV,I    AREA WORD ADDRESS AND EXIT. 
* 
*********************************************** 
* 
* 
***  MEMORY  TABLE  *** 
* 
FWABP OCT 0        SET BY INITIALIZATION SECTION
LWABP DEF LWA      LWA AVAIL.MEMORY IN BASE PAGE
FWAM  DEF XPCS     FWA AVAIL. MEMORY
LWAM  OCT 0        SET BY INITIALIZATION SECTION
* 
LWAM1 OCT 0        HOLDS ORIGINAL  LWA MEMORY.
* 
SLASH OCT 57
E     OCT 105 
D     OCT 104 
PER.  OCT 56
COMMA OCT 54
* 
EQTA  DEF PCS1     DEFINE EQT BUILDING AREA 
SQTA  OCT 0 
* 
EQTX  DEF PCS1+1
* 
* SUBROUTINE:  ERROR PRINT  - ERRPT 
* 
ERRPT NOP 
      LDB ERBUF 
      LDA ERBUF+1 
      JSB LOUT
      JMP ERRPT,I 
* 
ERBUF DEC 6 
      DEF *+1 
      ASC 3,*ERROR
* 
T1    OCT 0        TEMPORARY
T2    OCT 0         STORAGE 
* 
      END 
