ASMB,R,L,B,T,C   ** BCS DRIVER D.02 (PT PUNCH) ** 
      HED     ** BCS DRIVER D.02 (PT PUNCH) **
* 
      NAM D.02
* 
************  D.02 - HP-2753A PUNCHED TAPE OUTPUT DRIVER ************ 
* 
      ENT D.02,I.02 
* 
      EXT .BUFR 
* 
*  THIS MODULE OF THE HP-2116 BASIC CONTROL SYSTEM
* SOFTWARE IS DESIGNED TO OPERATE THE 8-LEVEL 120 
* CPS PAPER TAPE PUNCH. THE FUNCTION OF THIS DRIVER 
* IS TO INITIATE, CONTINUE AND COMPLETE A WRITE 
* -(OUTPUT)- OPERATION REQUESTED THROUGH INPUT/ 
* OUTPUT CONTROL. 
* 
* 
* 
** D.02 -  INITIATOR  SECTION **
* 
D.02  NOP 
      STA SAVA     SAVE EQT ENTRY ADDRESS.
      STB SAVB     SAVE REQUEST (WORD 2) ADDRESS. 
      LDA B,I      GET WORD 2 OF I/O REQUEST
      ALF          ROTATE REQUEST CODE TO LOW 
      AND M17       A AND ISOLATE CODE. 
      STA SAVC     SAVE REQUEST CODE. 
      SZA          IF CODE NOT = 0, 
      JMP X.1       CONTINUE PROCESSING.
* 
* CODE= 0 . TERMINATE CURRENT OPERATION. A  CLC 
*  INSTRUCTION REPLACES THE FOLLOWING JMP AFTER 
*   THE FIRST OPERATION IS INITIATED. 
* 
I.1   JMP D.02,I       (  CLC  )
I.0   STF 0         SOFTWARE CORRECT. BY GRANT SHAW 
      JMP STAT     CLEAR OPERATION. 
* 
*                  WRITE REQUEST
* 
X.1   LDB DFLG     IF DRIVER IS CURRENTLY BUSY
      SZB           (I.E, DFLG NOT = 0), REJECT 
      JMP REJB       REQUEST. 
* 
      CPA C.02     IF REQUEST CODE IS NOT 
      RSS           EQUAL TO 2 (WRITE), 
      JMP RCER       REJECT REQUEST.
* 
      LDA SAVA,I   GET WORD 1 OF EQT ENTRY, 
      AND M77       ISOLATE DEVICE I/O ADDRESS
      IOR SFSI      AND COMBINE WITH SFS INSTR. 
      STA I.2      SET SFS. 
      XOR OTAM       CONSTRUCT AND
      STA I.3      SET OTA. 
      XOR CLCM       CONSTRUCT AND
      STA I.1      SET CLC. 
      STA I.6 
      XOR STCM       CONSTRUCT AND
      STA I.4      SET STC. 
      XOR LIBM       CONSTRUCT AND
      STA I.5      SET LIB. 
      XOR STFM      SOFTWARE CORRECT. BY GRANT SHAW 
      STA I.0       SOFTWARE CORRECT. BY GRANT SHAW 
I.2   SFS 0        TEST DEVICE FLAG.
      JMP REJB      NOT SET - DEVICE NOT READY. 
* 
* 
      LDA SAVA     SAVE EQT ENTRY FWA 
      STA EXIT+2    FOR COMPLETION CALL TO BUFR.
      LDA SAVB,I   GET WORD 2 OF REQUEST. 
      ALF,CLE,ALF  SHIFT SO THAT
      ELA,ELA       M (MODE-BIT 06) IS IN E.
      CLB          CLEAR B AND PUT MODE 
      ERB           IN B(15). 
      ISZ SAVA     INDEX TO WORD 2 OF EQT ENTRY.
      LDA SAVA,I   SET BIT 15 OF WORD 2 
      IOR M15       = 1  ( O-FIELD = 2) TO SAY
      STA SAVA,I    DEVICE BUSY.
      LDA SAVA     SET ADDRESS OF WORD 3
      INA           OF EQT ENTRY
      STA EQTA       IN -EQTA- .
      ISZ SAVB     INDEX TO WORD 4
      ISZ SAVB      OF REQUEST. 
      LDA SAVB
      LDA A,I     GET BUFFER ADDRESS
      RAL,CLE,SLA,ERA     IF INDIRECTION, 
      JMP *-2        GET NEXT-LEVEL ADDRESS 
      STA BUF      SAVE BUFFER ADDRESS. 
      ISZ SAVB     INDEX TO WORD 5, 
      LDA SAVB,I   GET WORD 5 (BUFFER LENGTH).
      SSA          IF CHARACTERS REQUESTED, 
      INB           SET LSB OF B = 1 AND SET
      STB EQTA,I     B AS WORD 2 OF EQT ENTRY.
      SSA          CHECK FOR CHARS. REQUESTED.
      JMP *+3       YES- VALUE IS ALREADY NEGATIVE. 
      CMA,INA      CONVERT WORDS TO CHARS 
      ALS           AND SET LENGTH AS AN
      STA CHX        INDEX COUNTER. 
      LDA UL52     INITIALIZE UPPER/LOWER CHAR. 
      STA ULFL      POSITION FLAG TO UPPER. 
      LDA CM.4     SET -FFCT- = -4 FOR OUTPUT OF 4
      STA FFCT      FEED-FRAMES AFTER BINARY RECORD.
      STA DFLG     SET DRIVER FLAG BUSY - NOT = 0.
      CLA          SET CHARACTER COUNTER WORD 
      STA CHC       AND RETURN-OUTPUT FLAG
      STA RETF       = 0. 
* 
* INITIATE OUTPUT OPERATION BY TRANSFERRING CONTROL 
*  TO CONTINUATOR SECTION FOR FIRST CHARACTER.
* 
      JSB I.02      OUTPUT FIRST CHARACTER. 
      JMP D.02,I   -EXIT TO IOC.
* 
* REJECT SECTION
* 
RCER  CLB,RSS      REQUEST CODE ERROR - SET B = 0.
REJB  LDB M15      DEVICE/DRIVER BUSY-SET B(15)= 1. 
      CLA,INA      SET A NON-ZERO FOR REJECT
      JMP D.02,I    CONDITION - EXIT TO IOC.
* 
* 
* 
** I.02 -  CONTINUATOR SECTION  **
* 
I.02  NOP 
      STA SAVAX    SAVE 
      STB SAVBX     ALL 
      CLA            REGISTERS
      SOC             AND 
      INA              OVERFLOW 
      ELA               INDICATOR.
      STA SAVEX 
* 
      LDA EQTA,I   PUT MODE (BIT 15 OF EQT WORD 3)
      ELA           INTO E. 
* 
      LDA BUF      IF BUFFER ADDRESS IS NEGATIVE
      SSA           THEN OPERATION
      JMP STAT       IS COMPLETED.
* 
      LDA CHX      IF CHARACTER INDEX IS
      SSA,RSS       POSITIVE, THEN BUFFER IS
      JMP X.3        COMPLETED. 
      LDB ULFL     (B) = UPPER/LOWER POSITION FLAG. 
      LDA BUF,I    GET BUFFER WORD CONTAINING CHAR. 
      SSB,RSS      IF CHAR. TO BE OUTPUT IS IN UPPER
      ALF,ALF       POSITION (SIGN = 0), ROTATE 
      AND M377       AND ISOLATE CHARACTER
      SSB          IF CHAR. OUTPUT IS IN LOWER POS- 
      ISZ BUF       ITION, ADD 1 TO BUFFER ADDRESS. 
      RBL          ROTATE UPPER/LOWER POSITION FLAG 
      STB ULFL      FOR NEXT CHARACTER. 
      ISZ CHX      INDEX CHAR. LENGTH VALUE.
      NOP           -IGNORE P+1 EXIT. 
      SEZ          IF BINARY MODE, GO 
      JMP I.3      TO OUTPUT CHARACTER. 
* 
      IOR M200     ADD 8-LEVEL BIT FOR ASCII MODE.
      LDB CHX      IF CURRENT CHAR. IS
      SZB           NOT THE LAST CHAR. IN BUFFER, 
      JMP I.3        GO TO OUTPUT CHAR. 
* 
* CHECK LAST CHARACTER FOR A  - _ -.
* 
      CPA ARROW    IF LAST CHARACTER  =   _, TERM-
      JMP STAT      INATE WITHOUT RETURN/LINE FEED. 
* 
I.3   OTA 0        OUTPUT CHARACTER TO BUFFER.
* 
      ISZ CHC      COUNT CHARACTER OUTPUT.
* 
* 
X.2   JSB RSTR     RESTORE REGISTERS
* 
* FOLLOWING INSTRUCTION (STC) CAUSES THE
*  CHARACTER IN THE I/O BUFFER TO BE PUNCHED. 
* 
I.4   STC 0,C      PUNCH 1 CHARACTER
* 
      JMP I.02,I   EXIT TO INTERRUPTED SEQUENCE.
* 
* CONTROL TO THIS SECTION TO TERMINATE A RECORD 
* 
X.3   SEZ,RSS      IF ASCII MODE, GO TO OUTPUT
      JMP X.4       A RETURN/LINE FEED. 
*                 BINARY MODE 
      CLA         (A) = ZERO FOR A FEED-FRAME.
      ISZ FFCT    INDEX COUNTER FOR 4 FEED-FRAMES.
      JMP I.3      NOT 4 OUTPUT - 
      JMP X.5+1    FOURTH TO BE OUTPUT
* 
X.4   LDA RETF    IF RETURN FLAG = ZERO, RETURN CODE
      SZA          IS TO BE OUTPUT - OTHERWISE, A 
      JMP X.5       LINE-FEED IS OUTPUT.
      LDA RETN    (A) = RETURN CODE.
      STA RETF     SET RETN NON-ZERO. 
      JMP I.3     GO TO OUTPUT SECTION. 
X.5   LDA LINF     (A) = LINE-FEED CODE.
      LDB CM.4     SET (BUF) NEGATIVE TO TERMINATE
      STB BUF       OPERATION AFTER CHAR. IS
      JMP I.3        OUTPUT.
* 
* STATUS SECTION
* 
STAT  LDB CHC      (B)= NO. OF CHARS OUTPUT.
      LDA EQTA,I   GET EQT ENTRY WORD 3.
      CLE,SLA,RSS  IF WORDS OUTPUT REQUESTED (LSB=0)
      BRS           DIVIDE CHAR. COUNT BY 2 
      ERA,RAL      REMOVE LSB SETTING, LEAVE MODE IN
      ADA B         BIT 15, PUT TRANSMISSION LOG IN 
      STA EQTA,I     A AND SET EQT ENTRY-WORD 3.
      CCA          SET -EQTA- TO
      ADA EQTA      ADDRESS OF
      STA BUF       WORD 2. 
      LDA BUF,I   GET WORD 2, SET OPERATION AND 
      AND MST       STATUS FIELDS = ZERO. 
* 
I.5   LIB 0        GET DEVICE STATUS. 
      SZB           IF STATUS NON-ZERO, SET BIT 5 
      IOR TSLOW      FOR TAPE SUPPLY LOW INDICATION.
      STA BUF,I    SET WORD 2 OF EQT ENTRY. 
      CLA          SET DRIVER 
      STA DFLG      FLAG = ZERO TO SAY AVAILABLE. 
      CPA SAVC     IF CLEAR REQUEST, THEN EXIT TO 
      JMP D.02,I     IOC. 
* 
      LDA I.02     SET INTERRUPTED SEQUENCE 
      STA EXIT+1    ADDRESS IN
      JSB RSTR
* 
I.6   CLC 0        CLEAR DEVICE CONTROL 
* 
EXIT  JSB .BUFR    CALL FOR UNIT BUFFERING (OR EXIT)
      NOP          HOLDS RETURN ADDRESS.
      NOP          HOLDS UNIT EQT ADDRESS.
* 
* 
RSTR  NOP 
      LDA SAVEX    RESTORE
      ERA           E,
      CLO           OVERFLOW, 
      SLA           A AND 
      STF 01        B TO VALUES 
      LDA SAVAX     AT TIME 
      LDB SAVBX     OF INTERRUPT
      JMP RSTR,I
* 
SAVAX NOP          TEMPORARY
SAVBX NOP           STORAGE 
SAVEX NOP 
* 
* 
* 
* 
* CONSTANT AND STORAGE SECTION
* 
A     EQU 0        A -REGISTER
B     EQU 1        B -REGISTER
SAVA  OCT 0 
SAVB  OCT 0 
SAVC  OCT 0 
* 
DFLG  OCT 0   DRIVER FLAG: 0=AVAILABLE, 1=BUSY
* 
M17   OCT 17       MASKS
M77   OCT 77        USED
M377  OCT 377        IN 
M200  OCT 200         PROCESSING
M15   OCT 100000
MST   OCT 37400 
TSLOW OCT 40040    TAPE SUPPLY LOW STATUS 
* 
SFSI  SFS 0 
OTAM  OCT 500      MASKS USED 
CLCM  OCT 4100      TO
STCM  OCT 5000       CONSTRUCT
LIBM  OCT 5200        I/O INSTRUCTIONS. 
STFM  OCT 4400      SOFTWARE CORRECT. BY GRANT SHAW 
* 
EQTA  OCT 0 
BUF   OCT 0 
CHX   OCT 0 
CHC   OCT 0 
FFCT  OCT 0 
CM.4  DEC -4
C.02  DEC 2 
RETN  OCT 215      RETURN CODE
LINF  OCT 212      LINE-FEED CODE 
UL52  OCT 52525   POSITION FLAG: 0=UPPER,1=LOWER
ULFL  OCT 0        FOR UNPACKING CHARACTERS.
RETF  OCT 0       FLAG FOR RETURN/LINE FEED OUTPUT. 
* 
ARROW OCT 337      LEFT ARROW WITH 8-LEVEL BIT SET
* 
* 
      END 
