ASMB,R,L,T,B,C   ** BCS TAPE READER DRIVER D.01 **
      HED     ** BCS TAPE READER DRIVER D.01 ** 
* 
      NAM D.01
* 
***********  D.01 -  HP-2737A PUNCHED TAPE READER DRIVER ***********
* 
      ENT D.01,I.01 
* 
* 
*  THIS MODULE OF THE HP-2116 BASIC CONTROL SYSTEM
* SOFTWARE IS DESIGNED TO OPERATE THE 8-LEVEL 
* PAPER-TAPE READER. THE FUNCTION OF THIS DRIVER
* IS TO INITIATE, CONTINUE AND COMPLETE A READ
* -(INPUT)- OPERATION REQUESTED THROUGH 
* INPUT/OUTPUT CONTROL. 
* 
*  THE DRIVER ACCEPTS AND PROCESSES A READ
* REQUEST FOR TRANSMISSION IN ASCII OR BINARY MODES.
* THE SPECIAL P-FORMAT FOR BINARY INPUT MAY BE
* SELECTED FOR A SINGLE READ OPERATION. 
* 
*  THE DRIVER PROVIDES FOR A SIMULATED END-OF-TAPE
* CONDITION WHICH IS DETERMINED BY A FIXED
* NUMBER OF CONSECUTIVE FEED-FRAMES BEFORE THE
* FIRST DATA CHARACTER OF A RECORD IS INPUT. THE
* NUMBER OF FEED-FRAMES IS REPRESENTED BY A 
* NEGATIVE CONSTANT AT THE LABEL -FFCT- IN THE
* DRIVER. THE CONSTANT IS SET FOR  10, BUT MAY BE 
* CHANGED TO ANY DESIRED VALUE BY RE-ASSEMBLING 
* THE DRIVER. 
* 
*  REFER TO THE -EXTERNAL DESIGN SPECIFICATIONS-
* OF THE BCS SYSTEM FOR A DESCRIPTION OF THE
* REQUEST CALLS TO IOC AND THE INPUT RECORD FORMATS.
* 
*                   ** INITIATOR SECTION ** 
D.01  NOP 
      STA SAVA     SAVE EQT ENTRY ADDRESS.
      STB SAVB     SAVE REQUEST (WORD 2) ADDRESS. 
      LDA B,I      GET WORD 2 OF I/O REQUEST
      ALF          ROTATE REQUEST CODE TO LOW 
      AND M17       A AND ISOLATE CODE. 
      SZA          IF CODE NOT = 0, CONTINUE
      JMP D01.1     PROCESSING. 
*            CODE = 0 - TERMINATE OPERATION.
I.1   JMP D.01,I   INSTR. IS A CLC AFTER INITIAL
      STA SAVAX 
      LDA D.01      OPERATION. SET EXIT OF CONTIN-
      STA I.01       UATOR SECTION TO IOC.
      CLA 
      CLB,INB 
      JMP STAT1     CLEAR EQT ENTRY O-FIELD 
* 
D01.1 LDB DFLG     IF DRIVER IS BUSY
      SZB            (DFLG NOT = 0), THEN 
      JMP REJB        REJECT REQUEST. 
* 
      CLE,ERA      IF A NOT = ZERO AFTER MOVING 
      SZA           LSB INTO E, THEN
      JMP RCER       REQUEST CODE IS ILLEGAL. 
* 
      LDA SAVA,I   GET WORD 1 OF EQT ENTRY. 
      AND M77      ISOLATE DEVICE I/O ADDRESS 
      IOR SFSI      AND COMBINE WITH SFS INSTR. 
      STA I.2      SET  SFS.
      XOR LIAM      CONSTRUCT AND 
      STA I.4      SET  LIA.
      XOR CLCM      CONSTRUCT AND 
      STA I.1      SET  CLC.
      XOR STCM      CONSTRUCT AND 
      STA I.3      SET  STC.
      STA I.5 
I.2   SFS 0        IF FLAG NOT SET, REJECT
      JMP REJB      REQUEST.
      LDA SAVB,I   GET WORD 2 OF REQUEST. 
      ALF,CLE,ALF  SHIFT SO THAT
      ELA,ELA       P IS IN A(00), M IN E.
      STA PFMT     SET P FORMAT FLAG. 
      CLB          CLEAR AND PUT
      ERB           MODE IN B.
      ISZ SAVA     SET ADDRESS TO WORD 2 OF EQT 
      LDA SAVA,I    ENTRY. SET BIT 15 OF WORD 
      IOR M15       2 = 1 (O-FIELD = 2) TO SAY
      STA SAVA,I     BUSY AND RESTORE.
      LDA SAVA     SET ADDRESS OF WORD
      INA           3 IN
      STA EQTA       EQTA 
      ISZ SAVB     INDEX TO WORD 4 OF 
      ISZ SAVB      REQUEST 
      LDA SAVB
      LDA A,I     GET BUFFER ADDRESS
     RAL,CLE,SLA,ERA     IF INDIRECTION,
     JMP *-2        GET NEXT-LEVEL ADDRESS
      STA BUF       AND SAVE FOR
      STA BUFS       BUFFER ADDRESS 
      ISZ SAVB     INDEX TO WORD 5 OF REQUEST.
      LDA SAVB,I   GET WORD 5 - BUFFER LENGTH.
      SSA          IF CHARS. REQUESTED, SET 
      INB           B(LSB) = 1 AND RESTORE
      STB EQTA,I     WORD 3 OF EQT ENTRY-MODE IN 15.
      SSA          IF WORDS REQUESTED, (+), 
      JMP *+3       CONVERT WORDS TO
      CMA,INA        CHARACTERS AND 
      ALS             COMPLEMENT. 
      STA LENG     SAVE NEGATIVE
      STA CHX       CHARACTER LENGTH. 
      LDA UL52     INITIALIZE UPPER/LOWER CHAR. 
      STA ULFL      POSITION INDICATOR TO UPPER.
      LDA FFCT     SET COUNTER FOR SIMULATED
      STA EOTC      END-OF-TAPE 
      STA DFLG     SET DRIVER FLAG BUSY (NOT = 0) 
      CLA          SET DATA-IN
      STA DINF      FLAG AND CHARACTER
      STA CHC        COUNTER = 0. 
* 
*  FOLLOWING INSTRUCTION STARTS DATA TRANSMISSION.
I.3   STC 0,C      INITIATE INPUT OPERATION 
      JMP D.01,I   -- EXIT TO IOC ---.
* 
* REJECT SECTION
* 
RCER  CLB,RSS      REQUEST CODE ERROR - (B) = 0 
REJB  LDB M15      DRIVER/DEVICE BUSY-(B)SIGN = 1.
      CLA,INA      SET A NON-ZERO 
      JMP D.01,I   -EXIT TO IOC AND REJECT. 
* 
* 
* 
***  CONTINUATOR SECTION  *** 
*  ENTERED BY JSB,I  IN DEVICE INTERRUPT LOCATION 
* 
I.01  NOP 
      STA SAVAX    SAVE 
      STB SAVBX     A,
      ERA,ALS       B,
      SOC           E 
      INA           AND 
      STA SAVEX     OVERFLOW
* 
      LDA EQTA,I   PUT MODE (BIT 15 OF EQT WORD 
      ELA           3) INTO E.
* 
I.4   LIA 0        LOAD CHARACTER TO A(07-00).
      LDB DINF     (B) = DATA-IN FLAG.
      SZB,RSS      IF NO DATA IN YET AND CHARACTER
      SZA           = 0, CHECK FOR EOT. 
      JMP X.1      OTHERWISE, PROCESS CHARACTER.
* 
* END-OF-TAPE CHECK.
* 
      ISZ EOTC     INDEX EOT COUNTER. 
      JMP X.6       NOT ZERO, KEEP READING. 
      JMP STAT      STATUS, GO TO STATUS SECTION. 
* 
* CHARACTER EXAMINATION SECTION 
* 
X.1   SEZ          IF BINARY MODE, SKIP 
      JMP X.2       CHARACTER CHECK.
      AND M177     REMOVE 8-LEVEL BIT 
      CPA RUBO     -ASCII MODE- CHARACTER CHECK.
      JMP X.7       RUBOUT (RECORD DELETE)
      CPA RETN     -RETURN- 
      JMP X.6        IGNORE RETURN CODE.
      CPA LINF     -LINE FEED-
      JMP X.8 
      SSB          IF DATA-IN FLAG = -1, IGNORE CHAR
      JMP X.6       ACTERS UNTIL LINE-FEED INPUT. 
* 
X.2   SEZ          IF ASCII MODE, SKIP P-FORMAT 
      SZB           CHECK. SKIP CHECK IF NOT FIRST
      JMP X.3        CHARACTER IN BINARY MODE.
      LDB PFMT     IF P-FORMAT NOT SEECTED, 
      SLB,RSS        LSB = 0, 
      JMP X.3         GO TO PROCESS 1ST CHAR. 
* 
* P-FORMAT SECTION - BINARY INPUT 
* 
      STA B        SAVE CHAR----WORD COUNT OF RECORD
      ALS           CONVERT TO CHARACTERS.
      ADA LENG     ADD REQUESTED LENGTH TO VALUE. 
      CCE,SSA,RSS  IF VALUE GT REQUESTED LENGTH,
      JMP *+5       USE REQUESTED LENGTH. 
      LDA B        GET VALUE AGAIN AND
      ALS           SET AS NEGATIVE 
      CMA,INA        CHARACTER COUNTER
      STA CHX         IN CHX
      LDA B        RESTORE CHAR. IN A 
* 
X.3   CLB,INB      SET DATA-IN FLAG = 1 TO SAY
      STB DINF      FIRST DATA CHAR. OF RECORD INPUT
      LDB ULFL     (B) = UPPER/LOWER POSITION FLAG. 
      SSB,RSS      IF SET FOR UPPER (BIT 15 = 0)
      JMP X.4       SAVE CHAR.
      IOR BUF,I     LOWER - PACK WITH PREVIOUS UPPER
      STA BUF,I     CHAR. AND STORE IN BUFFER.
      ISZ BUF      ADD 1 TO BUFFER ADDRESS. 
      JMP *+3 
X.4   ALF,ALF      ROTATE CHAR. TO UPPER POSITION 
      STA BUF,I      AND SAVE.
      RBL          SET UPPER/LOWER FLAG 
      STB ULFL      FOR NEXT CHARACTER. 
      ISZ CHC      ADD 1 TO CHARACTER COUNTER.
      ISZ CHX      INDEX CHAR. INPUT COUNTER. 
      JMP X.6       MORE TO INPUT.
*                    BUFFER FILLED, LENGTH = 0
      SEZ          IF BINARY MODE,
      JMP STAT      GO TO STATUS SECTION. 
X.5   CCB          ASCII- SET DATA-IN FLAG = -1 TO
      STB DINF      FORCE A LINE-FEED TO TERMINATE. 
* 
X.6   LDA SAVEX    RESTORE
      CLO           E,
      SLA,ELA       OVERFLOW
      STF 1         A AND 
      LDA SAVAX     B AT TIME 
      LDB SAVBX     OF INTERRUPT. 
* 
I.5   STC 0,C      SET FOR NEXT CHAR. (OR CLEAR DE- 
      JMP I.01,I    VICE IF FINISHED)- EXIT.
* 
* PROCESSOR FOR RUB-OUT CODE. 
* 
X.7   LDA BUFS     RESET STARTING BUFFER
      STA BUF       ADDRESS.
      LDA LENG     RESET REQUESTED BUFFER 
      STA CHX       LENGTH. 
      LDA UL52     RESET UPPER/LOWER POSITION 
      STA ULFL      INDICATOR TO UPPER. 
      LDA FFCT     RESET END-OF-TAPE
      STA EOTC      COUNTER.
      CLA          SET CHARACTER COUNTER =
      STA CHC       0.
      JMP X.5      GO TO START RETRANSMISSION.
* 
* PROCESSOR FOR LINE-FEED CODE
* 
X.8   CLB          SET DATA-IN FLAG = 0 FOR POSSIBLE
      STB DINF      RE-INPUT CAUSED BY RUB-OUT. 
      LDA LENG     IF CHAR. LENGTH = CHAR. INDEX, 
      CPA CHX       IGNORE LINE-FEED. 
      JMP X.6 
*                 ASCII INPUT COMPLETE. 
      LDB ULFL     IF LAST CHARACTER INPUT WAS IN 
      LDA BUF,I      UPPER POSITION, THEN MAKE LOWER
      IOR BLNK      CHARACTER A BLANK (SPACE) 
      SSB           AND STORE LAST WORD IN
      STA BUF,I     BUFFER. 
* 
*       * STATUS  SECTION * 
STAT  LDB CHC       SET A = WORD 3 EQT ENTRY, 
      LDA EQTA,I     B = CHAR. COUNT. 
      CLE,SLA       IF CHAR. LENGTH REQUESTED, LSB =
      JMP *+3        1, SKIP CHAR/WORD CONVERSION.
      SLB,BRS       IF ODD NO. CHARS INPUT, ADD 1 TO
      INB            WORD COUNT.
      ERA,RAL       SET LSB OF A = 0. 
      ADA B        PUT RECORD LENGTH IN A AND 
STAT1 STA EQTA,I     SET WORD 3 (EQT ENTRY) 
      CCA          SET ADDRESS FOR
      ADA EQTA      WORD 2
      STA BUF       OF  EQT ENTRY.
      LDA BUF,I   GET WORD 2, REMOVE PREVIOUS 
      AND MST       STATUS FIELD SETTING. 
      SZB,RSS      IF B = 0, SET BIT 5 = 1 TO 
      IOR EOTS      DESIGNATE END-OF-TAPE.
      STA BUF,I   SET WORD 2 OF EQT ENTRY.
      CLA          SET DRIVER FLAG
      STA DFLG      TO SAY -NOT BUSY- . 
      LDA I.1       SET A CLC INSTRUCTION IN
      STA I.5         EXIT SECTION. 
      JMP X.6      GO TO RESTORE REGISTERS. 
* 
* CONSTANT AND STORAGE SECTION
* 
A     EQU 0        A -REGISTER
B     EQU 1        B -REGISTER
SAVA  OCT 0 
SAVB  OCT 0 
* 
SAVAX NOP 
SAVBX NOP 
SAVEX NOP 
* 
DFLG  OCT 0      DRIVER BUSY FLAG - = 0, NOT BUSY 
* 
M17   OCT 17        MASKS 
M77   OCT 77         USED 
M177  OCT 177         IN
M15   OCT 100000       PROCESSING 
MST   OCT 37400 
EOTS  OCT 40040 
* 
LIAM  OCT 600      MASKS USED IN
CLCM  OCT 4200      CONSTRUCTING
STCM  OCT 5000       I/O INSTRUCTIONS 
SFSI  SFS 0 
* 
DINF  OCT 0       DATA-IN FLAG, =0,NO DATA. =1, DATA
ULFL  OCT 0       UPPER/LOWER CHAR. POSITION FLAG,
*                 BIT 15 = 0,UPPER, = 1,LOWER.
* 
EQTA  OCT 0        TEMPORARY
BUF   OCT 0 
BUFS  OCT 0         STORAGE 
LENG  OCT 0 
CHC   OCT 0          AREA 
CHX   OCT 0 
EOTC  OCT 0 
PFMT  OCT 0 
UPCH  EQU PFMT
* 
UL52  OCT 52525 
RUBO  EQU M177     RUB-OUT CODE 
RETN  OCT 15       RETURN CODE
LINF  OCT 12       LINE-FEED CODE 
BLNK  OCT 40       BLANK  CODE
* 
* 
FFCT  DEC -10      END-OF-TAPE COUNTER (NEGATIVE) 
* 
      END 
