ASMB,R,B,L,T,C   **  BCS TTY DRIVER D.00  MODIFIED ** 
*                                  (PARALLEL TTY--BUFFERED) 
      HED ** BCS TTY DRIVER D.01 (BUFFERED) **
* 
      NAM D.00
* 
* NOTE - THIS DRIVER HAS BEEN MODIFIED TO PERMIT USING
* WITH TERMINALS THAT EMIT ONLY CR WHEN ENTER IS PRESSED
* MODS NOTED BY MOD AND /MOD    JUNE 7 2011 WTN
* 
************ D.00  -  ASR-33/35 DRIVER  ************
* 
      ENT D.00,I.00 
      EXT .BUFR 
*                                                   * 
*  THIS MODULE OF THE HP-2116 BASIC CONTROL SYSTEM  * 
* SOFTWARE IS DESIGNED TO OPERATE THE ASR-33/35     * 
* TELE-TYPEWRITER. THE FUNCTION OF THIS DRIVER IS   * 
* TO INITIATE, CONTINUE AND COMPLETE A READ/WRITE   * 
* OPERATION REQUESTED THROUGH INPUT/OUTPUT CONTROL. * 
*                                                   * 
*  THE DRIVER ACCEPTS AND PROCESSES A READ OR       * 
* WRITE REQUEST IN EITHER ASCII OR BINARY MODES.    * 
* KEYBOARD MODE MAY BE SELECTED FOR A SINGLE        * 
* READ OPERATION.  THE SPECIAL P-FORMAT FOR  BINARY * 
* INPUT MAY ALSO BE SELECTED FOR A SINGLE READ      * 
* OPERATION.                                        * 
*                                                   * 
*  THE DRIVER WILL REJECT A -FUNCTION SELECT-       * 
* REQUEST AS NONE OF THE DEFINED FUNCTIONS IS       * 
* APPLICABLE FOR THE ASR DEVICE.                    * 
*                                                   * 
*  THE DRIVER PROVIDES FOR A SIMULATED  END-OF-TAPE * 
* CONDITION WHICH IS DETERMINED BY A FIXED NUMBER   * 
* OF CONSECUTIVE FEED-FRAMES BEFORE THE FIRST       * 
* DATA CHARACTER OF A RECORD IS READ.  THE NUMBER   * 
* OF FEED-FRAMES IS REPESENTED BY A NEGATIVE        * 
* CONSTANT AT THE LABEL   -FFCT- IN THE DRIVER.     * 
* THE CONSTANT IS SET FOR 10 BUT MAY BE CHANGED     * 
* TO ANY DESIRED VALUE BY RE-ASSEMBLING THE DRIVER. * 
*                                                   * 
*  REFER TO THE -EXTERNAL DESIGN SPECIFICATIONS- OF * 
* THE BCS SYSTEM FOR A DESCRIPTION OF THE REQUEST   * 
* CALLS TO IOC AND THE RECORD FORMATS.              * 
*                                                   * 
*                                                   * 
* 
***  D.00     INITIATOR SECTION  ***
* 
D.00  NOP           * ENTRY / EXIT *
     STA SAVA      SAVE EQT ENTRY ADDRESS.
      STB SAVB      SAVE REQUEST (WORD 2) ADDRESS.
      LDA B,I       GET WORD 2 OF REQUEST, ROTATE 
      ALF            REQUEST CODE TO LOW A
      AND M17         AND ISOLATE CODE FIELD
     SZA           IF CODE NOT = ZERO, CONTINUE 
      JMP X.1        NORMAL PROCESSING. 
* 
* CODE = ZERO (CLEAR CURRENT OPERATION) - THE 
*  FOLLOWING INSTR (JMP) IS REPLACED BY A CLC AFTER 
*  THE FIRST OPERATION IS INITIATED.
* 
I.1   JMP D.00,I    CLEAR DEVICE CONTROL. 
I.2   STF 0        SET DEVICE FLAG FOR NEXT REQUEST.
      STA SAVC       SAVE CLEAR CODE. 
      CLB,INB      GO TO
      JMP STAT1     STATUS SECTION. 
* 
X.1  LDB DFLG      CHECK DRIVER FLAG -
     SZB             IF DRIVER BUSY,
     JMP REJB         REJECT THIS REQUEST.
* 
      STA SAVC
     ADA CM3      SUBTRACT 3 FROM CODE
     SSA,RSS       IF RESULT +, THEN ILLEGAL CODE,
      JMP RCER       REJECT REQUEST. 1,2 LEGAL. 
* 
      LDA SAVA     SAVE EQT ADDR. FOR 
      STA EXIT+2    CALL TO .BUFR AFTER WRITE 
     LDA SAVA,I    GET WORD 1 OF EQT ENTRY. 
     AND M77       ISOLATE PUNCH UNIT I/O ADDRESS.
      IOR OTAI     OTA TTY
      STA I.10
      STA Q.02     *** MOD
      XOR LIAM     LIA TTY
      STA I.6 
      XOR SFSM     SFS TTY
      STA I.3 
      XOR CLFM     CLF TTY
      XOR SFSM     STC TTY,C
      STA I.5 
      STA I.11
      STA I.14
      STA Q.03     *** MOD
      XOR CFM      STF TTY
      XOR SFSM
      STA I.2 
      XOR CLCM     CLC TTY
      STA I.1 
      STA I.7 
      STA I.8 
      XOR OTBI     OTB TTY
      STA I.4 
      STA I.9 
      STA I.13
      STA Q.01     *** MOD
* 
* 
I.3   SFS 0        IF FLAG NOT SET (I.E. DEVICE UN- 
     JMP REJB       AVAILABLE),REJECT REQUEST.
      LDB SAVC
* 
     LDA SAVB,I    GET WORD 2 OF REQUEST- SHIFT SO
     ALF,ALF        THAT P=BIT 15, M=BIT 14, K=0. 
      STA SAVD
     SSA           IF P FORMAT SELECTED, SET BIT 15 
     ADB M15        OF B = 1 AND SAVE AS
     STB RWFL        READ/WRITE FLAG. 
      CLB,CLE       CLEAR "B", CLEAR "E". 
     ELA,ELA       PUT MODE BIT INTO
     ERB            BIT 15 OF B.
      CLE,SSB       SET MODE BACK 
      CCE            INTO E 
      LDA SAVB,I    GET UNIT
      AND M77        # FROM REQUEST 
      CMA,INA       IF #
      CPA MIN4       =4 
      CCE           SET MODE TO 1 
      LDA LOUT      SET PRINT COMMAND 
      SEZ            FOR E=0, SET 
      LDA POUT       PUNCH FOR E=1
      STA XOUT
     ISZ SAVA      SET ADDRESS OF EQT ENTRY TO
     LDA SAVA,I     WORD 2, GET WORD 2, 
     ADA M15         SET  O-FIELD = 2 ( BUSY) AND 
     STA SAVA,I       RESET.
     LDA SAVA      SET  -EQTA- =
     INA             ADDRESS OF EQT ENTRY 
      STA EQTA         WORD 3.
     ISZ SAVB      INDEX TO WORD 4
     ISZ SAVB       OF I/O REQUEST. 
      LDA SAVB
      LDA A,I     GET BUFFER ADDRESS
      RAL,CLE,SLA,ERA     IF INDIRECTION, 
      JMP *-2        GET NEXT-LEVEL ADDRESS 
     STA BUF       SAVE BUFFER ADDRESS. 
     STA BUFS 
     ISZ SAVB      SET TO WORD 6 OF REQUEST.
     LDA SAVB,I    GET WORD 6 - BUFFER LENGTH.
     SSA           IF CHARS. REQUESTED, SET 
     INB            B(LSB = 1 AND RESTORE WORD 3
     STB EQTA,I      OF EQT ENTRY.
     SSA           IF WORDS REQUESTED,
     JMP *+3        CONVERT WORDS TO
     CMA,INA         CHARACTERS AND 
     ALS              COMPLEMENT
     STA LENG      SAVE NEG. CHAR LENGTH
     STA CHX
     LDA UL52      INITIALIZE UPPER/LOWER CHAR. 
     STA ULFL        POSITION INDICATOR TO UPPER. 
     LDB RWFL      SET B = READ/WRITE FLAG. 
     LDA FFCT      READ REQUEST: SET FOR END-OF-TAPE
     SLB,RSS         COUNTER (FEED-FRAME COUNTER).
     LDA MIN4      WRITE: SET FOR 4 FEED-FRAMES TO BE 
     STA EOTC        OUTPUT AFTER BINARY RECORD.
     STA DFLG      SET DRIVER FLAG BUSY (NOT = 0).
     CLA
     STA DINF      CLEAR DATA-IN FLAG,
     STA CHC        CHARACTER COUNTER AND 
      SLB,RSS 
      JMP Y 
* 
* FOLLOWING INSTRUCTION STARTS DATA TRANSMISSION. 
X.2   LDA SAVD
      LDB DA       READ AND PRINT INSTRUCTION 
      SLA,RSS 
      LDB DB       READ ONLY INSTRUCTION
      CLA 
I.4   OTB 0        OUTPUT INSTRUCTION IN -B-
I.5   STC 0,C 
      JMP D.00,I    EXIT BACK TO IOC. 
Y     JSB I.00
      JMP D.00,I    EXIT. 
* 
RCER CLB,RSS    ---REJECT SECTION. R.C. ERROR (B=0).
REJB LDB M15       DEVICE/DRIVER NOT AVAILABLE
     CLA,INA       SET (A) NON-ZERO AND 
      JMP D.00,I    EXIT TO IOC AND REJECT. 
* 
* 
***  CONTINUATOR  SECTION  ***
* ENTERED  JSB  IN  DEVICE INTERRUPT LOCATION * 
* 
I.00  NOP 
      STA SAVAX    SAVE 
      STB SAVBX     A,
      ERA,ALS       B,
      SOC           E 
      INA           AND 
      STA SAVEX     OVERFLOW
* 
     LDA EQTA,I    PUT MODE INTO E -  =0, ASC&I,
     ELA             =1, BINARY.
     LDA RWFL      CHECK FOR READ OR WRITE
     SLA,RSS        OPERATION 
     JMP OUTP      WRITE -
* 
*  INPUT SECTION
* 
I.6   LIA 0 
     AND M377      REMOVE TRAILER BITS. 
     LDB DINF      SET (B) = DATA-IN FLAG.
     SZB,RSS        IF NO DATA IN YET AND CHARACTER 
     SZA             = ZERO, CHECK FOR EOT -
     JMP X.3       OTHERWISE, GO PROCESS CHAR.
* 
* END-OF-TAPE CHECK - CHAR=0, NO NON-ZERO CHAR. YET.
* 
     ISZ EOTC      INDEX END-OF-TAPE COUNTER
     JMP X.8        NOT ZERO, KEEP READING
     CLB           END-OF-TAPE- SET (B) = 0 FOR 
     JMP STAT       STATUS AND GO TO STATUS SECTION.
* 
* CHARACTER EXAMINATION SECTION 
* 
X.3  SEZ           IF BINARY MODE, SKIP 
     JMP X.4         CHARACTER CHECK. 
     AND M177      REMOVE 8-LEVEL BIT 
     CPA RUBO      -ASCII MODE-  CHARACTER CHECK--- 
     JMP X.10        RUBOUT (RECORD DELETE) 
     CPA RETN
* MOD - SWAP LF/CR PROCESSING
     JMP X.11         RETURN - PROCESS AS LF - 
     CPA LINF 
     JMP X.8        LINE FEED - IGNORE
* /MOD
     SSB           IF DATA-IN FLAG = -1, IGNORE CHAR- 
     JMP X.8        ACTERS UNTIL LINE-FEED INPUT. 
* 
X.4  SEZ           IF ASCII MODE, SKIP P-FORMAT CHECK 
     SZB            - IF NOT FIRST CHAR. IN BINARY
     JMP X.5          MODE, SKIP P-FORMAT CHECK.
* 
     LDB RWFL      BINARY MODE- CHECK FOR -P- FORMAT
     SSB,RSS        SELECTED (B15 OF RWFL = 1)
     JMP X.5       NO- GO TO STORE (OR SAVE) CHAR.
* 
* P-FORMAT SECTION (FIRST CHAR. CONTAINS RECORD SIZE) 
* 
     STA B         SAVE CHAR(RECORD WORD COUNT) IN B. 
     ALS           CONVERT WORDS TO CHARS.
     ADA LENG      SUBTRACT REQ. LENGTH (RESET E = 1) 
     CCE,SSA,RSS   A POSITIVE RESULT MEANS RECORD 
     JMP *+5        LENGTH GT LENGTH REQ. USE REQ.
     LDA B         LENGTH LT REQUESTED LENGTH.
     ALS           CONVERT WORD LENGTH TO NEGATIVE
     CMA,INA        CHARACTER COUNT AND SET 
     STA CHX         IN COUNTER.
     LDA B         RESTORE FIRST CHAR. TO A.
* 
* 
X.5  CLB,INB       SET DATA-IN FLAG = 1 TO SAY DATA 
     STB DINF       CHARACTER IN. 
     LDB ULFL      SET B = UPPER/LOWER POSITION FLAG. 
     SSB,RSS       IF SET FOR UPPER (15=0), SAVE CHAR 
     JMP X.6         IN EOTC. 
      IOR BUF,I     LOWER- *OR* IN PREVIOUS UPPER 
     STA BUF,I      CHARACTER AND STORE IN BUFFER.
     ISZ BUF       ADD 1 TO BUFFER ADDRESS. 
     JMP *+3
X.6  ALF,ALF       POSITION CHAR. TO UPPER AND
      STA BUF,I      SAVE 
     RBL           SET FLAG FOR NEXT POSITION 
     STB ULFL       AND SAVE FLAG.
     ISZ CHC       ADD 1 TO CHARACTE- COUNTER.
     ISZ CHX       INDEX LENGTH COUNTER.
     JMP X.8        NO ZERO (BUFFER NOT COMPLETE),
*                    SET TO INPUT NEXT CHARACTER. 
*                  BUFFER FILLED. 
     SEZ           IF BINARY MODE,  GO DIRECTLY TO
     JMP STAT        STATUS SECTION.
X.7  CCB           SET DATA-IN FLAG TO FORCE A RETURN 
     STB DINF        AND LINE-FEED TO TERMINATE ASCII 
* 
X.8   LDA SAVD
      LDB DA       READ AND PRINT INSTRUCTION 
      SLA,RSS 
      LDB DB       READ ONLY INSTRUCTION
I.13  OTB 0 
      JSB RSTR     RESTORE REGISTERS
I.14  STC 0,C 
      JMP I.00,I    EXIT INTERRUPT PROCESSING.
* 
* 
* PROCESSOR FOR -RUB-OUT- CODE
* 
X.10 LDA BUFS      -RESET STARTING
     STA BUF         BUFFER ADDRESS.
     LDA LENG      -RESET STARTING
      STA CHX        CHARACTER LENGTH 
     LDA UL52      -RESET UPPER/LOWER CHARACTER 
     STA ULFL       POSITION FLAG TO UPPER
     LDA FFCT      -RESET FEED-FRAME COUNTER FOR
     STA EOTC        END-OF-TAPE CONDITION. 
     CLA           -RESET CHARACTER COUNTER 
     STA CHC         TO ZERO. 
     JMP X.7       -GO TO SET DATA-IN FLAG = -1 
* 
* PROCESSOR FOR LINE-FEED CODE
* 
X.11 CLB           CLEAR DATA-IN FLAG FOR POSSIBLE
     STB DINF       RE-INPUT CAUSED BY RUB-OUT. 
     LDA LENG      IF ORIGINAL CHAR. INDEX =
     CPA CHX         CURRENT INDEX THEN A RUB-OUT 
     JMP X.8         WAS INPUT - INPUT NEXT RECORD, 
*             OR IGNORE LINE-FEED BEFORE RECORD.
*                   ASCII INPUT COMPLETED.
     LDB ULFL      IF LAST CHARACTER INPUT WAS IN 
      LDA BUF,I      UPPER POSITION, THEN MAKE LOWER
     IOR BLNK       CHARACTER A BLANK (SPACE) 
     SSB            AND STORE LAST WORD IN
     STA BUF,I      BUFFER. 


* MOD - OUTPUT A LF
     LDB XOUT
     LDA LINF
Q.01 OTB 0
Q.02 OTA 0
Q.03 STC 0,C
* /MOD

* 
* 
STAT LDB CHC        ==STATUS SECTION**
     LDA EQTA,I     SET A=WORD 3 EQT ENTRY, B= CHAR.
     CLE,SLA         COUNT. IF CHAR. LENGTH REQUEST-
     JMP *+3         ED, LSB = 1, SKIP CONVERSION.
     SLB,BRS        IF ODD NO. CHARS. INPUT, ADD 1
     INB             TO WORD COUNT. 
     ERA,RAL        SET LSB OF A = 0. 
     ADA B          PUT CHAR/WORD COUNT IN A AND
STAT1 STA EQTA,I      SET EQT ENTRY WORD 3. 
     CCA            SET A = -1 TO  GET
     ADA EQTA        ADDRESS OF WORD 2 OF THE 
     STA BUF        EQT ENTRY.
     LDA BUF,I     GET WORD 2, REMOVE  PREVIOUS 
     AND MST         SETTING OF STATUS AND O FIELDS,
      SZB          IF CHC NOT = 0,
      JMP *+4       LEAVE STATUS FIELD = 0. 
      LDB RWFL     IF INPUT OPERATION HAS 
      SLB           END-OF-TAPE CONDITION,
      IOR EOTS       SET BIT 5 = 1, A FIELD = 1.
     STA BUF,I      AND SET WORD 2 OF EQT ENTRY.
     CLA            CLEAR DRIVER-BUSY-FLAG TO 
     STA DFLG        SAY DRIVER AVAILABLE.
* 
      CPA SAVC     IF CLEAR REQUEST BEING PROCESSED,
      JMP D.00,I
      LDA RWFL     IF WRITE REQUEST 
      SLA,RSS       BEING PROCESSED,
      JMP WXT        EXIT TO .BUFR IN IOC.
* 
     JSB RSTR       RESTORE REGISTERS-
I.7   CLC 0        CLEAR DEVICE CONTROL-LEAVE FLAG=1
      JMP I.00,I    EXIT
* 
WXT   LDA I.00      SET INTERRUPTED SEQUENCE RETURN.
      STA EXIT+1    ADDRESS IN .BUFR CALL.
* 
      JSB RSTR     RESTORE REGISTERS. 
* 
I.8   CLC 0        CLEAR DEVICE CONTROL.
* 
EXIT  JSB .BUFR    CALL FOR BUFFERING 
      NOP          HOLDS INTERRUPT RETURN ADDRESS.
      NOP          HOLDS EQT ENTRY ADDRESS
* 
* 
RSTR NOP        -RESTORE REGISTERS ROUTINE- 
      LDA SAVEX    RESTORE
      CLO           E,
      SLA,ELA       OVERFLOW
      STF 1         A 
      LDA SAVAX     AND 
      LDB SAVBX     B 
     JMP RSTR,I     AND EXIT. 
* 
* 
*  OUTPUT SECTION 
* 
* 
OUTP  LDA BUF      OUTPUT SECTION 
     SSA            THEN EXIT TO
     JMP STAT        STATUS SECTION-OUTPUT COMPLETE.
* 
     LDB CHX       IF CHARACTER (RECORD LENGTH) 
     SSB,RSS        INDEX = ZERO, THEN GO TO
     JMP X.14       CLEAN-UP OUTPUT SECTION.
     LDA BUF,I     GET WORD FROM BUFFER CONTAINING
     LDB ULFL       NEXT CHAR.
     SSB,RSS       IF CHAR. IS IN UPPER PART OF WORD
     ALF,ALF        ROTATE TO LOWER.
     ISZ CHC        COUNT CHARACTER OUTPUT. 
X.12 AND M377      ISOLATE LOWER CHARACTER. 
     SEZ,RSS       IF ASCII MODE, 
      IOR M200      ADD 8 LEVEL BIT 
     RBL,SLB       ROTATE UPPER/LOWER MASK FOR NEXT 
     ISZ BUF        CHAR. ADD 1 TO BUFFER ADDRESS 
     STB ULFL       IF CURRENT CHAR. IS IN LOWER. 
     ISZ  CHX      INDEX CHARACTER LENGTH COUNTER.
* 
STCM OCT 4000    -NOP-, ALSO USED AS A MASK FOR STC.
* 
     SEZ           IF BINARY MODE,
      JMP X.13     GO TO OUTPUT CHARACTER.
     LDB CHX       IF CHAR. IS
     SZB            NOT LAST CHAR. IN BUFFER, 
      JMP X.13     GO TO OUTPUT CHAR. 
* 
     CPA ARROW     IF LAST CHAR. IN ASCII RECORD IS 
     JMP X.18       LEFT ARROW, EXIT W/O RETURN/LF. 
X.13  LDB XOUT
* 
I.9   OTB 0        OUTPUT INSTRUCTION IN -B-
I.10  OTA 0        SET CHARACTER IN BUFFER
      JSB RSTR
I.11  STC 0,C      OUTPUT BUFFER TO TTY.
      JMP I.00,I
* 
* 
X.14 CLA,SEZ        SKIP IF ASCII MODE
     JMP X.15        BINARY 
* 
     LDA RETN      (A) = RETURN CODE
     LDB DINF       IF DATA-IN FLAG 
     STA DINF        = 0, GO
     SZB,RSS          OUTPUT RETURN 
     JMP X.12 
     LDA LINF      RETURN OUT - SET A = LINE-FEED 
     JMP X.16        AND  GO TO SET FOR LAST CHAR.
* 
X.15 ISZ EOTC      BINARY - (A) = 0. INDEX COUNTER
     JMP X.12       FOR OUTPUT OF FOUR FEED-FRAMES. 
* 
X.16 LDB MIN4      CONTROL HERE FOR LAST CHAR.
     STB BUF        SET BUF NEGATIVE TO SIGNAL THAT 
     JMP X.12        LAST CHAR. IS  BEING OUTPUT. 
* 
X.18  LDB CHC 
      ADB CM1       SUBTRACT 1 FOR _ IN CHC,
     JMP STAT+1    GO TO STATUS. (B) = CHC. 
* 
* CONSTANT, FLAG AND STORAGE SECTION
* 
A    EQU 0
B    EQU 1
* 
SAVAX NOP          STORAGE AREA 
SAVBX NOP           FOR SAV&NG -EGISTERS
SAVEX NOP            AT INTERRUPT TIME. 
* 
SAVA  NOP          HOLDS EQT ADDRESS
SAVB  NOP          HOLDS REQUEST WORD 2 ADDRESS 
SAVC  NOP          HOLDS REQUEST CODE.
SAVD  NOP 
* 
DFLG OCT 0       DRIVER BUSY FLAG.  =0, NOT BUSY
* 
M17  OCT 17      MASKS
M77  OCT 77         USED
M177 OCT 177          IN
M377 OCT 377           PROCESSING 
M700  OCT 700 
M200  OCT 200 
M15  OCT 100000 
MST  OCT 37400
EOTS OCT 40040
LIAM OCT 300     MASKS USED 
SFSM OCT 600      IN CONSTRUCTING 
CLFM OCT 1200      I/O
CLCM  OCT 4600        INSTRUCTIONS
CFM  OCT 1000 
OTAI OCT 102600 
OTBI  OCT 100 
* 
RWFL OCT 0       READ/WRITE FLAG // P-FORMAT FLAG 
DINF OCT 0       DATA-IN FLAG 
ULFL OCT 0       UPPER/LOWER CHAR POSITION FLAG.
*                  1 = LOWER, 0 = UPPER.
* 
EQTA OCT 0     TEMPORARY
BUF  OCT 0
BUFS OCT 0       STORAGE
LENG OCT 0
CHC  OCT 0        AREA
CHX  OCT 0
EOTC OCT 0
* 
CM1  DEC -1 
CM3 DEC -3
MIN4 DEC -4 
UL52 OCT 52525
* 
RUBO EQU M177 
RETN OCT 15 
LINF OCT 12 
BLNK OCT 40 
ARROW OCT 337 
* 
XOUT  OCT 0 
LOUT  OCT 120000
POUT  OCT 110000
DA    OCT 160000
DB    OCT 140000
* 
FFCT OCT 177766    END-OF-TAPE COUNTER  (NEGATIVE)
*
* 
     END
