ASMB,A,B,L,T,N
      HED ***  SIO PARALLEL TELEPRINTER DRIVER  ***         (JRW) 
********** SYSTEM INPUT/OUTPUT DRIVER **********
* 
*  FOR THE ASR 33/35 TELETYPE (KEYBOARD/READER AND
*  PRINTER/PUNCH UNITS).
* 
*  THIS DRIVER PROVIDES FOR ALL FOUR(4) I/O FACILITIES
*  REQUIRED BY THE ASSEMBLER, SYMBOLIC EDITOR AND THE 
*  FORTRAN COMPILER.  THE FACILITIES ARE DESCRIBED AS 
*  SHOWN BELOW WITH THE LOCATION IN THE SYSTEM LINKAGE
*  TABLE AND THE NAME OF THE CORRESPONDING SECTION IN 
*  THE DRIVER:
* 
*     INPUT            101    TTY.I 
*     LIST OUTPUT      102    TTY.O 
*     PUNCH OUTPUT     103    TTY.P 
*     KEYBOARD INPUT   104    TTY.K 
* 
* CALLING SEQUENCE: 
* 
*  (A) = LENGTH OF DATA BUFFER (OR RECORD): 
*         > O, LENGTH IN CHARACTERS FOR ASCII RECORDS 
*         < 0, LENGTH IN WORDS (2-S COMPLEMENT) FOR 
*              BINARY RECORDS 
* 
*  (B) = STARTING ADDRESS OF DATA BUFFER. 
* 
* 
*  (P)     JSB  10XB,I  ( X DESIGNATES 1 TO 4 ) 
*  (P+1)  -RETURN-   (B) MEANINGLESS
* 
*     (A) ON RETURN FROM AN INPUT OPERATION CONTAINS
*     THE NUMBER OF CHARACTERS (ASCII) OR WORDS 
*     (BINARY) TRANSMITTED TO BUFFER. 
* 
*     NOTE: IF (A) = ZERO, THEN AN END-OF-TAPE
*           CONDITION RESULTED FROM THE INPUT.
*           THIS IS DEFINED AS A FIXED NUMBER OF
*           CONSECUTIVE FEED-FRAMES INPUT BEFORE
*           THE FIRST NON-ZERO DATA CHARACTER OF
*           A RECORD.  THE FIXED NUMBER IS THE
*           NEGATIVE CONSTANT AT LABEL  -FFCT- .
* 
*   (A) ON RETURN FROM AN OUTPUT OPERATION IS 
*   MEANINGLESS.
* 
* RECORD FORMATS: 
* 
*  A. INPUT - ASCII: A GROUP OF CHARACTERS
*           TERMINATED BY A RETURN/LINE FEED. 
*           THESE CODES INPUT BEFORE THE FIRST
*           DATA CHARACTER OF A RECORD ARE IGNORED. 
*           A RUB-OUT CODE CAUSES THE CURRENT RECORD
*           TO BE DELETED AND THE NEXT RECORD INPUT.
*           A LINE-FEED MUST TERMINATE THE CURRENT
*           RECORD. 
* 
*           BINARY: THE FIRST CHARACTER OF A
*           BINARY RECORD CONTAINS THE WORD COUNT OF
*           THE ENTIRE RECORD.  THIS VALUE DETERMINES 
*           THE NUMBER OF WORDS TRANSMITTED UP TO 
*           THE BUFFER LENGTH IN THE CALLING SEQUENCE.
* 
*           KEYBOARD:  ASCII FORMAT WITH EACH 
*           CHARACTER PRINTED AS IT IS TYPED. 
* 
*  B. OUTPUT - ASCII: A RETURN/LINE-FEED IS OUTPUT BY 
*           THE DRIVER TO  TERMINATE AN ASCII RECORD. 
* 
*           BINARY: THE DRIVER OUTPUTS FOUR (4) 
*           FEED-FRAMES TO TERMINATE A BINARY RECORD. 
*           THE LENGTH OF A BINARY RECORD IS THE
*           LENGTH IN "A" UPON ENTRY TO THE DRIVER. 
* 
* 
*****  DRIVER INITIALIZATION SECTION  ***** 
* 
*  PURPOSE OF THIS SECTION IS TO SET THE I/O
*  INSTRUCTIONS TO REFERENCE A DESIGNATED 
*  I/O ADDRESS FOR THE PRINTER/PUNCH AND THE
*  READER UNIT.  EXECUTION OF THIS SECTION
*  IS BEGUN AT  LOCATION  2:  (2) = JMP 3,I.
*  (3) = DEF I.TTY .  THE SWITCH REGISTER 
*  IS SET TO CONTAIN THE ADDRESS OF THE UNIT. 
* 
*  BIT 15 OF SW IS CLEAR FOR ASR 33 UNITS.
*  BIT 15 OF SW IS SET FOR ASR 35 UNITS 
* 
*     WHEN ASR33 UNIT IS USED, LOCATIONS 102B AND 
*     103B CONTAIN THE SAME ENTRY POINT ADDRESS.
* 
*  THIS SECTION IS RELEASED AFTER THE 
*  INITIALIZATION IS COMPLETED. 
* 
* 
      ORG 00002B
      JMP *+1,I      SET STARTING POINT 
      DEF I.TTY     IN 2 AND 3. 
      SPC 2 
      IFN 
KCORE EQU 30000B
      XIF 
      IFZ 
KCORE EQU 70000B
      XIF 
      SKP 
      ORG KCORE+06000B
I.TTY LIA 01B       GET AND 
      STA TTY.K     SAVE THE SWITCH REGISTER. 
      AND M.77      ISOLATE I/O ADDRESS 
      STA B        SET IN B 
      LDA TT.32    STC TTY,C
      AND .1777 
      IOR B 
      STA TT.32 
      LDA TT.33    SFS TTY
      AND .1777 
      IOR B        OUTPUT 
      STA TT.33 
      LDA TOUT3 
      AND .1777 
      IOR B 
      STA TOUT3 
      STA TT.31 
      LDA TT.34    LIA TTY
      AND .1777 
      IOR B 
      STA TT.34 
      LDA TTY.K     LOAD THE SWITCH OPTION. 
      SSA 
      JMP A35 
      LDA 102B
      STA 103B
      LDA JMP 
      STA TTY.O+3 
      LDB A33 
TRANS LDA B,I 
      STA INDEX,I 
      ISZ INDEX 
      INB 
      CPB ENDT
      JMP FIN 
      JMP TRANS 
A35   LDA ASR35    ASR 35 
      LDB ASR33 
      STA POUT
      STB LOUT
FIN   LDA *+3       LOAD: A= HLT 77B
      STA 00002B    THE CONFIGURATOR IS NOT RESTARTABLE.
      LDB TTY.K     LOAD: B= SWITCH OPTIONS.
      HLT 77B      (B) = I/O ADDR.
      JMP *-1 
      SPC 2 
ASR33 OCT 120000   PUNCH AND PRINT
ASR35 OCT 110000   PUNCH ONLY COMMAND 
M.77  OCT 77       I/O ADDR MASK
.1777 OCT 177700
      SKP 
JMP   JMP TTY.P+1 
      SPC 1 
INDEX DEF TTY.P+1 
A33   DEF *+1 
      STB TTY.P 
      CCB,CCE 
      ADB TTY.O 
      LDB B,I 
      SLB 
      JMP TOUTX 
      JMP TTY.O+4 
ENDT  DEF * 
      SKP 
      ORG KCORE+07405B
      SPC 1 
TTY.K NOP         ** KEYBOARD INPUT ENTRY **
      STB BUFF     SET BUFFER 
      STB BUFS      ADDRESS 
      LDB TTY.K    TAKE ENTRY POINT ADDRESS AND 
      STB TTY.I    STORE IN EXIT POINT
      LDB LCNT      LOAD: B= -61. 
      STB COUNT     RESET THE LINE COUNTER. 
      LDB DA.      SET INSTRUCTION IN INPUT SECTION 
      JMP TT.1
      SPC 2 
TTY.I NOP         **  INPUT  ENTRY  **
      STB BUFF     SET BUFFER 
      STB BUFS      ADDRESS 
      LDB DB.      SET INSTRUCTION TO INPUT ONLY. 
TT.1  STB TTY.P     TO PROVIDE CHARACTER PRINTING.
      CCE,SSA      SET E=1 FOR ASCII MODE, SKIP IF
      ALS,CLE,SLA  ASCII. SET E=0, BINARY,CONVERT TO
      CMA,INA       CHARS. SET CHAR COUNT NEGATIVE. 
      CLB          SET B (DATA-IN FLAG) =0, NO DATA 
      STA LENG     SET REQUESTED LENGTH (CHARS) 
TT.2  STA CHC1      AS COUNTER. 
      LDA UL52     INITIALIZE UPPER/LOWER CHAR. POS.
      STA ULFL      INDICATOR TO UPPER. 
      LDA FFCT     INITIALIZE END-OF-TAPE 
      STA EOTC      COUNTER.
      CLA          SET CHAR. INPUT COUNTER
      STA CHC2      TO ZERO.
      SPC 1 
* CHARACTER INPUT SECTION 
      SPC 1 
TT.3  JSB I.O       OUT COMMAND,SET CONTROL,CLR FLG.
      ELA,CLE,SLA,ERA REMOVE STATUS BIT; BINARY?
      AND M177     REMOVE TRAILER BITS IF ASCII.
      SZB,RSS      IF NO DATA YET AND CHAR = 0, 
      SZA           CHECK FOR END-OF-TAPE.
      JMP TT.6     OTHERWISE PROCESS CHAR.
      ISZ EOTC     INDEX END-OF-TAPE COUNTER
      JMP TT.3      NO -
      JMP TT.13    END-OF-TAPE - GO TO EXIT SECTION.
      SPC 1 
* BINARY RECORD LENGTH SECTION
      SPC 1 
TT.6  SEZ          IF ASCII MODE, GO TO 
      JMP TT.7      EXAMINE CHAR. 
      SZB          IF NOT FIRST CHAR. OF BINARY 
      JMP TT.8      RECORD, GO TO PACK CHARACTER. 
      STA B         CONVERT RECORD WORD 
      BLS            LENGTH TO CHARS. 
      ADB LENG      SUBTRACT ORIG. BUFFER LENGTH. 
      CLE,SSB,RSS   IF RECORD LENGTH GREATER, 
      JMP TT.8       USE ORIG. BUFFER LENGTH. 
      STA B         CONVERT TO CHARS AGAIN
      BLS            AND SET NEGATIVE 
      CMB,INB        FOR CHARACTER
      STB CHC1        INDEX.
      JMP TT.8      GO TO CHAR. PACKING SECTION.
      SPC 1 
* CHARACTER EXAMINATION SECTION - ASCII 
      SPC 1 
TT.7  CPA RETN.    IF CHAR. IS RETURN CODE, IGNORE
      JMP TT.3X     IT. GET NEXT CHAR.
      CPA M177     IF CHAR. IS RUB-OUT, GO
      JMP TT.11     TO RESET INPUT FOR NEXT RECORD. 
      CPA LINF.    IF CHAR. IS LINE-FEED, GO TO 
      JMP TT.12     TERMINATION SECTION.
      SSB          IF DATA-IN FLAG = -1 (LINE-FEED
      JMP TT.3X     REQUIRED), INPUT NEXT CHAR. 
TT.8  CLB,INB      SET DATA-IN FLAG = 1 TO SAY
      STB I.O       RECORD BEING TRANSMITTED. 
      SPC 1 
* DATA PACKING AND STORING SECTION
      SPC 1 
      LDB ULFL    (B) = CHAR. POSITION INDICATOR. 
      SSB,RSS 
      JMP TT.9     UPPER. 
      IOR CHAR     LOWER- PACK PREVIOUS UPPER CHAR
      STA BUFF,I    AND STORE PACKED WORD 
      ISZ BUFF     ADD 1 TO BUFFER ADDRESS. 
      JMP TT.10 
TT.9  ALF,ALF      ROTATE TO UPPER AND
      STA CHAR      SAVE. 
TT.10 RBL          SET INDICATOR FOR NEXT POSITION
      STB ULFL      AND SAVE FLAG.
      LDB I.O      RESTORE DATA-IN FLAG.
      ISZ CHC2     COUNT CHAR. INPUT
      ISZ CHC1     INDEX CHAR. LENGTH 
      JMP TT.3X     BUFFER NOT FILLED.
      CCB,SEZ,RSS   BUFFER FILLED - IF BINARY 
      JMP TT.13     MODE, GO TO EXIT SECTION. 
TT.3X CLA           ENTER: A=0. 
      JMP TT.3      TO FORCE A LINE-FEED IN.
      SPC 1 
* SECTION TO PROCESS RUBOUT CODE (ASCII  MODE)
      SPC 1 
TT.11 LDA BUFS     RESET STARTING BUFFER
      STA BUFF      ADDRESS.
      LDA LENG     (A) = ORIGINAL BUFFER LENGTH.
      CCB          SET DATA-IN FLAG = -1, TO FORCE
      JMP TT.2     A LF TO TERMINATE RECORD.
      SPC 1 
* SECTION TO PROCESS LINE-FEED CODE (ASCII MODE)
      SPC 1 
TT.12 CLB       SET B=0 FOR RE-INPUT FROM RUB-OUT.
      LDA LENG     IF NO CHARS. INPUT OR RUB-OUT
      CPA CHC1      RECORD TERMINATED, READ 
      JMP TT.3X      NEXT CHARACTER.
      SKP 
*               CHECK CURRENT POSITION INDICATOR. 
      SPC 1 
      LDB ULFL     IF LAST CHAR.
      LDA CHAR      INPUT WAS IN UPPER POSITION,
      IOR BLANK     MAKE LOWER CHAR. A
      SSB            BLANK AND STORE
      STA BUFF,I      LAST WORD.
      SPC 1 
* EXIT (COMPLETION) SECTION 
      SPC 1 
TT.13 LDA CHC2     SET A = CHARACTER COUNT. 
      SEZ,RSS      IF BINARY RECORD INPUT,
      ARS           CONVERT TO WORDS
      JMP TTY.I,I  EXIT THROUGH INPUT ENTRY.
      SPC 2 
I.O   NOP 
      IOR TTY.P     INCLUDE THE COMMAND CODE. 
TT.31 OTA TTY       OUTPUT THE COMMAND CODE.
TOUT3 OTA TTY 
TT.32 STC TTY,C     SET CONTROLAND CLEAR FLAG 
TT.33 SFS TTY       WAIT UNTIL READY
      JMP TT.33 
TT.34 LIA TTY,C     INPUT THE CHARACTER.
      JMP I.O,I     RETURN
      SPC 2 
RETN. OCT 000015
      SKP 
* LIST AND PUNCH OUTPUT SECTION 
      SPC 1 
      ORG KCORE+07557B
TTY.P NOP          ** OUTPUT PUNCH ENTRY ** 
      STB BUFF     SAVE STARTING ADDRESS OF BUFFER
      LDB TTY.P    LOAD ENTRY POINT AND STORE 
      STB TTY.O    IN EXIT POINT
      LDB POUT     GET PUNCH CODE 
      STB TTY.P    SET IN OUTPUT ROUTINE
      JMP TOUTX 
      SPC 1 
POUT  OCT 120000
      SPC 2 
TTY.O NOP          ** OUTPUT LIST ENTRY **
      STB BUFF      SAVE STARTING ADDRESS OF BUFFER.
      LDB LOUT     GET LIST CODE
      STB TTY.P     SET IN OUTPUT ROUTINE 
      ISZ COUNT     INCREMENT LINE COUNT, SKIP >60
      CCE,SSA       SET E, CHECK A FOR PAGE SKIP
      JMP PAGE      SKIP TO NEXT PAGE 
TOUTX STA B 
TOUT1 CCE,SSB 
      BLS,CLE,SLB   -BINARY, SET E=0, CONVERT TO
*                             CHARS., FORCE A SKIP
      CMB,INB,SZB   SET CHAR. COUNT NEGATIVE
      RSS           IF ZERO(0) CHARACTER LENGTH,
      JMP TT.15      GO OUTPUT A LINE-FEED. 
      STB CHC1      SET CHAR. INDEX 
      LDB UL52     (B) = UPPER/LOWER INDICATOR
      SPC 1 
* CHARACTER OUTPUT SECTION
      SPC 1 
TT.14 LDA BUFF,I   GET WORD CONTAINING CHARACTER
      SSB,RSS      IF UPPER/LOWER FLAG SAYS UPPER,
      ALF,ALF       SIGN = 0, ROTATE TO LOWER.
      AND M377     ISOLATE CHARACTER. 
      SEZ           ASCII MODE? 
      IOR M1400     YES, INCLUDE LEVEL 8 BIT. 
      JSB I.O       GO OUTPUT THE CHARACTER.
      RBL,SLB      IF CHAR. OUTPUT WAS LOWER CHAR., 
      ISZ BUFF      ADD 1 TO BUFFER ADDRESS.
      ISZ CHC1     INDEX CHARACTER COUNTER
      JMP TT.14     MORE TO PROCESS.
      SPC 1 
* OUTPUT COMPLETION SECTION 
      SPC 1 
TT.15 CCB,SEZ,RSS   ENTER: B=-1; BINARY MODE? 
      LDB CM.4      YES, LOAD: B=-4.
      STB EOTC      STORE THE CHARACTER COUNT.
      CLA,SEZ,RSS  IF BINARY MODE, GO TO OUTPUT 
      JMP TT.16     4 FEED-FRAMES.
      LDA RETN     OUTPUT 
      JSB I.O       RETURN (ASCII MODE).
      JMP TT.25     GO ISSUE A LINE-FEED CHARACTER. 
      SPC 2 
M1400 OCT 000200    MASK FOR ADDING TRAILER BITS. 
CM.4  DEC -4        FEED-FRAME OUTPUT COUNTER.
      SPC 2 
PAGE  STA B         SAVE A REGISTER 
      LDA LSKIP     LOAD PAGE SPACING COUNT 
      ADA COUNT     ADD REMAINING LINES 
      STA EOTC      SAVE TOTAL LINES TO SKIP
      LDA LCNT      LOAD PAGE LINE COUNT
      STA COUNT     RESTORE LINE COUNT
      CCE,RSS       ENTER: E=1; SKIP. 
TTOUT CLA,SEZ       ENTER: A=0; BINARY MODE?
TT.25 LDA LINF      LOAD LINE FEED CHARACTER
TT.16 JSB I.O       OUTPUT LINE FEED
      ISZ EOTC      INCREMENT LINEFEEDS OUTPUT
      JMP TTOUT      REPEAT 
      SSB           THROUGH - SEE IF (A) WZ 
      JMP TTY.O,I   YES - RETURN
      ISZ COUNT     CORRECT THE LINE COUNT. 
      JMP TOUT1     GO PRINT THE LINE.
      SPC 2 
* CONSTANT, STORAGE AND FLAG SECTION
      SPC 1 
      ORG KCORE+07654B
BUFF  OCT 0        HOLDS CURRENT BUFFER ADDRESS 
BUFS  OCT 000000   HOLDS STARTING BUFFER ADDRESS
LENG  EQU TTY.K    HOLDS ORIGINAL BUFFER LENGTH 
CHC1  OCT 0        INDEX VALUE FOR CHARACTERS 
CHC2  OCT 0        HOLDS COUNT OF CHARACTERS INPUT
M377  OCT 377      MASK FOR 8-BIT CHARACTER 
LOUT  OCT 130000
DA.   OCT 160000   INSTRUCTION TO PRINT 
DB.   OCT 140000   INSTRUCTION TO INPUT ONLY. 
*                             UPPER/LOWER CHARACTER 
UL52  OCT 52525    POSITION INDICATOR:0=UPPER,1=LOWR
ULFL  OCT 0        POSITION INDICATOR FLAG
EOTC  OCT 0        INDEX WORD FOR END-OF-TAPE 
CHAR  EQU EOTC     HOLDS UPPER CHAR. FOR PACKING
BLANK CLE          ASCII  SPACE  (BLANK)
RETN  OCT 000215   ASCII  RETURN CODE 
LINF  OCT 000212   ASCII  LINE FEED CODE
M177  OCT 000177
B     EQU 00001B
COUNT DEC -61 
LCNT  DEC -61 
LSKIP DEC -6
LINF. OCT 000012    LINE-FEED CODE. 
      SPC 2 
* FOLLOWING IS NEGATIVE CONSTANT FOR FEED-FRAME COUNT 
      SPC 1 
FFCT  DEC -10      * END OF TAPE COUNTER *
      SPC 1 
TTY   EQU 15B 
      SKP 
* SYSTEM LINKAGE TABLE SET-UP SECTION 
      SPC 1 
      ORG 00101B
      DEF TTY.I     * INPUT * 
      DEF TTY.O     * LIST OUTPUT * 
      DEF TTY.P     * PUNCH OUTPUT *
      DEF TTY.K     * KEYBOARD INPUT *
      SPC 2 
      ORG 00106B
      DEF TTY.K-1   L.W.A. OF AVAILABLE MEMORY. 
*     OCT 000000
      SPC 2 
      ORG 00004B
      HLT 04B,C     SET HALT IN POWER FAIL CELL.
      HLT 05B    SET HALT IN POWER FAIL CELL !!!!!! 
      SPC 1 
      END 
